2018-02-28 16:23:07 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ffd8a29)

    Released v2.3.0.1.


M	NEWS
M	configure.ac

2018-02-26 12:53:19 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (ee0c09c)

    lib-master: Fix dns_match_wildcard result value check

    It returns 0, not TRUE.

M	src/lib-master/master-service-settings-cache.c

2018-02-23 15:31:11 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (5666456)

    lib-master: Check local_name only if both filter and input have it

    Broken in cedc777a1acf830af4cf0b6e9b0f343c81e20adc

M	src/lib-master/master-service-settings-cache.c

2018-02-19 14:19:08 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (cd6517b)

    lib-dns: Move before lib-master


M	src/Makefile.am

2017-11-30 20:52:11 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (8960d1c)

    login-common: Enable config filtering by local name

    Prevents servername misuse.

M	src/login-common/login-settings.c

2017-11-30 15:47:25 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (3be6c1a)

    lib-master: Support validating config filters against requests

    Validation will sanitize the input request and drop any fields that have no
    filter in config. E.g. if you have a local block with name, and nothing
    else, then lip/rip will be dropped from the request.

M	src/lib-master/Makefile.am
M	src/lib-master/master-service-settings-cache.c
M	src/lib-master/master-service-settings-cache.h
M	src/lib-master/master-service-settings.c
M	src/lib-master/master-service-settings.h
M	src/lib-master/test-master-service-settings-cache.c

2017-11-30 15:46:52 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (d89bdb7)

    config: Add command to request all filters


M	src/config/config-connection.c

2017-11-30 15:46:40 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (014ac02)

    config: Add config_filter_get_all

    Returns all filters

M	src/config/config-filter.c
M	src/config/config-filter.h

2018-01-11 13:38:14 -0500 Timo Sirainen <timo.sirainen@dovecot.fi> (811daa0)

    *-login: Fix clients linked list corruption with SSL connections

    This could have resulted in infinite loops or some of the clients being 
    skipped for some operations.

M	src/login-common/client-common.c

2017-12-22 18:58:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9bc65e8)

    global: Call rfc822_parser_deinit() wherever possible


M	src/lib-mail/istream-attachment-extractor.c
M	src/lib-mail/message-address.c
M	src/lib-mail/message-date.c
M	src/lib-mail/message-decoder.c
M	src/lib-mail/message-id.c
M	src/lib-mail/message-parser.c
M	src/lib-mail/message-part-data.c
M	src/lib-mail/message-search.c
M	src/lib-mail/test-rfc2231-parser.c
M	src/lib-mail/test-rfc822-parser.c
M	src/plugins/fts/fts-build-mail.c
M	src/plugins/fts/fts-parser-script.c

2018-01-09 11:33:59 -0500 Timo Sirainen <timo.sirainen@dovecot.fi> (aa2c38f)

    lib-mail: Refactor code to make the next commit smaller


M	src/lib-mail/message-address.c
M	src/lib-mail/message-id.c
M	src/lib-mail/message-parser.c

2017-12-22 18:56:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5f1a823)

    lib-mail: Add rfc822_parser_deinit()

    It's not a strict requirement to call this, but it assert-crashes if the 
    state isn't valid.

M	src/lib-mail/rfc822-parser.h

2017-12-22 18:42:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a4e981c)

    lib-mail: Make sure parsers don't accidentally go much beyond end pointer


M	src/lib-mail/message-address.c
M	src/lib-mail/message-date.c
M	src/lib-mail/message-part-data.c
M	src/lib-mail/rfc2231-parser.c
M	src/lib-mail/rfc822-parser.c

2017-12-22 18:36:55 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (35eb25c)

    lib-mail: Fix out-of-bounds read when parsing an invalid email address

    The included unit test doesn't fail, but running it with valgrind shows
    "Invalid read of size 1" error.

    Broken in d6737a17a27402e7a262f7ba8a2ed588d576f23c

    Discovered by Aleksandar Nikolic of Cisco Talos

M	src/lib-mail/message-address.c
M	src/lib-mail/test-message-address.c

2017-12-22 18:36:09 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ccde1a8)

    lib-mail: test-message-address - Add TEST_MESSAGE_ADDRESS_FLAG_SKIP_LIST
    flag

    This commit just adds the flag and sets it to 0 for all existing tests.

M	src/lib-mail/test-message-address.c

2017-12-22 18:31:52 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3213a02)

    lib-mail: rfc822-parser - Add asserts to make sure parser state is correct


M	src/lib-mail/rfc822-parser.c

2018-01-26 10:55:54 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (b20c2a5)

    lib-auth: Remove request after abort

    Otherwise the request will still stay in hash table and get dereferenced
    when all requests are aborted causing an attempt to access free'd memory.

    Found by Apollon Oikonomopoulos <apoikos@debian.org>

    Broken in 1a29ed2f96da1be22fa5a4d96c7583aa81b8b060

M	src/lib-auth/auth-client-request.c
M	src/lib-auth/auth-server-connection.c
M	src/lib-auth/auth-server-connection.h

2017-12-18 16:50:51 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b569776)

    lib-auth: Fix memory leak in auth_client_request_abort()

    This caused memory leaks when authentication was aborted. For example with
    IMAP:

    a AUTHENTICATE PLAIN
    *

    Broken by 9137c55411aa39d41c1e705ddc34d5bd26c65021

M	src/lib-auth/auth-client-request.c

2017-12-22 15:35:03 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c8b89eb)

    Released v2.3.0.


M	NEWS
M	configure.ac

2017-12-22 15:12:30 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (dfc19b4)

    doveadm dump: Add "multiplex" dump type

    This allows dumping all channels from istream-multiplex stream.

M	src/doveadm/doveadm-dump.c

2017-12-22 15:11:45 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (70b1a35)

    doveadm dump: Allow doveadm_cmd_dump.test() to be NULL

    This means that there's no auto-detection for the dump type.

M	src/doveadm/doveadm-dump.c

2017-12-22 15:10:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (56c43d3)

    lib: istream-multiplex - Return error if the last packet wasn't fully read


M	src/lib/istream-multiplex.c

2017-12-22 15:07:28 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (93fd68a)

    doveadm: Fix potential crash or reading garbage from doveadm-server

    The connection's input buffer may have been reallocated or otherwise moved 
    while checking for log input.

M	src/doveadm/server-connection.c

2017-12-22 13:36:32 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c0dd00d)

    doveadm: Don't connect to stats-writer for the "quick init" commands


M	src/doveadm/doveadm.c

2017-12-22 13:20:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e71a080)

    lib-master: Add master_service_init_stats_client()

    This allows initializing the stats client after master_service_init() if 
    necessary.

M	src/lib-master/master-service-settings.c
M	src/lib-master/master-service.c
M	src/lib-master/master-service.h

2017-12-22 13:27:48 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (818b09e)

    lib-master: Hide connect(stats-writer) errors when running via CLI

    Only hide errors that occur if the stats process isn't running, i.e. when 
    socket isn't found or there's no listener. This way e.g. permission errors 
    are still logged, which points to a wrong configuration.

M	src/lib-master/master-service-settings.c
M	src/lib-master/stats-client.c
M	src/lib-master/stats-client.h

2017-12-22 13:34:45 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (96dd47c)

    auth: Fix password and scheme handling in Lua db

    This was only partially fixed in c86575ac9776d0995355d03719c82e7ceac802e6

M	src/auth/db-lua.c
M	src/auth/passdb-lua.c

2017-12-22 09:42:50 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c471ce9)

    imap-old-stats plugin: Finish renaming the plugin

    The init functions and dependency were named wrong, so it didn't work.

M	src/plugins/imap-old-stats/imap-stats-plugin.c
M	src/plugins/imap-old-stats/imap-stats-plugin.h

2017-12-22 09:37:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (cb2feda)

    m4: Fix detecting libsodium to use LIBS instead of LDFLAGS

    Patch by Eray Aslan

M	m4/want_sodium.m4

2017-12-22 09:36:48 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (21a6bcd)

    m4: Avoid _FORTIFY_SOURCE redefinition warnings

    Some source based distros like Gentoo already enable -D_FORTIFY_SOURCE=2 by
    default resulting in the following warnings during build:

    <command-line>:0:0: warning: "_FORTIFY_SOURCE" redefined
    <built-in>: note: this is the location of the previous definition

    Patch by Eray Aslan

M	m4/cc_fortify.m4

2017-12-22 09:59:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a8369d9)

    example-config: Fix postmaster_address comment

    The default value was wrong.

M	doc/example-config/conf.d/15-lda.conf

2017-12-22 11:25:06 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6bc16cf)

    doveadm-server: Fix potential hangs with SSL connections


M	src/doveadm/client-connection-tcp.c

2017-12-18 21:58:16 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (71965c1)

    auth: Don't include LIBSODIUM_LIBS in dependencies

    Put it into AUTH_LIBS among other libraries that are used by auth.

M	m4/want_sodium.m4
M	src/auth/Makefile.am

2017-12-21 23:09:13 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (7adffef)

    lib-smtp: server: STARTTLS command: Call
    smtp_server_connection_set_ssl_streams() after calling the conn_start_tls()
    connection callback.

    This is called instead smtp_server_connection_set_streams(), so that the
    connection is now marked as SSL-secured. This fixes a submission-login bug
    that prevented client login when ssl=required.

M	src/lib-smtp/smtp-server-cmd-starttls.c

2017-12-21 23:07:10 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (d076bd9)

    lib-smtp: server: Add smtp_server_connection_set_ssl_streams().

    It wraps smtp_server_connection_set_streams() and additionally marks the
    connection as SSL-secured.

M	src/lib-smtp/smtp-server-connection.c
M	src/lib-smtp/smtp-server.h

2017-12-21 23:00:18 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b1de005)

    lib-smtp: server: Change conn_start_tls() connection callback to return a
    success status.


M	src/lib-smtp/smtp-server-cmd-starttls.c
M	src/lib-smtp/smtp-server.h
M	src/submission-login/client.c

2017-12-19 00:29:03 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d0d92f4)

    man: Update version number to v2.3


M	doc/man/doveadm-acl.1.in
M	doc/man/doveadm-altmove.1.in
M	doc/man/doveadm-auth.1.in
M	doc/man/doveadm-batch.1.in
M	doc/man/doveadm-deduplicate.1.in
M	doc/man/doveadm-director.1.in
M	doc/man/doveadm-dump.1.in
M	doc/man/doveadm-exec.1.in
M	doc/man/doveadm-expunge.1.in
M	doc/man/doveadm-fetch.1.in
M	doc/man/doveadm-flags.1.in
M	doc/man/doveadm-force-resync.1.in
M	doc/man/doveadm-fs.1.in
M	doc/man/doveadm-fts.1.in
M	doc/man/doveadm-help.1.in
M	doc/man/doveadm-import.1.in
M	doc/man/doveadm-index.1.in
M	doc/man/doveadm-instance.1.in
M	doc/man/doveadm-kick.1.in
M	doc/man/doveadm-log.1.in
M	doc/man/doveadm-mailbox-cryptokey.1.in
M	doc/man/doveadm-mailbox.1.in
M	doc/man/doveadm-move.1.in
M	doc/man/doveadm-penalty.1.in
M	doc/man/doveadm-proxy.1.in
M	doc/man/doveadm-purge.1.in
M	doc/man/doveadm-pw.1.in
M	doc/man/doveadm-quota.1.in
M	doc/man/doveadm-replicator.1.in
M	doc/man/doveadm-save.1.in
M	doc/man/doveadm-search-query.7
M	doc/man/doveadm-search.1.in
M	doc/man/doveadm-stats.1.in
M	doc/man/doveadm-sync.1.in
M	doc/man/doveadm-user.1.in
M	doc/man/doveadm-who.1.in
M	doc/man/doveadm.1.in
M	doc/man/doveconf.1.in
M	doc/man/dovecot-lda.1.in
M	doc/man/dovecot.1.in

2017-12-18 16:45:23 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (3f3d3c6)

    lib-smtp: server: Fixed assertion in smtp_server_connection_next_reply()
    checking whether command is fully replied.

    It did not handle LMTP DATA/BDAT command correctly, for which there can be
    multiple replies.

    This fixes mixing local/remote recipients in LMTP, which used to crash: 
    Panic: file smtp-server-connection.c: line 610
    (smtp_server_connection_next_reply): assertion failed: (cmd->state ==
    SMTP_SERVER_COMMAND_STATE_READY_TO_REPLY &&
    smtp_server_command_is_replied(cmd))

M	src/lib-smtp/smtp-server-connection.c

2017-12-18 19:28:10 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (de37420)

    lib-smtp: server: Fix compile error in smtp-server-cmd-helo.c.

    Error was:
    "smtp-server-cmd-helo.c", line 140: void function cannot return value

M	src/lib-smtp/smtp-server-cmd-helo.c

2017-12-16 16:52:19 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (12aba59)

    Released v2.3.0.rc1.


M	NEWS
M	configure.ac

2017-12-18 15:20:07 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (97fad7a)

    lib-smtp: command parser: Fix error recovery.

    Input characters were not skipped upon error, meaning that error recovery
    would encounter these again. This would make the parser parse the same data
    over and over again, yielding the same error. This in turn caused the SMTP
    server application to hang in an infinite input loop, submitting error
    replies in the process, thereby filling up the process memory until
    exhaustion. Problem seen in submission service, but LMTP is also affected.

M	src/lib-smtp/smtp-command-parser.c

2017-12-18 14:08:16 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a72c750)

    lib-smtp: server: Fix panic when disconnecting client aborting commands

    This happened at least if the relay server simply disconnected without 
    sending any output.

    Fixes: Panic: file submission-commands.c: line 39: unreached

M	src/submission/submission-commands.c

2017-12-18 14:04:48 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (aa70583)

    lib-smtp: smtp_server_connection_pending_command_data() - don't crash if
    smtp_parser is NULL


M	src/lib-smtp/smtp-server-connection.c

2017-12-18 13:16:09 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b1e79ed)

    doc: example-config: Properly document SSL configuration for submission
    relay server.


M	doc/example-config/conf.d/20-submission.conf

2017-12-18 12:08:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c9d1ad7)

    submission: Fix memory leaks at deinit when submission_relay_host setting is
    missing


M	src/submission/main.c

2017-12-18 12:06:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f8d6f8d)

    lib-smtp: server: Fix panic when io_remove() is called too late

    With submission-login the conn_disconnect() callback ends up in 
    login-common's client_disconnect(), which closes the file descriptor. The
    io_remove() was done afterwards, which caused a crash:

    submission-login: Panic: epoll_ctl(del, 18) failed: Bad file descriptor

M	src/lib-smtp/smtp-server-connection.c

2017-12-18 12:05:59 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2814b47)

    lib-smtp: server: Fix infinite loop when client disconnects in initial state


M	src/lib-smtp/smtp-command-parser.c
M	src/lib-smtp/smtp-command-parser.h
M	src/lib-smtp/test-smtp-command-parser.c

2017-12-18 12:48:07 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9b375f5)

    old-stats plugin: Rename stats_* settings to old_stats_*


M	src/plugins/old-stats/stats-plugin.c

2017-12-18 12:47:47 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (de6d216)

    auth: Install stats plugin to old-stats/

    Fixes using auth_stats=yes

M	src/auth/Makefile.am

2017-12-17 20:41:52 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (52e8bf3)

    lib: Fix using appended log prefixes for events when full prefix isn't
    replaced


M	src/lib/event-log.c

2017-12-17 20:39:39 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1a5b037)

    lib: Fix using failure_context.log_prefix with internal log process
    communication


M	src/lib/failures.c

2017-12-17 20:38:38 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (bf88269)

    log: Add "disable log prefix" flag to log lines


M	src/lib/failures.c
M	src/lib/failures.h
M	src/log/log-connection.c

2017-12-17 20:35:58 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c2c58ed)

    lib: Add event_send()


M	src/lib/lib-event-private.h
M	src/lib/lib-event.c

2017-12-17 20:35:42 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (642f2bb)

    lib: Rename event_send() to event_vsend()


M	src/lib/event-log.c
M	src/lib/lib-event-private.h
M	src/lib/lib-event.c

2017-12-15 23:28:58 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (4e29b62)

    lmtp: local: Properly handle a user being over quota.

    Recent changes caused quota enforcement to be ineffective.

M	src/lmtp/lmtp-local.c

2017-12-15 21:31:44 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (8d7c247)

    lmtp: local: Make sure pending recipient is always destroyed.

    Before, the recipient was not freed when the server/connection ended
    prematurely.

M	src/lmtp/lmtp-local.c

2017-12-14 23:00:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c9f90d9)

    login-proxy: Add back support for ssl_client_cert/key

    Forgot to add these while rewriting login-proxy to use lib-ssl-iostream.

M	src/login-common/login-proxy.c

2017-12-14 22:59:30 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (024ca27)

    lib-ssl-iostream: If allow_invalid_cert=TRUE, skip verifying hostname


M	src/lib-ssl-iostream/iostream-openssl.c

2017-12-15 14:42:54 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (552d37c)

    lib-master: Fix master_service_ssl_settings_to_iostream_set() for client
    settings

    ssl_verify_client_cert setting applies only to server side. For client side 
    we always verify the SSL certificate validity.

M	src/lib-master/master-service-ssl-settings.c

2017-12-15 14:11:37 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (88dac1a)

    lib-http: Add http_client_init_private()

    This allows creating a HTTP client without a shared context, in case it's 
    needed for some reason.

M	src/lib-http/http-client.c
M	src/lib-http/http-client.h

2017-12-15 14:10:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (00ef907)

    lib-http: Change http_client_init() to use the global shared client context

    This is most likely what is usually wanted.

M	src/lib-http/http-client.c
M	src/lib-http/http-client.h

2017-12-15 14:08:20 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a9f3703)

    lib-http: Add http_client_get_global_context()


M	src/lib-http/http-client.c
M	src/lib-http/http-client.h

2017-12-14 21:49:08 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (993b1b9)

    fts: Code cleanup


M	src/plugins/fts/fts-build-mail.c

2017-12-14 21:42:45 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3813ebc)

    fts: Don't try to retry parsing if indexing already fails


M	src/plugins/fts/fts-build-mail.c

2017-12-14 21:39:08 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d7c139d)

    fts: Use consistent naming for retriable_err_msg

    It's only for retriable errors, not errors in general

M	src/plugins/fts/fts-build-mail.c

2017-12-14 21:34:31 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d8ebe88)

    fts: Make sure may_need_retry is reset between attempts.

    It wasn't if the second attempt failed early.

M	src/plugins/fts/fts-build-mail.c

2017-12-14 21:26:28 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f4c18fa)

    fts: Add assert to make sure fts_parser.deinit() returns retriable_error_msg
    when needed


M	src/plugins/fts/fts-parser.c

2017-12-14 21:25:54 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (fc2b89b)

    fts: fts-parser-tika - Add assert to make sure retriable_error_msg is set


M	src/plugins/fts/fts-parser-tika.c

2017-12-14 21:25:14 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (cbe118d)

    fts: fts-parser-script - Fix deinit return value


M	src/plugins/fts/fts-parser-script.c

2017-12-14 21:23:30 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (07bfc94)

    fts: fts-parser-html - Fix deinit return value


M	src/plugins/fts/fts-parser-html.c

2017-12-14 21:53:14 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (76f2553)

    fts: fts_parser_deinit() - Fix default return value


M	src/plugins/fts/fts-parser.c

2017-12-14 21:24:10 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8c93c82)

    fts: Add comment to fts_parser_deinit() describing its API


M	src/plugins/fts/fts-parser.h

2017-12-14 10:31:26 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ec61c40)

    lib: Fix static analyzer warning about uninitialized va_list


M	src/lib/lib-event.c

2017-12-14 12:01:33 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3b4d146)

    lib-storage: Delay error handing for invalid postmaster_address setting


M	src/lib-lda/mail-send.c
M	src/lib-storage/mail-storage-settings.c
M	src/lib-storage/mail-storage-settings.h

2017-12-14 20:56:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (117ae14)

    cassandra: Fix crash when using prepared statements

    Broken by cae3c6903c10682429f9849ab1a25093e3f538e4

M	src/lib-sql/driver-cassandra.c

2017-12-14 23:10:22 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a074b1e)

    *-login: Avoid unnecessary "OK Waiting for authentication process to
    respond"

    These happened with SSL connections when the process was starting up. The
    ssl-istream was triggering the IO callback, which was thinking that the 
    client was sending a command. If this happened early on before auth process 
    connection was finished, this caused several unnecessary notifications to 
    the client.

M	src/login-common/client-common.c

2017-12-14 23:23:13 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (99a6ea3)

    global: Finish fixing oldstats plugin/service rename


M	src/old-stats/stats-settings.c
M	src/plugins/old-stats/mail-stats.c
M	src/plugins/old-stats/stats-plugin.h

2017-12-14 21:50:58 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (3c8a163)

    lib-http: client: Check whether client is running in a wait loop with the
    correct condition.

    This used to check client->ioloop != NULL, but now it should check
    client->waiting. Previous commit (e8a1b62fe4a81b211dcccd1a58b44f254074eab6)
    omitted a few instances where this should have been changed.

M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c

2017-12-14 10:46:39 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (21bc261)

    lda: Do not replace the NULL sender with a default <MAILER-DAEMON> address.

    Only do this substitution locally where a NULL sender would cause problems,
    not everywhere else. This e.g. causes problems when determining whether to
    send a rejection somewhere; attempts would be made to mail <MAILER-DAEMON>. 
    Also other envelope-based (Sieve) tests would get confused.

M	src/lda/main.c

2017-12-14 10:42:07 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (a1f1ff1)

    lib-lda: Properly check whether MAIL FROM is the NULL sender <>.

    There's a function for that, since comparison with NULL pointer is not
    sufficient.

M	src/lib-lda/mail-deliver.c

2017-12-13 20:53:09 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e366340)

    lib-master: stats-client - Fix reconnection if handshake wait fails

    Fixes: Warning: Timeout leak: 0x5555556ac8d0 (stats-client.c:132)

M	src/lib-master/stats-client.c

2017-12-14 13:02:10 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (a46221f)

    submission-login: Fix another NULL dereference occurring at an invalid reply
    from the backend server.

    The text variable was still being used when it could be NULL. Made the
    offending code dependent on the reply validity check.

    Problem found by Coverity.

M	src/submission-login/submission-proxy.c

2017-12-14 14:13:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7a80631)

    oldstats plugin: Fix init/deinit function names


M	src/plugins/old-stats/stats-plugin.c

2017-12-14 02:11:28 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (75aaa1a)

    lib-storage: mailbox_list_index - Don't overwrite INBOX's flags with
    prefix/INBOX's

    This made the real INBOX appear as if it was \NoSelect

M	src/lib-storage/list/mailbox-list-index-sync.c

2017-12-14 02:10:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6081f6a)

    lib-storage: mailbox_list_index - indentation cleanup


M	src/lib-storage/list/mailbox-list-index-sync.c

2017-12-14 01:39:32 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6549236)

    lib-storage: mailbox_list_index - List prefix/INBOX if it necessary


M	src/lib-storage/list/mailbox-list-index-iter.c
M	src/lib-storage/list/mailbox-list-index.h

2017-12-14 01:36:50 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (874dc84)

    LAYOUT=fs: Fix listing prefix/INBOX

    Removed some confusing special case code that didn't seem to work very well. 
    Implemented this now properly so that prefix/INBOX is listed as \NoSelect 
    mailbox whenever it has children.

    It's not actually possible to differentiate between INBOX and prefix/INBOX 
    in the storage for a inbox=yes namespace, because they both are converted 
    into the same storage_name=INBOX.

M	src/lib-storage/list/mailbox-list-fs-iter.c

2017-12-14 01:34:25 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (141aa0e)

    LAYOUT=fs: List INBOX as \NoInferiors when necessary


M	src/lib-storage/list/mailbox-list-fs-iter.c

2017-12-14 01:31:10 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f7dd04e)

    LAYOUT=index: List INBOX as \NoInferiors when necessary


M	src/lib-storage/list/mailbox-list-index-iter.c

2017-12-14 01:23:45 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (38e6026)

    LAYOUT=Maildir++: List INBOX as \NoInferiors when necessary


M	src/lib-storage/list/mailbox-list-maildir-iter.c

2017-12-14 01:23:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9a2149c)

    lib-storage: Add mail_namespace_is_inbox_noinferiors()


M	src/lib-storage/mail-namespace.h

2017-12-08 16:14:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (50ba09c)

    imapc: Don't skip listing "INBOX" when INBOX/ namespace prefix is used.

    The INBOX was still listed as part of the autocreated mailboxes, unless 
    MAILBOX_LIST_ITER_NO_AUTO_BOXES was used.

M	src/lib-storage/index/imapc/imapc-list.c

2017-12-13 19:11:02 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (673ee24)

    lib: mempool-allocfree - make static analyzer happier with pool clearing

    It was thinking that already freed memory was being accessed.

M	src/lib/mempool-allocfree.c

2017-12-13 20:55:59 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (11d4b18)

    dbox: Fix creating dbox-alt-root symlink when mail root directory doesn't
    exist

    Broken by 74664ac6dcf88cfc2ae6378c87c20ba694385a23

M	src/lib-storage/index/dbox-common/dbox-storage.c

2017-12-13 21:52:41 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (af7956f)

    lib-http: client: peer: Properly handle claiming an existing connection.

    If no other connections were being created, request handling was not
    restarted. This problem sometimes caused the client to hang. Fixed by
    calling http_client_peer_connection_success() upon claiming an existing
    connection.

M	src/lib-http/http-client-peer.c

2017-12-13 18:16:07 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (20138b8)

    lib-http: test-http-payload: Terminate the test if it is hanging for some
    reason.


M	src/lib-http/test-http-payload.c

2017-12-13 17:27:10 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b7f1ebf)

    lib-http: test-http-payload: Amend shared client tests to do both download
    and echo tests.

    Also, the original download tests were named wrong.

M	src/lib-http/test-http-payload.c

2017-12-13 17:29:09 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (c9f7a21)

    lib-http: test-http-payload: Fixed indent problems.


M	src/lib-http/test-http-payload.c

2017-12-13 14:44:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f46a703)

    doveadm stats dump: Add -r parameter to reset stats after dumping


M	src/doveadm/doveadm-stats.c

2017-12-13 14:43:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9c675f5)

    stats: Add DUMP-RESET command to reset stats after dumping them


M	src/stats/client-reader.c
M	src/stats/stats-metrics.c
M	src/stats/stats-metrics.h

2017-12-12 21:38:46 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (74664ac)

    lib-storage: Delay creating mail root directory until it's necessary


M	src/lib-storage/mail-storage.c

2017-12-12 21:36:07 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d95773f)

    lib-storage: Make sure index root is created when it's the same as root
    directory

    This is required by the following commit.

M	src/lib-storage/mailbox-list.c

2017-08-09 20:06:00 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e8a1b62)

    lib-http: client: Made http_client record the current ioloop it is switched
    to.

    This prevents http_client_wait() from switching the client to an ioloop it
    was never explicitly switched to.

M	src/lib-http/http-client-private.h
M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c
M	src/lib-http/http-client.h

2017-12-13 14:19:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (481992b)

    imap: Fix o_stream_is_corked() assert check

    All the callers cork the stream, so this can only mean that the corking 
    failed because the connection was already closed. Continue handling the 
    input anyway.

    Fixes: Panic: file imap-client.c: line 1236 (client_handle_input): assertion
    failed: (o_stream_is_corked(client->output))

M	src/imap/imap-client.c

2017-12-13 15:48:17 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a820036)

    LAYOUT=index: Fix crash in doveadm force-resync if storage doesn't implement
    list_index_rebuild()

    Broken by recent changes.

M	src/lib-storage/list/mailbox-list-index-backend.c

2017-12-12 18:10:40 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f544706)

    LAYOUT=index: Fix updating STATUS changes in mailbox list index

    Mailbox list index backend code was overriding sync_init and sync_deinit 
    methods, which STATUS handling had already already overridden. They both 
    used the same super struct, so STATUS's sync_* were never called.

M	src/lib-storage/list/mailbox-list-index-backend.c
M	src/lib-storage/list/mailbox-list-index-status.c
M	src/lib-storage/list/mailbox-list-index-storage.h
M	src/lib-storage/list/mailbox-list-index.c
M	src/lib-storage/list/mailbox-list-index.h

2017-12-13 15:54:40 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (583c531)

    lib-master: Fix logging "Expected FILTER" error


M	src/lib-master/stats-client.c

2017-12-13 15:54:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (db2d8df)

    stats: Fix logging unknown client command error


M	src/stats/client-writer.c

2017-12-13 14:37:59 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (0e8ff50)

    .gitignore: Ignore src/old-stats/old-stats


M	.gitignore

2017-12-04 23:39:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (324f41b)

    lib-http: Add named event: http_request_finished


M	src/lib-http/http-client-request.c

2017-12-04 21:56:29 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (285f3c4)

    doveadm: Add new "stats dump" command


M	src/doveadm/Makefile.am
M	src/doveadm/doveadm-cmd.c
M	src/doveadm/doveadm-cmd.h
A	src/doveadm/doveadm-stats.c

2017-12-04 21:23:44 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (838d6a4)

    global: Enable MASTER_SERVICE_FLAG_SEND_STATS for mail processes


M	src/doveadm/doveadm.c
M	src/doveadm/main.c
M	src/imap/main.c
M	src/indexer/indexer-worker.c
M	src/lmtp/main.c
M	src/pop3/main.c

2017-12-04 20:39:05 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (15dd189)

    lib: connection - When receiving invalid VERSION line, log the line contents


M	src/lib/connection.c

2017-12-04 20:33:58 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2fb2794)

    log: Fix restoring global log prefix

    It was allocated from data stack, which was freed by 
    master_service_init_finish(). This may have caused wrong prefix to be used
    for log's internal error messages, or restoring the global log prefix could
    have crashed:

    Panic: file strfuncs.c: line 147 (t_noalloc_strdup_vprintf): assertion
    failed: ((unsigned int)ret == *size_r-1)

M	src/log/log-connection.h
M	src/log/main.c

2017-12-08 00:15:40 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (36409af)

    lib-http: client: Replace http_*_debug() with e_debug()


M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-peer.c
M	src/lib-http/http-client-queue.c
M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c

2017-12-04 12:58:47 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (39018a6)

    lib-http: client: Remove redundant debug logging checks


M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-peer.c
M	src/lib-http/http-client-queue.c
M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c

2017-12-04 12:35:46 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2d1ad57)

    lib-http: client: Add support for event API


M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-peer.c
M	src/lib-http/http-client-private.h
M	src/lib-http/http-client-queue.c
M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c
M	src/lib-http/http-client.h

2017-12-04 12:27:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a79ae29)

    lib-http: Cleanup - Add name parameter to http_client_host_create()


M	src/lib-http/http-client-host.c

2017-12-03 19:31:20 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b254b8e)

    lib-fs: Replace i_error() calls with e_error()


M	src/lib-fs/fs-posix.c
M	src/lib-fs/fs-sis-common.c
M	src/lib-fs/fs-sis-queue.c
M	src/lib-fs/fs-sis.c

2017-12-03 19:26:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (fc59aba)

    lib-fs: Add fs_file/iter_init_with_event()

    Use the event for logging critical errors

M	src/lib-fs/fs-api-private.h
M	src/lib-fs/fs-api.c
M	src/lib-fs/fs-api.h
M	src/lib-fs/fs-sis-common.c

2017-12-04 15:06:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6d1218e)

    lib-fs: Add fs_file/iter_init_parent()


M	src/lib-fs/fs-api-private.h
M	src/lib-fs/fs-api.c
M	src/lib-fs/fs-metawrap.c
M	src/lib-fs/fs-randomfail.c
M	src/lib-fs/fs-sis-queue.c
M	src/lib-fs/fs-sis.c
M	src/lib-fs/fs-wrapper.c
M	src/plugins/fs-compress/fs-compress.c
M	src/plugins/mail-crypt/fs-crypt-common.c

2017-12-04 14:55:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4110f96)

    lib-fs: Set fs_iter.flags immediately in fs_iter_init()

    This way backends don't need to set it.

M	src/lib-fs/fs-api.c
M	src/lib-fs/fs-dict.c
M	src/lib-fs/fs-posix.c
M	src/lib-fs/fs-randomfail.c
M	src/lib-fs/fs-test.c
M	src/lib-fs/fs-wrapper.c

2017-12-04 14:53:37 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4d71d71)

    lib-fs: Split allocation from fs.iter_init() to a separate fs.iter_alloc()


M	src/lib-fs/fs-api-private.h
M	src/lib-fs/fs-api.c
M	src/lib-fs/fs-dict.c
M	src/lib-fs/fs-metawrap.c
M	src/lib-fs/fs-posix.c
M	src/lib-fs/fs-randomfail.c
M	src/lib-fs/fs-sis-queue.c
M	src/lib-fs/fs-sis.c
M	src/lib-fs/fs-test.c
M	src/lib-fs/fs-wrapper.c
M	src/lib-fs/fs-wrapper.h
M	src/plugins/fs-compress/fs-compress.c
M	src/plugins/mail-crypt/fs-crypt.c
M	src/plugins/mail-crypt/fs-mail-crypt.c

2017-12-04 14:43:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (86ad48a)

    lib-fs: Split allocation from fs.file_init() to a separate fs.file_alloc()


M	src/lib-fs/fs-api-private.h
M	src/lib-fs/fs-api.c
M	src/lib-fs/fs-dict.c
M	src/lib-fs/fs-metawrap.c
M	src/lib-fs/fs-posix.c
M	src/lib-fs/fs-randomfail.c
M	src/lib-fs/fs-sis-queue.c
M	src/lib-fs/fs-sis.c
M	src/lib-fs/fs-test.c
M	src/plugins/fs-compress/fs-compress.c
M	src/plugins/mail-crypt/fs-crypt-common.c
M	src/plugins/mail-crypt/fs-crypt.c
M	src/plugins/mail-crypt/fs-mail-crypt.c

2017-11-23 17:46:23 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (b63e20e)

    lib-master: Add stats-client

    Enable it if MASTER_SERVICE_FLAG_SEND_STATS is set

M	src/lib-master/Makefile.am
M	src/lib-master/master-service-private.h
M	src/lib-master/master-service-settings.c
M	src/lib-master/master-service-settings.h
M	src/lib-master/master-service.c
M	src/lib-master/master-service.h
A	src/lib-master/stats-client.c
A	src/lib-master/stats-client.h
M	src/lib/lib-event-private.h

2017-11-22 17:36:09 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (e9068f1)

    stats: Add new stats service


M	configure.ac
M	src/Makefile.am
A	src/stats/Makefile.am
A	src/stats/client-reader.c
A	src/stats/client-reader.h
A	src/stats/client-writer.c
A	src/stats/client-writer.h
A	src/stats/main.c
A	src/stats/stats-event-category.c
A	src/stats/stats-event-category.h
A	src/stats/stats-metrics.c
A	src/stats/stats-metrics.h
A	src/stats/stats-settings.c
A	src/stats/stats-settings.h

2017-11-21 18:22:38 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (9c9d842)

    imap: Add imap_command_finished event.

    This can be used to get per-command statistics.

M	src/imap/imap-client.c

2017-11-21 16:05:30 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (1c02804)

    imap: Add client_command_context.event and use it as global event while
    running


M	src/imap/imap-client.c
M	src/imap/imap-client.h
M	src/imap/imap-commands.c
M	src/imap/imap-notify.c
M	src/imap/imap-state.c

2017-11-21 15:33:59 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (fcad7b5)

    imap: Add client.event and use it as mail_*user's parent event


M	src/imap/imap-client.c
M	src/imap/imap-client.h
M	src/imap/imap-common.h
M	src/imap/main.c

2017-11-21 13:13:49 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (ceac664)

    lib-index: mail_index_set_error() - log error using index's event


M	src/lib-index/mail-index.c

2017-11-21 13:13:40 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (82d158d)

    lib-index: Add mail_index.event


M	src/doveadm/doveadm-dump-index.c
M	src/lib-index/mail-index-alloc-cache.c
M	src/lib-index/mail-index-alloc-cache.h
M	src/lib-index/mail-index-private.h
M	src/lib-index/mail-index.c
M	src/lib-index/mail-index.h
M	src/lib-index/test-mail-index-modseq.c
M	src/lib-index/test-mail-transaction-log-file.c
M	src/lib-storage/index/dbox-multi/mdbox-map.c
M	src/lib-storage/index/index-rebuild.c
M	src/lib-storage/index/index-storage.c
M	src/lib-storage/list/mailbox-list-index.c
M	src/lib-storage/mail-storage.c
M	src/lib-storage/test-mail-search-args-simplify.c

2017-11-21 13:03:03 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (6610dc5)

    lib-storage: mail_storage_set_critical() - log error using user's event

    Fix test-storage unit test to also initialize mail_user.event so it won't 
    crash.

M	src/lib-storage/mail-storage.c
M	src/lib-storage/test-mail-storage.c

2017-11-21 12:59:40 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (c499c40)

    lib-storage: Add mail.event


M	src/lib-storage/index/index-mail.c
M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage.c
M	src/lib-storage/mail-storage.h

2017-11-21 12:51:10 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (b644a77)

    lib-storage: Add mailbox.event


M	src/lib-storage/index/index-storage.c
M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage.c

2017-11-20 19:33:40 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (677cc0d)

    lib-storage: Add mail_user.event and give parent event in mail_user_alloc*()


M	src/lib-storage/index/raw/raw-storage.c
M	src/lib-storage/index/shared/shared-storage.c
M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage-service.c
M	src/lib-storage/mail-storage.c
M	src/lib-storage/mail-user.c
M	src/lib-storage/mail-user.h

2017-11-20 17:26:42 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (d272952)

    lib-storage: Add mail_storage_service_user.event and use it as the global
    event

    The event is set in the same place as where the user's default logging 
    prefix is changed.

M	src/lib-storage/mail-storage-service.c
M	src/lib-storage/mail-storage-service.h

2017-11-22 15:41:51 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (1fd856f)

    lib-master: Add log_debug setting

    lib-master understands only the global log_debug setting, which is passed to
    it via environment from master process, or alternatively via doveconf when
    executing standalone programs. Any per-user log_debug settings need to be
    handled explicitly elsewhere.

M	src/lib-master/master-interface.h
M	src/lib-master/master-service-settings.c
M	src/lib-master/master-service-settings.h
M	src/lib-master/master-service.c
M	src/master/service-process.c

2017-11-22 14:51:47 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (c6ab223)

    lib: Add event filtering to debug logging


M	src/lib/event-log.c
M	src/lib/event-log.h
M	src/lib/lib-event-private.h
M	src/lib/lib-event.c

2017-11-22 13:55:51 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (918384d)

    lib: Add event filter

    This currently supports matching events by:

     * name
    * source file:line
    * categories
    * key=value fields

M	src/lib/Makefile.am
A	src/lib/event-filter.c
A	src/lib/event-filter.h
M	src/lib/lib-event.c
M	src/lib/lib.c

2017-12-04 21:20:49 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (53ea4ad)

    lib: Add event_import() and event_export()


M	src/lib/lib-event-private.h
M	src/lib/lib-event.c

2017-10-23 11:18:59 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (b8a1347)

    lib: Add event API

    The events are hierarchical and the child events inherit the parents' 
    fields. The events will be attached to "objects", which gives them some 
    context. For example each mail user, mailbox and mail will have its own 
    event. The events can also have a log prefix, so logging events to e.g. mail
    will always log a consistent prefix that identifies which mail is being
    logged about.

    The events will also be used for statistics. Typically this is done by 
    logging a debug event, which contains fields that are interesting for 
    statistics. The interesting events will have a name, which can be used to
    identify them when configuring which statistics are wanted to be tracked.
    It's possible to also track events that have no name, but that requires
    using the source code's filename:line as the event name. That of course may
    change between releases, so it's not very reliable.

M	src/lib/Makefile.am
A	src/lib/event-log.c
A	src/lib/event-log.h
A	src/lib/lib-event-private.h
A	src/lib/lib-event.c
A	src/lib/lib-event.h
M	src/lib/lib.c
M	src/lib/lib.h

2017-11-17 12:37:15 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (982c30a)

    lib: Add failure_context.log_prefix to override the default


M	src/lib/failures.c
M	src/lib/failures.h

2017-11-13 16:08:15 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8009758)

    lib: Add i_log_typev()


M	src/lib/failures.c
M	src/lib/failures.h

2017-12-12 01:04:29 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4b51ecb)

    lib: ioloop.h - improve ioloop context comments


M	src/lib/ioloop.h

2017-12-12 01:20:52 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c4995ce)

    lib-storage: Remove mail_storage_service_io_deactivate()

    We now require that ioloop context is always properly deactivated, so 
    there's no need for the function.

M	src/lib-storage/mail-storage-service.c
M	src/lib-storage/mail-storage-service.h

2017-12-12 01:19:04 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (64c7bca)

    imap, pop3: Remove unnecessary call to mail_storage_service_io_deactivate()

    The context is automatically deactivated when service user is freed.

M	src/imap/imap-client.c
M	src/imap/imap-client.h
M	src/imap/main.c
M	src/pop3/main.c
M	src/pop3/pop3-client.c
M	src/pop3/pop3-client.h

2017-12-12 01:17:22 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (cafe72d)

    lib-storage: mail_storage_service_io_[de]activate_user() - [de]activate the
    whole ioloop context


M	src/lib-storage/mail-storage-service.c

2017-12-12 01:33:08 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b758c60)

    lib-storage: mail_storage_service_user_unref() - deactivate user before
    removing callbacks

    Otherwise the next commit won't work correctly.

M	src/lib-storage/mail-storage-service.c

2017-12-12 01:12:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (0f8663f)

    lib-storage: Create ioloop context regardless of logging settings

    This will be needed by the following commits.

M	src/lib-storage/mail-storage-service.c

2017-12-12 01:04:06 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (391fa11)

    lib: io_loop_context_deactivate() - Assert that given context is currently
    active


M	src/lib/ioloop.c

2017-12-12 01:02:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (76da9d5)

    lib: io_loop_context_new() - deactivate old context

    Since it changes the current context, it needs to deactivate the old one.

M	src/lib/ioloop.c

2017-12-12 01:01:33 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1da9355)

    lib: io_loop_destroy() - Assert-crash if ioloop contet is still set

    It may be too late to try to deactivate it at that point, so it points to a 
    bug.

M	src/lib/ioloop.c

2017-12-12 00:50:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7446aaf)

    lib: Move io_loop_context_[de]activate() to be public


M	src/lib/ioloop-private.h
M	src/lib/ioloop.h

2017-12-08 00:54:51 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (92fc2c8)

    lib: timing - Allow changing sample buffer size


M	src/lib/timing.c
M	src/lib/timing.h

2017-11-21 14:46:30 +0100 Timo Sirainen <timo.sirainen@dovecot.fi> (6ef83bc)

    global: Renamed stats plugin and service to old-stats


M	configure.ac
M	src/Makefile.am
M	src/auth/Makefile.am
M	src/auth/auth-request-stats.c
M	src/doveadm/Makefile.am
M	src/doveadm/doveadm-cmd.c
M	src/doveadm/doveadm-cmd.h
A	src/doveadm/doveadm-oldstats.c
D	src/doveadm/doveadm-stats.c
M	src/doveadm/doveadm.c
A	src/lib-old-stats/Makefile.am
A	src/lib-old-stats/stats-connection.c
A	src/lib-old-stats/stats-connection.h
A	src/lib-old-stats/stats-parser.c
A	src/lib-old-stats/stats-parser.h
A	src/lib-old-stats/stats.c
A	src/lib-old-stats/stats.h
D	src/lib-stats/Makefile.am
D	src/lib-stats/stats-connection.c
D	src/lib-stats/stats-connection.h
D	src/lib-stats/stats-parser.c
D	src/lib-stats/stats-parser.h
D	src/lib-stats/stats.c
D	src/lib-stats/stats.h
A	src/old-stats/Makefile.am
A	src/old-stats/client-export.c
A	src/old-stats/client-export.h
A	src/old-stats/client-reset.c
A	src/old-stats/client-reset.h
A	src/old-stats/client.c
A	src/old-stats/client.h
A	src/old-stats/fifo-input-connection.c
A	src/old-stats/fifo-input-connection.h
A	src/old-stats/global-memory.c
A	src/old-stats/global-memory.h
A	src/old-stats/mail-command.c
A	src/old-stats/mail-command.h
A	src/old-stats/mail-domain.c
A	src/old-stats/mail-domain.h
A	src/old-stats/mail-ip.c
A	src/old-stats/mail-ip.h
A	src/old-stats/mail-session.c
A	src/old-stats/mail-session.h
A	src/old-stats/mail-stats.c
A	src/old-stats/mail-stats.h
A	src/old-stats/mail-user.c
A	src/old-stats/mail-user.h
A	src/old-stats/main.c
A	src/old-stats/stats-carbon.c
A	src/old-stats/stats-carbon.h
A	src/old-stats/stats-settings.c
A	src/old-stats/stats-settings.h
M	src/plugins/Makefile.am
A	src/plugins/imap-old-stats/Makefile.am
A	src/plugins/imap-old-stats/imap-stats-plugin.c
A	src/plugins/imap-old-stats/imap-stats-plugin.h
D	src/plugins/imap-stats/Makefile.am
D	src/plugins/imap-stats/imap-stats-plugin.c
D	src/plugins/imap-stats/imap-stats-plugin.h
A	src/plugins/old-stats/Makefile.am
A	src/plugins/old-stats/mail-stats-connection.c
A	src/plugins/old-stats/mail-stats-connection.h
A	src/plugins/old-stats/mail-stats-fill.c
A	src/plugins/old-stats/mail-stats.c
A	src/plugins/old-stats/mail-stats.h
A	src/plugins/old-stats/stats-plugin.c
A	src/plugins/old-stats/stats-plugin.h
D	src/plugins/stats/Makefile.am
D	src/plugins/stats/mail-stats-connection.c
D	src/plugins/stats/mail-stats-connection.h
D	src/plugins/stats/mail-stats-fill.c
D	src/plugins/stats/mail-stats.c
D	src/plugins/stats/mail-stats.h
D	src/plugins/stats/stats-plugin.c
D	src/plugins/stats/stats-plugin.h
D	src/stats/Makefile.am
D	src/stats/client-export.c
D	src/stats/client-export.h
D	src/stats/client-reset.c
D	src/stats/client-reset.h
D	src/stats/client.c
D	src/stats/client.h
D	src/stats/fifo-input-connection.c
D	src/stats/fifo-input-connection.h
D	src/stats/global-memory.c
D	src/stats/global-memory.h
D	src/stats/mail-command.c
D	src/stats/mail-command.h
D	src/stats/mail-domain.c
D	src/stats/mail-domain.h
D	src/stats/mail-ip.c
D	src/stats/mail-ip.h
D	src/stats/mail-session.c
D	src/stats/mail-session.h
D	src/stats/mail-stats.c
D	src/stats/mail-stats.h
D	src/stats/mail-user.c
D	src/stats/mail-user.h
D	src/stats/main.c
D	src/stats/stats-carbon.c
D	src/stats/stats-carbon.h
D	src/stats/stats-settings.c
D	src/stats/stats-settings.h

2017-12-12 12:41:29 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (0cce673)

    submission: remove unnecessary casts

    Casting from a void * to any pointer type is automatic and doesn't require
    an explicit cast.

M	src/submission/cmd-data.c
M	src/submission/cmd-helo.c
M	src/submission/cmd-mail.c
M	src/submission/cmd-noop.c
M	src/submission/cmd-quit.c
M	src/submission/cmd-rcpt.c
M	src/submission/cmd-rset.c
M	src/submission/cmd-vrfy.c
M	src/submission/submission-client.c

2017-12-12 11:55:15 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (c4588e6)

    submission-login: use container_of instead of casts


M	src/submission-login/client-authenticate.c
M	src/submission-login/client.c
M	src/submission-login/submission-proxy.c

2017-12-12 11:26:21 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (0afd9a9)

    submission-login: remove unnecessary casts

    Casting from a void * to any pointer type is automatic and doesn't require
    an explicit cast.

M	src/submission-login/client-authenticate.c
M	src/submission-login/client.c
M	src/submission-login/submission-proxy.c

2017-12-12 11:18:10 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (c5e46db)

    global: drop unnecessary parens in &(foo)

    This makes the code more consistent since most of the repo uses the 
    no-parens style.  These inconsistencies were found using
    `git grep '(&([^*]'` and any use of the parens in macros was ignored for 
    safety reasons.

M	src/auth/auth-policy.c
M	src/doveadm/doveadm-cmd.c
M	src/lib-dcrypt/dcrypt-gnutls.c
M	src/lib-dcrypt/dcrypt-openssl.c
M	src/lib-dcrypt/istream-decrypt.c
M	src/lib-dcrypt/ostream-encrypt.c
M	src/lib-dict-backend/dict-ldap.c
M	src/lib-ldap/ldap-connection.c
M	src/lib-ldap/ldap-entry.c
M	src/lib-ldap/ldap-iterator.c
M	src/lib-ldap/ldap-search.c

2017-12-12 11:10:15 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (4afd5b6)

    global: io_remove*(NULL) is a no-op


M	src/lib-ldap/ldap-connection.c
M	src/lib-master/master-service.c

2017-11-27 14:11:40 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (d90a924)

    global: timeout_remove(NULL) is a no-op


M	src/dict/dict-connection.c
M	src/director/user-directory.c
M	src/imap/imap-notify.c
M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-peer.c
M	src/lib-http/http-client-queue.c
M	src/lib-imap-client/imapc-connection.c
M	src/lib-ldap/ldap-connection.c
M	src/lib-master/anvil-client.c
M	src/lib-master/master-service.c
M	src/lib-sql/driver-pgsql.c
M	src/plugins/fts-lucene/lucene-wrapper.cc

2017-12-13 10:50:38 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (47758f9)

    m4: Fix sodium checks

    Make sure it actually has password checking function

M	m4/want_sodium.m4

2017-12-12 21:53:42 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (82bddf8)

    submission-login: Added default listener for secure submission on port 465
    (submissions).

    This is analogous to pop3s and imaps. Efforts to standardize the use of this
    port are almost finished:
    https://datatracker.ietf.org/doc/draft-ietf-uta-email-deep/

M	src/submission-login/submission-login-settings.c

2017-12-12 21:46:53 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (4a1af46)

    submission-login: Fix NULL dereference occurring at an invalid reply from
    the backend server.

    Problem found by Coverity.

M	src/submission-login/submission-proxy.c

2017-12-12 12:18:06 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (836ed7e)

    lib-smtp: fix uoff_t vs. size_t confusion


M	src/lib-smtp/smtp-client-command.c
M	src/lib-smtp/smtp-server-cmd-data.c
M	src/lib-smtp/test-smtp-payload.c

2017-12-12 16:07:52 +0200 Sergey Kitov <sergey.kitov@open-xchange.com> (e7e3f40)

    plugins/fts: Return back comment about Server Error.


M	src/plugins/fts/fts-parser-tika.c

2017-12-12 16:06:14 +0200 Sergey Kitov <sergey.kitov@open-xchange.com> (71b4377)

    plugins/fts: Retry all 5xx tika http statuses, not only 500


M	src/plugins/fts/fts-parser-tika.c

2017-12-12 08:56:31 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (70a88f2)

    director: avoid comparison between signed and unsigned ints


M	src/director/director-connection.c

2017-12-12 08:55:58 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (2e758d1)

    submission: use correct format string for printing uoff_t


M	src/submission/cmd-helo.c

2017-12-11 14:18:20 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (5af1ff0)

    Update README regarding supported RFCs.

    Some were missing and new ones are added by the recent lib-smtp and
    submission service changes.

M	README.md

2017-12-11 18:07:35 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f2cd173)

    config: Add a warning comment to the generated all-settings.c


M	src/config/settings-get.pl

2017-12-11 20:29:29 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (0a6796c)

    doc: example-config: Fix installation of the example configuration for the
    submission service.

    Forgot to add it to Makefile.am.

M	doc/example-config/conf.d/Makefile.am

2017-12-11 15:55:32 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b1aac3a)

    lmtp: Fix segfault occurring in client_read_settings().

    This problem is caused by recent changes. The code attempts to access
    client->conn to obtain connection security info, which is not yet assigned
    at that point. It is doubtful whether assigning those security flags is
    useful at that stage, but it now uses the ssl flag from the
    master_service_connection instead.

M	src/lmtp/client.c

2017-12-11 15:53:45 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (823802b)

    lmtp: Removed useless ssl_start parameter for client_create().

    The same information is already contained in the conn parameter.

M	src/lmtp/client.c
M	src/lmtp/client.h
M	src/lmtp/main.c

2017-11-11 14:20:59 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (2cbbe9b)

    Implemented SMTP submission proxy service.


M	.gitignore
M	TODO
M	configure.ac
M	doc/example-config/conf.d/10-director.conf
M	doc/example-config/conf.d/10-master.conf
M	doc/example-config/conf.d/10-ssl.conf
A	doc/example-config/conf.d/20-submission.conf
M	doc/example-config/dovecot.conf
M	src/Makefile.am
A	src/submission-login/Makefile.am
A	src/submission-login/client-authenticate.c
A	src/submission-login/client-authenticate.h
A	src/submission-login/client.c
A	src/submission-login/client.h
A	src/submission-login/submission-login-settings.c
A	src/submission-login/submission-login-settings.h
A	src/submission-login/submission-proxy.c
A	src/submission-login/submission-proxy.h
A	src/submission/Makefile.am
A	src/submission/cmd-data.c
A	src/submission/cmd-helo.c
A	src/submission/cmd-mail.c
A	src/submission/cmd-noop.c
A	src/submission/cmd-quit.c
A	src/submission/cmd-rcpt.c
A	src/submission/cmd-rset.c
A	src/submission/cmd-vrfy.c
A	src/submission/main.c
A	src/submission/submission-client.c
A	src/submission/submission-client.h
A	src/submission/submission-commands.c
A	src/submission/submission-commands.h
A	src/submission/submission-common.h
A	src/submission/submission-settings.c
A	src/submission/submission-settings.h

2017-12-09 02:09:35 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (211caf3)

    lib-storage: mail-user: Added more information about the client connection.

    Submission service will need it to pass to the backend MTA in XCLIENT and
    for creating the "Received:" header.

M	src/imap/main.c
M	src/lib-storage/mail-storage-service.c
M	src/lib-storage/mail-storage-service.h
M	src/lib-storage/mail-user.h
M	src/lmtp/client.c
M	src/lmtp/lmtp-local.c
M	src/pop3/main.c

2017-12-09 02:34:52 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (e213fe0)

    lib-master: master-auth: Pass more information about the user connection to
    the backend in struct master_auth_request.

    Adds remote and local ports and security information about the connection. 
    This changes the master-auth protocol incompatibly, so the major version is
    updated.

M	src/lib-master/master-auth.h
M	src/login-common/sasl-server.c

2017-12-09 02:33:16 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (9666d13)

    login-common: Added flag to client that indicates whether connection is
    secured using SSL specifically.


M	src/login-common/client-common.c
M	src/login-common/client-common.h

2017-12-09 01:52:28 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (ff4ba03)

    lib-storage: mail-user: Changed mail_user_set_vars() to accept struct
    mail_user_connection_data, rather than individual fields.


M	src/lib-storage/mail-storage-service.c
M	src/lib-storage/mail-user.c
M	src/lib-storage/mail-user.h

2017-12-09 01:29:06 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (6067018)

    lib-storage: Moved connection information in struct mail_user into separate
    struct mail_user_connection_data.


M	src/imap/cmd-idle.c
M	src/imap/imap-client-hibernate.c
M	src/imap/main.c
M	src/lib-storage/mail-user.c
M	src/lib-storage/mail-user.h
M	src/plugins/stats/mail-stats-connection.c
M	src/pop3/main.c

2017-12-09 01:11:53 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (2ded32b)

    imap: cmd-idle: Created local variable for client in
    idle_add_keepalive_timeout().


M	src/imap/cmd-idle.c

2017-12-09 01:04:48 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (8c1199c)

    imap: imap-client-hibernate: Created local variable for mail_user in
    imap_hibernate_write_cmd().


M	src/imap/imap-client-hibernate.c

2016-09-26 09:25:32 +0200 Stephan Bosch <stephan@rename-it.nl> (f1edf7f)

    imap-urlauth: Allow connections from services other than IMAP.

    The imap-urlauth service detects the new submission service and assigns the
    appropriate privileges. The dovecot-token authentication mechanism provides
    information on which service connected to it.

M	src/auth/mech-dovecot-token.c
M	src/imap-urlauth/imap-urlauth-client.c
M	src/imap-urlauth/imap-urlauth-client.h
M	src/imap-urlauth/imap-urlauth-login.c
M	src/imap-urlauth/imap-urlauth-worker.c
M	src/imap-urlauth/imap-urlauth.c
M	src/imap/imap-client.c
M	src/lib-imap-urlauth/imap-urlauth-connection.c
M	src/lib-imap-urlauth/imap-urlauth-connection.h
M	src/lib-imap-urlauth/imap-urlauth-private.h
M	src/lib-imap-urlauth/imap-urlauth.c
M	src/lib-imap-urlauth/imap-urlauth.h

2017-11-10 17:18:28 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (dfafc4a)

    login-common: Added client_disconnect(), which allows explicitly
    disconnecting the client before it is destroyed.

    This is sometimes needed to make sure the SSL layer is closed properly
    before destroying the underlying connection.

M	src/login-common/client-common.c
M	src/login-common/client-common.h

2016-09-26 19:12:19 +0200 Stephan Bosch <stephan@rename-it.nl> (a1852ab)

    login-common: Added support for login services that handle their own input
    io.


M	src/login-common/client-common-auth.c
M	src/login-common/client-common.c
M	src/login-common/client-common.h

2017-12-10 11:28:44 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (4dd460c)

    lib-smtp: server: Added max_recipients setting, which enforces a recipient
    limit per-transaction.


M	src/lib-smtp/smtp-server-cmd-rcpt.c
M	src/lib-smtp/smtp-server-connection.c
M	src/lib-smtp/smtp-server.c
M	src/lib-smtp/smtp-server.h
M	src/lib-smtp/test-smtp-server-errors.c

2017-12-10 11:26:10 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (6d76b99)

    lib-smtp: server: transaction: Added smtp_server_transaction_rcpt_count().


M	src/lib-smtp/smtp-server-private.h
M	src/lib-smtp/smtp-server-transaction.c

2017-12-11 02:19:52 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (1f4f829)

    lib-smtp: server: DATA/BDAT command: Make sure chunk stream is dereferenced
    early.

    The submission BURL command - which uses part of the same code - runs into
    trouble otherwise. This could also be an actual istream reference leak
    outside BURL, but that is not confirmed.

M	src/lib-smtp/smtp-server-cmd-data.c

2017-12-10 11:32:28 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (090abb1)

    lib-smtp: server: DATA command: Continue processing connection input once
    DATA reply is submitted.

    Fixes a potential connection hang.

M	src/lib-smtp/smtp-server-cmd-data.c

2017-12-10 11:31:24 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (e69ac57)

    lib-smtp: server: command: Added smtp_server_command_input_unlock().

    Allows unlock input for a command that was earlier locked with
    smtp_server_command_input_lock().

M	src/lib-smtp/smtp-server-command.c
M	src/lib-smtp/smtp-server.h

2017-12-11 10:33:09 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (237ff49)

    lib-smtp: server: DATA command: Make sure there is a transaction in
    smtp_server_connection_data_check_state() before using it.

    This fixes a potential NULL dereference. Found by Coverity.

M	src/lib-smtp/smtp-server-cmd-data.c

2017-12-11 10:37:58 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (eda1c4f)

    lib-smtp: server: DATA command: Fixed check for valid recipients in
    smtp_server_connection_data_check_state().

    Can only decide whether we have valid recipients once there are no more
    pending RCPT commands.

M	src/lib-smtp/smtp-server-cmd-data.c

2017-12-11 04:18:54 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (479f238)

    lib-smtp: server: Removed inappropriate NULL check in
    smtp_server_connection_send_replies().

    Caller holds a reference, so it can never be NULL. Found by Coverity.

M	src/lib-smtp/smtp-server-connection.c

2017-12-11 10:41:53 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (c13d312)

    lib-smtp: server: Remove useless o_stream_flush() in
    smtp_server_connection_disconnect().

    This is already performed implicitly by o_stream_uncork(). Fixes a problem
    found by Coverity.

M	src/lib-smtp/smtp-server-connection.c

2017-12-10 20:00:21 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (21138be)

    lib-test: istream-test - Don't modify existing snapshots' memareas

    At least with --enable-devel-checks this caused istream-sized unit test to 
    randomly panic:

    Panic: file istream.c: line 279 (i_stream_read): assertion failed:
    (memcmp(prev_buf, prev_data + prev_skip, prev_pos - prev_skip) == 0)

M	src/lib-test/test-istream.c

2017-12-11 12:59:58 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (ea4a85f)

    lib-http: client: Cleaned up initialization of client settings.

    There were checks for the client context not being NULL, which makes no
    sense anymore, since a private context is always created when none is
    provided. Problem reported by Coverity.

M	src/lib-http/http-client.c

2017-12-05 17:05:27 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (66bdf53)

    lib: test-var-expand - Ensure var_get_key_range_full handles nested ifs
    correctly


M	src/lib/test-var-expand.c

2017-12-01 19:46:58 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (f5d1cfc)

    lib: var-expand - handle \{ and \} correctly

    Do not treat these as embedded braces

M	src/lib/var-expand.c

2017-12-01 14:53:46 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (20a8a12)

    lib: Support nested keys in var_get_key_range_full

    Fixes problems with %{if...}

    failed: if: requires four or five parameters, got 1

M	src/lib/var-expand.c

2017-12-11 12:52:38 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (53e4a0d)

    auth: Debug log an LDAP request result only once


M	src/auth/db-ldap.c
M	src/auth/db-ldap.h

2017-12-11 12:47:32 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (5ced9eb)

    auth: Have ldap_request instead of auth_request in
    db_ldap_result_iterate_context

    This makes it easier to access ldap_request where needed later.

M	src/auth/db-ldap.c

2017-10-09 13:57:12 +0300 Sergey Kitov <sergey.kitov@open-xchange.com> (dc1e69c)

    fts: fts_parser_tika replace empty path with "/"

    indexing doesn't crash if fts_tika = http://host:port setting is missing
    trailing '/'

M	src/plugins/fts/fts-parser-tika.c

2017-10-09 13:53:42 +0300 Sergey Kitov <sergey.kitov@open-xchange.com> (8e1eaf8)

    fts: Retry indexing for tika backend in case of internal server error


M	src/plugins/fts/fts-api-private.h
M	src/plugins/fts/fts-build-mail.c
M	src/plugins/fts/fts-parser-tika.c
M	src/plugins/fts/fts-parser.h

2017-10-09 13:13:05 +0300 Sergey Kitov <sergey.kitov@open-xchange.com> (72d301f)

    fts: Extend parser's deinit function interface with retriable_err_msg_r
    parameter

    the new parameter will be set to a error string in case indexing may need
    retrying, so it will be logged later when decision about retry will be made.

M	src/plugins/fts/fts-api-private.h
M	src/plugins/fts/fts-build-mail.c
M	src/plugins/fts/fts-parser-html.c
M	src/plugins/fts/fts-parser-script.c
M	src/plugins/fts/fts-parser-tika.c
M	src/plugins/fts/fts-parser.c
M	src/plugins/fts/fts-parser.h

2017-10-09 11:23:54 +0300 Sergey Kitov <sergey.kitov@open-xchange.com> (43f4e55)

    fts: Parser move try_init arguments to a single structure parser_context.


M	src/plugins/fts/fts-build-mail.c
M	src/plugins/fts/fts-parser-html.c
M	src/plugins/fts/fts-parser-script.c
M	src/plugins/fts/fts-parser-tika.c
M	src/plugins/fts/fts-parser.c
M	src/plugins/fts/fts-parser.h
M	src/plugins/fts/xml2text.c

2017-11-27 14:19:34 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (d4002fe)

    global: Use mail_set_critical() and mailbox_set_critical() if possible

    Replace calls to mail_storage_set_critical() with mail_set_critical() or
    mailbox_set_critical() in places where mailbox or mail are easily available.

M	src/imap/cmd-append.c
M	src/imap/imap-fetch-body.c
M	src/lib-imap-storage/imap-msgpart.c
M	src/lib-storage/index/cydir/cydir-mail.c
M	src/lib-storage/index/cydir/cydir-save.c
M	src/lib-storage/index/cydir/cydir-storage.c
M	src/lib-storage/index/dbox-common/dbox-save.c
M	src/lib-storage/index/dbox-common/dbox-storage.c
M	src/lib-storage/index/dbox-multi/mdbox-mail.c
M	src/lib-storage/index/dbox-multi/mdbox-save.c
M	src/lib-storage/index/dbox-multi/mdbox-storage.c
M	src/lib-storage/index/dbox-multi/mdbox-sync.c
M	src/lib-storage/index/dbox-single/sdbox-copy.c
M	src/lib-storage/index/dbox-single/sdbox-file.c
M	src/lib-storage/index/dbox-single/sdbox-mail.c
M	src/lib-storage/index/dbox-single/sdbox-save.c
M	src/lib-storage/index/dbox-single/sdbox-storage.c
M	src/lib-storage/index/dbox-single/sdbox-sync-rebuild.c
M	src/lib-storage/index/dbox-single/sdbox-sync.c
M	src/lib-storage/index/imapc/imapc-mail-fetch.c
M	src/lib-storage/index/imapc/imapc-mail.c
M	src/lib-storage/index/imapc/imapc-save.c
M	src/lib-storage/index/imapc/imapc-search.c
M	src/lib-storage/index/imapc/imapc-storage.c
M	src/lib-storage/index/imapc/imapc-sync.c
M	src/lib-storage/index/index-attachment.c
M	src/lib-storage/index/index-attribute.c
M	src/lib-storage/index/index-mail-binary.c
M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-mailbox-size.c
M	src/lib-storage/index/index-search.c
M	src/lib-storage/index/index-sort-string.c
M	src/lib-storage/index/index-storage.c
M	src/lib-storage/index/index-sync-pvt.c
M	src/lib-storage/index/index-sync.c
M	src/lib-storage/index/index-thread.c
M	src/lib-storage/index/index-transaction.c
M	src/lib-storage/index/maildir/maildir-copy.c
M	src/lib-storage/index/maildir/maildir-keywords.c
M	src/lib-storage/index/maildir/maildir-mail.c
M	src/lib-storage/index/maildir/maildir-save.c
M	src/lib-storage/index/maildir/maildir-storage.c
M	src/lib-storage/index/maildir/maildir-sync-index.c
M	src/lib-storage/index/maildir/maildir-sync.c
M	src/lib-storage/index/maildir/maildir-uidlist.c
M	src/lib-storage/index/maildir/maildir-util.c
M	src/lib-storage/index/mbox/mbox-file.c
M	src/lib-storage/index/mbox/mbox-lock.c
M	src/lib-storage/index/mbox/mbox-mail.c
M	src/lib-storage/index/mbox/mbox-storage.c
M	src/lib-storage/index/mbox/mbox-sync-list-index.c
M	src/lib-storage/index/mbox/mbox-sync-rewrite.c
M	src/lib-storage/index/mbox/mbox-sync.c
M	src/lib-storage/index/pop3c/pop3c-storage.c
M	src/lib-storage/index/pop3c/pop3c-sync.c
M	src/lib-storage/index/raw/raw-mail.c
M	src/lib-storage/index/raw/raw-storage.c
M	src/lib-storage/list/mailbox-list-index-backend.c
M	src/lib-storage/mail-copy.c
M	src/lib-storage/mail-storage.c
M	src/lib-storage/mailbox-recent-flags.c
M	src/plugins/acl/acl-mailbox.c
M	src/plugins/fts/fts-storage.c
M	src/plugins/lazy-expunge/lazy-expunge-plugin.c
M	src/plugins/mailbox-alias/mailbox-alias-plugin.c
M	src/plugins/quota/quota-storage.c
M	src/plugins/virtual/virtual-config.c
M	src/plugins/virtual/virtual-storage.c
M	src/plugins/zlib/zlib-plugin.c

2017-11-27 14:09:21 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (1260d50)

    lib-storage: Take mail_save_context parameter in save_check_write_error()

    This is in order to use mail_set_critical() in the function later.

M	src/lib-storage/index/index-attachment.c

2017-11-27 13:52:07 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (0060557)

    quota: Take mailbox as parameter in quota_set_storage_error()

    This is to start using mailbox_set_critical() later.

M	src/plugins/quota/quota-storage.c

2017-11-29 15:46:34 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (804bca7)

    lib-ssl-iostream: Use SSL_CTX_set_min_proto_version if available


M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c

2017-11-07 14:47:01 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (a3a483d)

    m4: Add SSL_CTX_set_min_proto_version detection


M	m4/ssl.m4

2017-11-28 12:02:08 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (976dee5)

    Replace ssl_protocols config option with ssl_min_protocol

    Default to TLSv1.

M	doc/example-config/conf.d/10-ssl.conf
M	src/config/old-set-parser.c
M	src/lib-ldap/ldap-connection.c
M	src/lib-master/master-service-ssl-settings.c
M	src/lib-master/master-service-ssl-settings.h
M	src/lib-master/master-service-ssl.c
M	src/lib-ssl-iostream/iostream-openssl-common.c
M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-11-20 13:40:03 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (e4f8e7a)

    lib-storage: mailbox-list-iter - Refresh subscriptions before setting flags

    This happens when list patterns match the namespace prefix, but
    mailbox_list_ns_match_patterns() returns FALSE. And one of the ways for that
    to happen is if namespace has alias_for set.

M	src/lib-storage/list/mailbox-list-iter.c

2017-11-20 10:40:52 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (a612b56)

    lib-storage: mailbox-tree - Ensure tree is not NULL


M	src/lib-storage/mailbox-tree.c

2017-11-06 21:54:00 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b8b2cc4)

    lmtp: Changed message data handling to use iostream-temp.

    The existing code predates iostream-temp.

M	src/lmtp/client.c
M	src/lmtp/client.h
M	src/lmtp/commands.c

2017-10-10 01:04:50 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (1aae941)

    lmtp: Removed structural comments that are now useless.


M	src/lmtp/client.c
M	src/lmtp/commands.c

2017-10-10 01:03:02 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (88201d8)

    lmtp: client: Made client_remote_id() static.


M	src/lmtp/client.c
M	src/lmtp/client.h

2016-11-23 10:43:53 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b73539e)

    lmtp: Ported to use lib-smtp/server.

    Implicitly fixes handling of multi-line replies from proxy backend. 
    Implicitly adds support for mixing local and proxy recipients. Implicitly
    adds support for SMTP CHUNKING. RCPT failures are reported back to the
    client immediately, rather than waiting for the DATA command.

M	TODO
M	src/lmtp/client.c
M	src/lmtp/client.h
M	src/lmtp/commands.c
M	src/lmtp/commands.h
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h
M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h
M	src/lmtp/main.c
M	src/lmtp/main.h

2017-11-11 10:20:05 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b85d7b8)

    lib-smtp: Created test-smtp-server-errors, which tests the server's error
    handling.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/test-smtp-server-errors.c

2017-11-11 10:30:14 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (8620dc7)

    lib-smtp: Created test-smtp-payload, which tests client<->server payload
    exchange.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/test-smtp-payload.c

2016-11-06 22:46:31 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (56dd928)

    lib-smtp: Implemented SMTP server.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-server-cmd-auth.c
A	src/lib-smtp/smtp-server-cmd-data.c
A	src/lib-smtp/smtp-server-cmd-helo.c
A	src/lib-smtp/smtp-server-cmd-mail.c
A	src/lib-smtp/smtp-server-cmd-noop.c
A	src/lib-smtp/smtp-server-cmd-quit.c
A	src/lib-smtp/smtp-server-cmd-rcpt.c
A	src/lib-smtp/smtp-server-cmd-rset.c
A	src/lib-smtp/smtp-server-cmd-starttls.c
A	src/lib-smtp/smtp-server-cmd-vrfy.c
A	src/lib-smtp/smtp-server-cmd-xclient.c
A	src/lib-smtp/smtp-server-command.c
A	src/lib-smtp/smtp-server-connection.c
A	src/lib-smtp/smtp-server-private.h
A	src/lib-smtp/smtp-server-reply.c
A	src/lib-smtp/smtp-server-transaction.c
A	src/lib-smtp/smtp-server.c
A	src/lib-smtp/smtp-server.h

2016-11-06 22:36:57 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (8141e65)

    lib-smtp: Implemented SMTP command parser.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-command-parser.c
A	src/lib-smtp/smtp-command-parser.h
A	src/lib-smtp/smtp-command.h
A	src/lib-smtp/test-smtp-command-parser.c

2017-11-19 22:57:12 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (a498556)

    lib: istream-failure-at: Allow setting the the stream_errno to something
    other than EIO.


M	src/lib-fs/fs-randomfail.c
M	src/lib-smtp/test-smtp-client-errors.c
M	src/lib/istream-failure-at.c
M	src/lib/istream-failure-at.h
M	src/lib/test-iostream-pump.c
M	src/lib/test-istream-failure-at.c

2017-10-31 01:12:44 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (3f2f5e0)

    lmtp: proxy: Restructured proxy so that it has direct access to struct
    client.

    This avoids the hassle of initializing using struct lmtp_proxy_settings and
    uselessly reallocating stuff that is already persisted in struct client. 
    Moved the proxy from alloconly pool to default pool in the process. The
    amount of allocated stuff will diminish further in subsequent commits.

M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-10-30 23:28:35 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (8e32a7f)

    lmtp: proxy: Renamed pool to auth_pool in lmtp_proxy_rcpt() for clarity.


M	src/lmtp/lmtp-proxy.c

2017-10-30 21:09:25 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (47af877)

    lmtp: proxy: Made struct lmtp_proxy_rcpt_settings private.


M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-10-30 20:50:28 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (0e0ce84)

    lmtp: proxy: Merged lmtp_proxy_add_rcpt() into lmtp_proxy_rcpt().


M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-10-30 20:44:09 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (11bb115)

    lmtp: proxy: Made lmtp_proxy_mail_from() private.


M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-10-30 20:41:03 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (dd34d6b)

    lmtp: proxy: Made lmtp_proxy_init() private.


M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-10-30 01:24:37 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (f0a4f00)

    lmtp: commands: Created local variable for client->dot_input in
    client_input_data_handle().


M	src/lmtp/commands.c

2017-10-30 01:19:18 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (7bb8793)

    lmtp: commands: Renamed client_input_add() to cmd_data_input_add().


M	src/lmtp/commands.c

2017-10-30 01:17:21 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (d8720e4)

    lmtp: commands: Renamed client_input_add_file() to
    cmd_data_input_add_file().


M	src/lmtp/commands.c

2017-10-30 01:13:33 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (d41037c)

    lmtp: commands: Renamed client_get_input() to cmd_data_get_input().


M	src/lmtp/commands.c

2017-10-23 00:36:16 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (755372f)

    lmtp: local: Renamed error variables in lmtp_local_rcpt_check_quota() to
    match other code.


M	src/lmtp/lmtp-local.c

2017-10-30 02:00:38 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (252a291)

    lmtp: local: Allocate recipients on the default pool, rather than the client
    state pool.

    This prevents the pool from growing potentially indefinitely with failed
    recipients.

M	src/lmtp/lmtp-local.c

2017-10-22 23:29:21 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (2b7d6fb)

    lmtp: Split off local delivery in a struct separate from the client.

    This mimics proxy delivery, making the implementation better structured.

M	src/lmtp/client.c
M	src/lmtp/client.h
M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h
M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-11-26 21:29:10 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (4bc2df9)

    lmtp: local: Renamed local variable "dest_user" to "rcpt_user" in
    lmtp_local_deliver().

    This matches the rcpt_user field in struct mail_deliver_context.

M	src/lmtp/lmtp-local.c

2017-09-19 03:56:39 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (28585a4)

    lmtp: local: Created local variable for service_user in
    lmtp_local_deliver().


M	src/lmtp/lmtp-local.c

2017-09-19 03:53:45 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (cfc330f)

    lmtp: local: Renamed trans variable in lmtp_local_open_raw_mail().

    Preparation for new trans parameter.

M	src/lmtp/lmtp-local.c

2017-09-19 03:33:12 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (dafe330)

    lmtp: local: Renamed client_deliver_to_rcpts() to
    lmtp_local_deliver_to_rcpts().


M	src/lmtp/lmtp-local.c

2017-09-19 02:07:22 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (ce7a45d)

    lmtp: client: Dropped useless rcpt_idx state.

    Recent refactoring made it obsolete.

M	src/lmtp/client.h
M	src/lmtp/lmtp-local.c

2017-09-19 00:29:02 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (6fe14de)

    lmtp: local: Always handle sending of error replies inside
    lmtp_rcpt_to_is_over_quota().

    Code was confusing.

M	src/lmtp/lmtp-local.c

2017-09-19 03:40:56 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (d5ddc86)

    lmtp: local: Renamed cmd_rcpt_finish() to lmtp_local_rcpt_anvil_finish().


M	src/lmtp/lmtp-local.c

2017-09-19 03:29:03 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (eb61a9e)

    lmtp: local: Renamed rcpt_anvil_lookup_callback() to
    lmtp_local_rcpt_anvil_cb().


M	src/lmtp/lmtp-local.c

2017-09-18 23:16:21 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (bc1306f)

    lmtp: commands: Moved RCPT command handling relating to local recipients to
    lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-18 22:51:30 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (70dfae6)

    lmtp: client: Moved recipient deinitialization to lmtp-local.c.


M	src/lmtp/client.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-19 03:21:39 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (fd3bad1)

    lmtp: local: Renamed lmtp_rcpt_to_is_over_quota() to
    lmtp_local_rcpt_check_quota().


M	src/lmtp/lmtp-local.c

2017-09-19 01:33:28 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (8a68f5b)

    lmtp: local: Renamed client_input_data_write_local() to lmtp_local_data().


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-19 01:07:17 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (d14a896)

    lmtp: local: Renamed client_open_raw_mail() to lmtp_local_open_raw_mail().


M	src/lmtp/lmtp-local.c

2017-09-19 00:59:27 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e5f4eb1)

    lmtp: local: Renamed client_deliver() to lmtp_local_deliver().


M	src/lmtp/lmtp-local.c

2017-09-18 22:40:41 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (95b2dd3)

    lmtp: local: Renamed client_rcpt_anvil_disconnect() to
    lmtp_local_rcpt_anvil_disconnect().


M	src/lmtp/client.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-10-30 23:06:50 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (652962c)

    lmtp: proxy: Changed return type of lmtp_proxy_rcpt() from bool to int.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-09-18 22:32:43 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e416140)

    lmtp: proxy: Renamed client_proxy_rcpt() to lmtp_proxy_rcpt().


M	src/lmtp/commands.c
M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-09-18 22:29:29 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (2f73bf1)

    lmtp: proxy: Renamed client_proxy_is_ourself() to lmtp_proxy_is_ourself().


M	src/lmtp/lmtp-proxy.c

2017-09-18 22:27:41 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (582f781)

    lmtp: proxy: Renamed client_proxy_rcpt_parse_fields() to
    lmtp_proxy_rcpt_parse_fields().


M	src/lmtp/lmtp-proxy.c

2017-09-18 22:04:58 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (447ae13)

    lmtp: Renamed struct mail_recipient to struct lmtp_recipient.


M	src/lmtp/client.c
M	src/lmtp/client.h
M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-10-31 02:37:40 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (bb0a27c)

    lmtp: proxy: Added structural comments.


M	src/lmtp/lmtp-proxy.c

2017-09-18 21:14:05 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (1c1396e)

    lmtp: local: Added structural comments.


M	src/lmtp/lmtp-local.c

2017-09-17 14:28:33 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (ebdfdb7)

    lmtp: commands: Added structural comments.


M	src/lmtp/commands.c

2016-11-23 10:43:53 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (124a7f9)

    lmtp: proxy: Removed dns_client_socket_path from struct lmtp_proxy_settings.

    It is globally accessible.

M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-10-10 00:36:37 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (3a1c078)

    lmtp: client: Moved soon-to-be-obsolete output handling functions to end of
    the file.


M	src/lmtp/client.c
M	src/lmtp/client.h

2017-09-17 19:03:06 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (eac03bb)

    lmtp: client: Moved soon-to-be-obsolete input handling functions to end of
    the file.


M	src/lmtp/client.c
M	src/lmtp/client.h

2017-09-17 18:39:08 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (27d5414)

    lmtp: client: Moved client_state_reset().


M	src/lmtp/client.c

2017-10-31 02:20:44 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (a33e180)

    lmtp: proxy: Moved lmtp_proxy_connection_finish().


M	src/lmtp/lmtp-proxy.c

2016-11-23 10:58:02 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (1b8cec4)

    lmtp: proxy: Moved lmtp_proxy_rcpt_cb().


M	src/lmtp/lmtp-proxy.c

2017-10-31 02:29:54 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b6e6966)

    lmtp: proxy: Moved lmtp_proxy_add_rcpt().


M	src/lmtp/lmtp-proxy.c

2017-10-31 02:27:47 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (122323b)

    lmtp: proxy: Moved lmtp_proxy_data_cb().


M	src/lmtp/lmtp-proxy.c

2017-10-31 02:26:12 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (65ff3f6)

    lmtp: proxy: Moved lmtp_proxy_data_dummy_cb().


M	src/lmtp/lmtp-proxy.c

2016-11-06 17:34:25 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (5f2855f)

    lmtp: Moved code relating to proxy from commands.c to lmtp-proxy.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-09-17 11:40:53 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (cbd1d1a)

    lmtp: Moved client_input_data_write_local() from commands.c to lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-17 11:13:17 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e3d554c)

    lmtp: Moved client_open_raw_mail() from commands.c to lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-18 23:48:51 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (420dc25)

    lmtp: Moved client_rcpt_fail_all() from commands.c to lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-17 10:52:43 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (fb2e20a)

    lmtp: Moved client_deliver_to_rcpts() from commands.c to lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-17 10:29:15 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (4c10d20)

    lmtp: Moved client_deliver() from commands.c to lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-17 02:57:29 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (a3259cc)

    lmtp: Moved rcpt_anvil_lookup_callback() from commands.c to lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-17 02:11:58 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (1d2e367)

    lmtp: Moved cmd_rcpt_finish() from commands.c to lmtp-local.c.


M	src/lmtp/commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-local.h

2017-09-17 00:07:34 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (0029bf6)

    lmtp: Moved client_rcpt_anvil_disconnect() from client.c to lmtp-local.c.


M	src/lmtp/Makefile.am
M	src/lmtp/client.c
M	src/lmtp/client.h
A	src/lmtp/lmtp-local.c
A	src/lmtp/lmtp-local.h

2016-11-23 10:22:21 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (4df5abb)

    lmtp: Moved lmtp_anvil_init() from commands.c to main.c.

    It fits better there.

M	src/lmtp/commands.c
M	src/lmtp/main.c
M	src/lmtp/main.h

2017-10-10 02:53:56 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (24afb81)

    lmtp: client: Use client_remote_id() to construct proctitle.


M	src/lmtp/client.c

2017-10-10 00:19:02 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (0807987)

    lmtp: client: Moved client_remote_id().


M	src/lmtp/client.c

2017-10-10 02:36:34 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (942b4f4)

    lmtp: client: Restructured client_state_set() to match
    imap_refresh_proctitle().


M	src/lmtp/client.c

2017-10-10 02:21:34 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (7affd5e)

    lmtp: client: Restructured handling of verbose_proctitle setting.


M	src/lmtp/client.c

2017-12-05 14:49:17 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (8b41f8f)

    lib-smtp: common: Added support for having custom fields in struct
    smtp_proxy_data.


M	src/lib-smtp/smtp-common.h

2017-12-04 11:01:31 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (4a31bc0)

    pop3: Include mail user variables in logout format


M	src/pop3/pop3-client.c

2017-12-04 11:01:05 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (ee1950c)

    imap: Include mail user variables in logout format


M	src/imap/imap-client.c

2017-12-05 23:49:27 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (857a9e1)

    lib: var-expand - Add table size and merge utility functions


M	src/lib/test-var-expand.c
M	src/lib/var-expand.c
M	src/lib/var-expand.h

2017-12-07 01:44:56 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (5644698)

    lib-http: test-http-payload: Added tests for running multiple clients in
    parallel with shared context.


M	src/lib-http/test-http-payload.c

2017-12-06 23:43:18 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (58e3ba7)

    lib-http: test-http-payload: Added support for running multiple parallel
    clients.


M	src/lib-http/test-http-payload.c

2016-12-18 19:45:32 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (6776cc8)

    lib-http: client: Amended the top comment explaining the structure of the
    HTTP client.


M	src/lib-http/http-client.c

2016-12-04 21:54:02 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (fd30e54)

    lib-http: client: Added identifier to client log messages.


M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-peer.c
M	src/lib-http/http-client-private.h
M	src/lib-http/http-client-queue.c
M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c

2017-09-27 19:21:40 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (faa4f87)

    lib-http: test-http-client: Run several clients simultaneously.


M	src/lib-http/test-http-client.c

2017-09-27 19:21:24 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (27a2e59)

    lib-http: client: shared context: Allow sharing peer state between clients.


M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-peer.c
M	src/lib-http/http-client-private.h
M	src/lib-http/http-client-queue.c
M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c

2016-12-18 19:27:05 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (0a3bccd)

    lib-http: client: peer: Moved http_client_peer_reset_backoff_timer()
    function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 19:16:31 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (49088f4)

    lib-http: client: peer: Moved http_client_peer_increase_backoff_timer()
    function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 19:15:04 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (aa65356)

    lib-http: client: peer: Moved http_client_peer_start_backoff_timer()
    function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 19:13:00 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (4a9bd6a)

    lib-http: client: peer: Moved http_client_peer_connect_backoff() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-05 00:37:27 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (01cfa2e)

    lib-http: client: peer: Moved http_client_peer_get() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 18:50:31 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (9e1f103)

    lib-http: client: peer: Moved http_client_peer_drop() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 18:46:01 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (5a8d6f8)

    lib-http: client: peer: Moved http_client_peer_close() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 18:44:05 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (0dfe37d)

    lib-http: client: peer: Moved http_client_peer_unref() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 18:42:50 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (1be73c4)

    lib-http: client: peer: Moved http_client_peer_ref() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 18:41:37 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (4e62967)

    lib-http: client: peer: Moved http_client_peer_disconnect() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-18 18:40:19 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (90fa7fd)

    lib-http: client: peer: Moved http_client_peer_create() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-peer.c

2016-12-04 00:11:46 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (e481023)

    lib-http: client: shared context: Allow sharing host lookups between
    clients.


M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-private.h
M	src/lib-http/http-client-queue.c
M	src/lib-http/http-client.c

2016-12-04 12:51:02 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (2300bdf)

    lib-http: client: host: Moved http_client_host_submit_request() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-host.c

2016-12-04 12:40:29 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (fbe111c)

    lib-http: client: host: Moved http_client_host_check_idle() function.

    This is a preparation for a subsequent change.

M	src/lib-http/http-client-host.c

2016-11-30 02:04:11 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (23fe024)

    lib-http: client: Avoid direct access to host object members from queue.


M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-private.h
M	src/lib-http/http-client-queue.c

2016-11-29 19:29:25 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (20493a5)

    lib-http: client: Moved connection pool handling from peer to separate
    object.


M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-peer.c
M	src/lib-http/http-client-private.h

2016-11-29 18:13:30 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (9fe6a55)

    lib-http: client: Moved connection list from client to shared context.


M	src/lib-http/http-client-connection.c
M	src/lib-http/http-client-private.h
M	src/lib-http/http-client.c

2016-11-29 16:17:59 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (fab1a1c)

    lib-http: client: Created basic shared context between clients.

    In this basic form it only shares default settings.

M	src/lib-http/http-client-private.h
M	src/lib-http/http-client.c
M	src/lib-http/http-client.h

2016-12-04 19:35:30 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (63a1359)

    lib-http: client: Cosmetic changes to http-client-private.h.


M	src/lib-http/http-client-private.h

2016-12-04 16:00:49 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (3ad0a46)

    lib-http: client: Simplified initiation of connection setup upon request
    submission.


M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-queue.c

2016-12-04 12:03:18 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (8149ed5)

    lib-http: client: Created separate http_client_queue_get() function.

    Before, this was combined in http_client_queue_create() which caused a large
    code block to be indentet. Separating creation and obtaining the current
    instance makes the code cleaner.

M	src/lib-http/http-client-host.c
M	src/lib-http/http-client-private.h
M	src/lib-http/http-client-queue.c

2016-11-29 17:22:41 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (d67f004)

    lib-http: client: Fixed whitespace in the top comment explaining the
    structure of the HTTP client.


M	src/lib-http/http-client.c

2017-12-07 09:48:51 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (cae3c69)

    driver-cassandra: Free statement pool on update

    Otherwise the pool memory will leak. This was happening with non-prepared 
    statements when version was older than 4.

M	src/lib-sql/driver-cassandra.c

2017-12-07 08:20:02 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (7cc5fcc)

    lib-http: test-http-client - conditionally depend on openssl

    Fixes compiling without openssl, broken by c45da70c

M	src/lib-http/test-http-client.c

2017-12-06 17:41:14 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (8006436)

    auth: passdb-ldap - Fix AUTH_LOG_MSG_PASSWORD_MISMATCH use in logging


M	src/auth/passdb-ldap.c

2017-04-04 12:40:10 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (ab5c28d)

    auth: Fix 'Password mismatch' casing consistency


M	src/auth/auth-request.c
M	src/auth/auth-request.h
M	src/auth/mech-cram-md5.c
M	src/auth/mech-digest-md5.c
M	src/auth/mech-scram-sha1.c
M	src/auth/passdb-ldap.c
M	src/auth/passdb-pam.c
M	src/auth/password-scheme.c
M	src/auth/password-scheme.h

2017-11-28 11:39:52 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (6699d5a)

    auth: Fix auth_request_is_disabled_master_user

    I assumed that lack of passdb means master authentication, but e.g. gssapi
    does not require a passdb. Instead, check that if requested_login_uset is
    non-null then check passdb is non-null too.

    Fixes auth: Panic: file auth-request.c: line 716
    (auth_request_is_disabled_master_user): assertion failed:
    (request->requested_login_user != NULL)

M	src/auth/auth-request.c

2017-12-04 17:55:15 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (bfbd100)

    doveadm-pw: Use CRYPT instead of CRAM-MD5 by default

    This is when generating new passwords.

M	src/doveadm/doveadm-pw.c

2017-12-04 18:39:24 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (4bed0c5)

    auth: Use bcrypt as default scheme for CRYPT scheme

    Only changes the type of password which is generated by default, password
    verification is not changed.

M	src/auth/password-scheme-crypt.c

2017-12-04 18:38:36 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (cfb22f2)

    auth: Rename CRYPT scheme to DES-CRYPT


M	src/auth/password-scheme-crypt.c
M	src/auth/test-libpassword.c

2017-11-29 15:20:29 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (12a1ee0)

    lib-storage: Log an error when mailbox list index is rebuilt due to header
    fsck flag


M	src/lib-storage/list/mailbox-list-index.c

2017-11-29 15:14:02 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b42817c)

    lib-storage: Rebuild list index when doing doveadm force-resync


M	src/lib-storage/list/mailbox-list-index-backend.c
M	src/lib-storage/list/mailbox-list-index.h
M	src/lib-storage/mail-storage-private.h

2017-11-29 14:51:02 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8049d57)

    LAYOUT=index: Rebuild list index if INBOX is missing on inbox=yes namespace

    This avoids having to manually rebuild the list index afterwards if it 
    becomes lost.

M	src/lib-storage/list/mailbox-list-index.c
M	src/lib-storage/list/mailbox-list-index.h
M	src/lib-storage/mail-storage-private.h

2017-11-29 14:36:25 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (82d1fe3)

    lib-storage: Rename mail_storage.list_index_corrupted() to
    list_index_rebuild()

    Also add a new parameter to it to specify the rebuild reason.

M	src/lib-storage/list/mailbox-list-index.c
M	src/lib-storage/mail-storage-private.h

2017-11-29 14:38:38 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2303cd3)

    lib-storage: Remove obsolete comment


M	src/lib-storage/list/mailbox-list-index.c

2017-11-30 12:52:23 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (05b5b75)

    auth: passdb-lua - Fix mistake in nopassword handling

    If nopassword is given, check that password is not set. Previous code did
    the opposite.

    Fixes Info: lua(): nopassword given and password is not empty

M	src/auth/passdb-lua.c

2017-12-04 19:05:55 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (208b68b)

    auth: Set cache key for lua auth database


M	src/auth/db-lua.h
M	src/auth/passdb-lua.c
M	src/auth/userdb-lua.c

2017-12-01 20:51:44 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (c9a7c4d)

    lib: murmurhash3 - Fix Aki's email address


M	src/lib/murmurhash3.c

2017-12-01 18:15:18 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (0351233)

    lib: Add fall through comments to murmurhash3.c to fix gcc-7 warnings


M	src/lib/murmurhash3.c

2017-12-01 11:53:50 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (aa6cd0d)

    lib: murmurhash3 - Fix 128 bit hash on 32 bit systems


M	src/lib/murmurhash3.c

2017-11-27 18:26:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (aa39987)

    doveadm-server: Switch to TCP connection's ioloop while sending logs to
    remote

    Fixes: Warning: I/O leak: 0x558d7c074ed0 (ostream-file.c:349, fd 16) Panic:
    file ioloop.c: line 127 (io_remove_full): assertion failed: (io->callback !=
    NULL)

M	src/doveadm/client-connection-tcp.c

2017-11-29 16:29:17 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (a8cad12)

    lib: randgen - Fallback to /dev/urandom in case getrandom does not work

    In some operating systems getrandom is defined, but not implemented, if this
    happens, fallback into using /dev/urandom.

M	src/lib/randgen.c

2017-11-27 13:46:40 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (44d29bb)

    lib: Add bloom filter support


M	src/lib/Makefile.am
A	src/lib/bloomfilter.c
A	src/lib/bloomfilter.h
A	src/lib/test-bloomfilter.c
M	src/lib/test-lib.inc

2017-11-27 13:46:17 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (f6de86e)

    lib: Add murmurhash3 support

    Needed for bloom filters

M	src/lib/Makefile.am
A	src/lib/murmurhash3.c
A	src/lib/murmurhash3.h
M	src/lib/test-lib.inc
A	src/lib/test-murmurhash3.c

2017-11-27 13:45:56 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (f157771)

    lib: bits - add circular rotation functions


M	src/lib/bits.h
M	src/lib/test-bits.c

2017-11-21 13:27:18 +0200 Sergey Kitov <sergey.kitov@open-xchange.com> (df65573)

    lib: Call prctl(PR_SET_DUMPABLE) only when PR_SET_DUMPABLE env variable is
    set


M	src/lib/restrict-access.c

2017-11-22 11:34:47 +0200 Sergey Kitov <sergey.kitov@open-xchange.com> (f5cc540)

    lib: Add logging of prctl(PR_SET_DUMPABLE) failure.


M	src/lib/restrict-access.c

2017-11-29 09:00:08 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (df0eef6)

    auth: test-lua - fix memory leaks


M	src/auth/test-lua.c

2017-11-28 01:04:53 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (80bd4f8)

    lib-smtp: client: Fixed sending payload with unknown size using the CHUNKING
    capability.


M	src/lib-smtp/smtp-client-command.c

2017-11-28 01:03:48 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (11142fd)

    lib-smtp: client: command: Implemented callback that is called when command
    is fully sent.


M	src/lib-smtp/smtp-client-command.c
M	src/lib-smtp/smtp-client-command.h
M	src/lib-smtp/smtp-client-private.h

2017-11-27 21:03:52 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (1fc55bf)

    lib-smtp: client: transaction: Fix adding a recipient while the transaction
    is already failed.

    This did not always trigger an immediate callback.

M	src/lib-smtp/smtp-client-transaction.c

2017-11-28 21:15:17 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (ecfca41)

    auth: test-lua - zero out auth settings in test

    Otherwise valgrind complains

M	src/auth/test-lua.c

2017-11-28 19:01:19 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4ccb618)

    director: Fix logging disconnection error reasons

    The previous commit set errno=0, which weren't logged. If error string is 
    provided, it doesn't matter what the errno is set (as long as it's not 0), 
    so we'll just use EINVAL.

M	src/director/director-connection.c

2017-11-28 13:45:42 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (acc6105)

    lib: mempool-alloconly - Make sure calloc() size isn't above SSIZE_T_MAX

    This avoids valgrind warnings when running unit tests:

    Argument 'nmemb' of function calloc has a fishy (possibly negative) value:
    -9223372036854775808

M	src/lib/mempool-alloconly.c

2017-11-28 16:51:46 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (04e49d6)

    auth: userdb-lua - Fix typo in logging


M	src/auth/userdb-lua.c

2017-11-28 16:51:06 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (e99ddf2)

    auth: userdb-lua - Log error if lookup fails

    Previously the error would just be discarded.

M	src/auth/userdb-lua.c

2017-11-28 16:50:13 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (c86575a)

    auth: db-lua - Fix password scheme handling

    It was left as NULL and had misleading name in some of the handler functions
    causing assert-crash.

M	src/auth/db-lua.c

2017-11-28 16:48:19 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (c2cda3f)

    auth: db-lua - fix auth request registration

    It was registered in wrong manner so one could not easily extend it with
    passdb and userdb subtables.

    The change itself was to change the object to a table, and register the
    actual pointer as light userdata under index 'item', and the passdb and
    userdb tables similarly with 'item' in each holding the pointer to request.

M	src/auth/db-lua.c

2017-11-28 13:44:06 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (6dd6dac)

    auth: db-lua - Do not assume params is always present for passdb/userdb
    field lookup


M	src/auth/db-lua.c

2017-11-28 16:07:12 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c8d80ba)

    lib: Fix mempool unit tests to pass with 32bit OSes

    malloc(SSIZE_T_MAX) actually succeeds there, so we can't test it.

M	src/lib/test-mempool-allocfree.c
M	src/lib/test-mempool-alloconly.c

2017-11-17 11:37:45 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (08259c1)

    lib: rename bswap_*() to i_bswap()


M	src/lib/byteorder.h
M	src/lib/test-byteorder.c

2017-11-28 15:06:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1a85ac6)

    director: Log connection stats for all types of disconnections


M	src/director/director-connection.c

2017-11-28 14:57:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (43edd10)

    director: Log whether connection is synced when it's being disconnected.


M	src/director/director-connection.c

2017-11-28 13:10:35 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (0bd3eb7)

    director: Fix crash when handling expired USER timestamps.

    The fix in 154f91726624265fce15097eb4bbbf6e55f8c477 wasn't complete.

M	src/director/director-connection.c

2017-11-24 13:22:19 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (a4fa567)

    password-scheme-sodium: ARGON2I - print errno on failure


M	src/auth/password-scheme-sodium.c

2017-11-24 13:18:16 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (66db268)

    password-scheme-sodium: Support ARGON2ID when available


M	src/auth/password-scheme-sodium.c
M	src/auth/test-libpassword.c

2017-11-24 12:50:00 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (2437015)

    password-scheme-sodium: rename ARGON2 to ARGON2I


M	src/auth/password-scheme-sodium.c
M	src/auth/test-libpassword.c

2017-11-24 12:47:58 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (1806d8f)

    password-scheme-sodium: Call sodium_init to improve performance


M	src/auth/password-scheme-sodium.c

2017-10-28 20:58:58 +0200 Frank Denis <github@pureftpd.org> (b2c5e11)

    configure: --with-sodium doesn't add support for scrypt (for now, at least)


M	configure.ac

2017-11-27 18:34:49 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3c1077b)

    doveadm-server: Fix potential dsync-server panic at deinit

    If the ostream is still used (e.g. for logging) after dsync is finished, it 
    crashed with:

    Panic: file ostream.c: line 276 (o_stream_sendv_int): assertion failed:
    (!_stream->finished)

M	src/doveadm/doveadm-dsync.c

2017-11-25 15:57:16 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (981f260)

    pop3-login: Properly recognize an empty SASL initial response.

    Pass only the empty string to the auth service and not "=".

M	src/pop3-login/client-authenticate.c

2017-11-25 15:55:41 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (ad3e5fb)

    imap-login: Properly recognize an empty SASL initial response.

    Pass only the empty string to the auth service and not "=".

M	src/imap-login/client-authenticate.c

2017-11-25 15:28:32 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (e4b72bd)

    auth: Properly recognize an empty initial SASL response.

    It was erroneously handled as an absent initial response. Restructured the
    code for clarity and changed the comments: '=' should not be passed to SASL
    layer at all.

M	src/auth/auth-request-handler.c

2017-11-25 18:13:04 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (451698c)

    lib: strfuncs: Fixed value of uchar_empty_ptr not to be NULL.


M	src/lib/strfuncs.c

2017-11-27 21:11:30 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (76553b1)

    lmtp: proxy: Fix connection settings comparison in
    lmtp_proxy_get_connection() when hostip field is set.

    The IP in the hostip field overrides the host setting, which broke the
    comparison.

M	src/lmtp/lmtp-proxy.c

2017-11-27 15:17:52 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e4a7dbe)

    lib: mempool-alloconly - Cleanly fail allocations just below SSIZE_T_MAX

    Previously it would have assert-crashed in nearest_power().

M	src/lib/mempool-alloconly.c

2017-11-27 15:14:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ba1a5db)

    lib: Use test_expect_fatal_string() for all fatal unit tests


M	src/lib/test-array.c
M	src/lib/test-data-stack.c
M	src/lib/test-malloc-overflow.c
M	src/lib/test-mempool-allocfree.c
M	src/lib/test-mempool-alloconly.c
M	src/lib/test-mempool.c
M	src/lib/test-printf-format-fix.c

2017-11-27 15:12:45 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a7d1bd5)

    lib: Fix mempool-alloconly & mempool-allocfree unit tests

    The "physically impossible size" test was supposed to test calloc()==NULL 
    failure, but in reality it was triggering asserts before that.

M	src/lib/test-mempool-allocfree.c
M	src/lib/test-mempool-alloconly.c

2017-11-27 15:11:40 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ac72c14)

    lib: mempool-allocfree - If calloc() fails, include "Out of memory" in the
    log line


M	src/lib/mempool-allocfree.c

2017-11-27 14:48:25 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f296964)

    lib: Fix logging panic message if data stack canary corruption is detected

    The previous code just recursed into the same canary corruption check and 
    didn't end up logging anything.

M	src/lib/data-stack.c

2017-11-27 14:42:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (86ec225)

    lib: Make sure panics/fatals don't recurse into loops


M	src/lib/failures.c

2017-11-27 14:24:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (37bf0a2)

    lib-test: Add test_expect_fatal_string()


M	src/lib-test/test-common.c
M	src/lib-test/test-common.h

2017-11-27 14:23:39 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a9a4210)

    lib-test: Cleanup - Move expected_error_str check to its own function


M	src/lib-test/test-common.c

2017-11-21 22:13:17 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (86ad487)

    lib-dcrypt: test-crypto and test-stream need lib-ssl-iostream.a fully

    Otherwise the .so file cannot be loaded due to missing symbols

M	src/lib-dcrypt/Makefile.am

2017-11-21 22:12:56 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (a40a477)

    login-common: Do not link lib-ssl-iostream.la twice

    It's already in libdovecot.la

M	src/login-common/Makefile.am

2017-11-24 08:51:14 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (83b6900)

    configure: Detect --whole-archive in linker


M	configure.ac
A	m4/ld_whole_archive.m4

2017-11-24 09:00:24 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (dbb1816)

    m4: Use CC, not CXX in ld_relro


M	m4/ld_relro.m4

2017-11-27 17:42:14 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (24ede7e)

    replicator: Keep user referenced while dsync is running

    Fixes a crash when user is removed with "doveadm replicator remove" while
    dsync is still running.

M	src/replication/replicator/replicator-brain.c

2017-11-27 17:42:06 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9b2129d)

    replicator: Add refcounting to user


M	src/replication/replicator/replicator-queue.c
M	src/replication/replicator/replicator-queue.h

2017-11-27 01:38:09 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (e40c4ca)

    lmtp: proxy: Fixed use of hostip field after changing the implementation to
    use lib-smtp/client broke it.

    Proxy was erroneously doing DNS queries while hostip field was returned from
    passdb.

M	src/lmtp/lmtp-proxy.c

2017-11-27 11:45:05 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (9336026)

    lmtp: proxy: Fixed proxying reply from backend server.

    It contained an additional CRLF, which caused problems.

M	src/lmtp/lmtp-proxy.c

2017-11-27 11:44:23 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (57b18ec)

    lib-smtp: Implemented function to write an SMTP reply as a single line.

    Needed for proxying in current LMTP code.

M	src/lib-smtp/smtp-reply.c
M	src/lib-smtp/smtp-reply.h

2017-11-27 14:57:09 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (c0660f1)

    configure: Fix Lua conditionals


M	configure.ac
M	m4/want_lua.m4
M	src/auth/Makefile.am
M	src/auth/test-lua.c
M	src/lib-lua/Makefile.am

2017-11-27 14:56:07 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (d5b0387)

    configure: Drop LuaJIT support

    Does not work with our custom allocator

M	configure.ac
M	m4/want_lua.m4

2017-11-27 12:32:54 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (6b98c59)

    lib: mempool-allocfree - include overhead in size check

    Found by valgrind

M	src/lib/mempool-allocfree.c

2017-11-27 11:58:39 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b211703)

    director: Fix logging of uninitialized PONG buffer size

    PONG always has 0 or 2 parameters. The easiest fix here is to just not even 
    try to support 1 parameter.

M	src/director/director-connection.c

2017-11-27 00:54:56 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (606ce50)

    lib-smtp: client: Fixed cleanup of untriggered transaction timeout.


M	src/lib-smtp/smtp-client-transaction.c

2017-11-26 23:00:30 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (769f5c2)

    director: Fix delayed request count in ps title after request timeouts

    The timeouts weren't shrinking the delayed request count. This didn't cause 
    any other problems.

M	src/director/director-request.c

2017-11-25 01:59:47 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e4e8301)

    lib-program-client: Ignore ostream error handling


M	src/lib-program-client/program-client.c

2017-10-29 18:36:25 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (9051b70)

    lib-smtp: Implemented test suite for client errors.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/test-smtp-client-errors.c

2017-11-05 21:51:02 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (6f08629)

    lib-test: Reset expected errors state at each test.


M	src/lib-test/test-common.c

2017-11-08 01:51:19 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (9e33e0a)

    lib-lda: Added support for message submission with SSL.


M	src/lib-lda/Makefile.am
M	src/lib-lda/mail-send.c

2017-05-07 14:58:05 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (ac8f4f3)

    lib-smtp: smtp-submit: Added SSL support.


M	src/lib-lda/mail-send.c
M	src/lib-smtp/smtp-submit-settings.c
M	src/lib-smtp/smtp-submit-settings.h
M	src/lib-smtp/smtp-submit.c
M	src/lib-smtp/smtp-submit.h
M	src/lib-smtp/test-smtp-submit.c

2017-09-16 20:10:39 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (eea481b)

    lib-smtp: smtp-submit: Use mail_debug setting to enable debug logging.

    When sendmail is used, this logs program_client debug messages. When SMTP is
    used (submission_host), this logs smtp_client debug messages.

M	src/lib-smtp/smtp-submit-settings.c
M	src/lib-smtp/smtp-submit-settings.h
M	src/lib-smtp/smtp-submit.c
M	src/lib-smtp/test-smtp-submit.c

2017-09-16 20:09:22 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (bce4997)

    lib-smtp: Dropped old lmtp-client.

    It is now unused.

M	src/lib-smtp/Makefile.am
D	src/lib-smtp/lmtp-client.c
D	src/lib-smtp/lmtp-client.h

2017-01-22 15:27:29 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (09cd817)

    lmtp: proxy: Changed implemention to use lib-smtp/smtp-client.


M	src/lmtp/client.h
M	src/lmtp/commands.c
M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-proxy.h

2017-01-22 15:26:32 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (7c8257b)

    lib-smtp: smtp-submit: Changed submission_host implementation to use
    lib-smtp/smtp-client.


M	src/lib-lda/mail-send.c
M	src/lib-smtp/smtp-submit.c
M	src/lib-smtp/smtp-submit.h
M	src/lib-smtp/test-smtp-submit.c

2017-11-20 23:30:37 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (70eaddb)

    lib-smtp: smtp-submit: Small whitespace fix.


M	src/lib-smtp/test-smtp-submit.c

2017-11-04 14:38:39 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (211fdbe)

    lib-smtp: smtp-submit: Remove erroneously copy-pasted FIXMEs.


M	src/lib-smtp/test-smtp-submit.c

2016-11-06 22:15:45 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (b388894)

    lib-smtp: Implemented SMTP client.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-client-command.c
A	src/lib-smtp/smtp-client-command.h
A	src/lib-smtp/smtp-client-connection.c
A	src/lib-smtp/smtp-client-connection.h
A	src/lib-smtp/smtp-client-private.h
A	src/lib-smtp/smtp-client-transaction.c
A	src/lib-smtp/smtp-client-transaction.h
A	src/lib-smtp/smtp-client.c
A	src/lib-smtp/smtp-client.h
M	src/lib-smtp/smtp-common.h

2016-11-06 22:00:08 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (a843339)

    lib-smtp: Implemented SMTP command reply parser.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-reply-parser.c
A	src/lib-smtp/smtp-reply-parser.h
A	src/lib-smtp/smtp-reply.c
A	src/lib-smtp/smtp-reply.h
A	src/lib-smtp/test-smtp-reply-parser.c

2017-10-18 01:03:03 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (ad8d206)

    lmtp: commands: Grouped deliver context field assignments by topic in
    client_deliver().


M	src/lmtp/commands.c

2016-11-06 19:09:30 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (de0971a)

    lib-lda: Added SMTP parameter fields to struct mail_deliver_context.

    This moves the original recipient field inside the SMTP parameters. This
    also affects both lda and lmtp. Changes are applied there accordingly.

M	src/lda/main.c
M	src/lib-lda/mail-deliver.c
M	src/lib-lda/mail-deliver.h
M	src/lmtp/client.h
M	src/lmtp/commands.c

2016-11-06 21:39:07 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (39bf540)

    lib-smtp: Implemented parsing, manipulation, and encoding for SMTP command
    parameters.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-common.c
A	src/lib-smtp/smtp-common.h
A	src/lib-smtp/smtp-params.c
A	src/lib-smtp/smtp-params.h
A	src/lib-smtp/test-smtp-params.c

2016-11-06 21:29:59 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (3e2f715)

    lib-smtp: Implemented parsing and encoding for common SMTP syntax elements.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-syntax.c
A	src/lib-smtp/smtp-syntax.h

2016-11-06 13:45:57 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (c663687)

    lib-lda: mail-send: Changed recipient argument type of mail_send_rejection()
    to struct smtp_address.


M	src/lda/main.c
M	src/lib-lda/mail-send.c
M	src/lib-lda/mail-send.h

2017-10-29 23:39:55 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (ca3aed4)

    lib-mail: message-address: Dropped message_detail_address_parse(), since it
    is no longer used.


M	src/lib-mail/message-address.c
M	src/lib-mail/message-address.h
M	src/lib-mail/test-message-address.c

2017-10-29 23:41:44 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (52f6112)

    plugins/quota: quota-status service: Changed recipient address parsing to
    use lib-smtp.


M	src/plugins/quota/Makefile.am
M	src/plugins/quota/quota-status.c

2016-11-05 14:47:53 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (3d7828e)

    lib-lda: Changed struct mail_deliver_context address fields to use the new
    struct smtp_address type.


M	src/lda/Makefile.am
M	src/lda/main.c
M	src/lib-lda/Makefile.am
M	src/lib-lda/mail-deliver.c
M	src/lib-lda/mail-deliver.h
M	src/lib-lda/mail-send.c
M	src/lmtp/client.h
M	src/lmtp/commands.c

2016-11-04 18:35:59 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (033c07c)

    lda: Renamed variables and parameters for consistency with lib-smtp.


M	src/lda/main.c

2016-11-03 00:20:55 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (a77f136)

    lib-lda: Renamed struct mail_deliver_context fields for consistency with
    lib-smtp.

    New fields are added in subsequent commits.

M	src/lda/main.c
M	src/lib-lda/mail-deliver.c
M	src/lib-lda/mail-deliver.h
M	src/lib-lda/mail-send.c
M	src/lmtp/commands.c

2016-11-04 18:16:52 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (d13bee3)

    lmtp: Removed lmtp_address_translate setting.

    It is assumed not to be used.

M	src/lmtp/commands.c
M	src/lmtp/lmtp-settings.c
M	src/lmtp/lmtp-settings.h

2017-11-05 02:00:43 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (fbad2d1)

    lib-mail: message-address: Added convenience functions that convert (single)
    addresses to string.


M	src/lib-mail/message-address.c
M	src/lib-mail/message-address.h

2017-10-19 15:20:04 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (cc77c1c)

    lib-mail: message-address: Added functions to initialize a struct
    message_address.


M	src/lib-mail/Makefile.am
M	src/lib-mail/message-address.c
M	src/lib-mail/message-address.h

2017-10-29 23:37:47 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (61ae3dd)

    lib-smtp: address: Created SMTP address detail parsing function from
    message_detail_address_parse().


M	src/lib-smtp/smtp-address.c
M	src/lib-smtp/smtp-address.h
M	src/lib-smtp/test-smtp-address.c

2016-11-06 21:15:41 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (03f08e4)

    lib-smtp: Implemented parsing, manipulation and encoding of SMTP addresses.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-address.c
A	src/lib-smtp/smtp-address.h
A	src/lib-smtp/test-smtp-address.c

2016-11-06 21:08:11 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (93bedc8)

    lib-smtp: Implemented generic parser for basic SMTP data items.


M	src/lib-smtp/Makefile.am
A	src/lib-smtp/smtp-parser.c
A	src/lib-smtp/smtp-parser.h

2017-10-27 19:43:43 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (4b9e7a8)

    lib: connection: Added means to initialize connection to just be added to
    the connection list.


M	src/lib/connection.c
M	src/lib/connection.h

2017-10-19 14:04:20 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e98ba66)

    lib-storage: Make parsed postmaster_address available in
    mail_storage_settings->parsed_postmaster_address.


M	src/config/Makefile.am
M	src/lib-lda/mail-send.c
M	src/lib-storage/mail-storage-settings.c
M	src/lib-storage/mail-storage-settings.h
M	src/plugins/mail-crypt/test-mail-key.c

2017-10-21 13:13:00 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (3c00329)

    lib-settings: Added support for running checks after variable expansion.


M	src/lib-settings/settings-parser.c
M	src/lib-settings/settings-parser.h

2017-11-22 21:02:07 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (6ee9106)

    lmtp: Accept XCLIENT ADDR field IPv6 address both with and without "IPV6:"
    prefix.

    This is the format that Postfix actually prescribes. The new lib-smtp will
    add the prefix by default.

M	src/lmtp/commands.c

2017-11-20 01:26:21 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (9ab7221)

    lib: llist: Fixed setting (after)->next->prev in DLLIST2_INSERT_AFTER_FULL.

    This function was not yet used, so the problem did not affect existing code.

M	src/lib/llist.h

2017-02-26 03:19:51 +0000 Josh Soref <jsoref@users.noreply.github.com> (29357a8)

    lib-settings: Fix spelling of 'expanded'


M	src/lib-master/master-service-settings.c
M	src/lib-settings/settings-parser.c
M	src/lib-settings/settings-parser.h

2017-11-26 02:11:57 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6895333)

    imap: Make sure command handlers are called with ostream corked

    This wasn't done when client input was continued. If COPY/MOVE was called 
    there, it crashed with:

    Panic: file cmd-copy.c: line 50 (fetch_and_copy): assertion failed:
    (o_stream_is_corked(client->output))

M	src/imap/imap-client.c

2017-11-26 12:33:33 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f0a2170)

    director: DIRECTOR-LIST - Return results sorted by host


M	src/director/doveadm-connection.c

2017-11-26 12:26:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (27f553b)

    director: DIRECTOR-LIST - Move connection/host output to their own functions


M	src/director/doveadm-connection.c

2017-11-26 12:36:54 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6e54fd2)

    director: Make director_host_cmp_p() public


M	src/director/director-host.c
M	src/director/director-host.h

2017-11-24 18:46:19 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (91b0bd6)

    director: Improve PING/PONG timeout errors and add new warnings

    Log a warning if PING-PONG takes over 5 secs in total, or also if the 
    recipient notices that the PING took >= 5 seconds to receive.

M	src/director/director-connection.c

2017-11-24 18:22:04 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2adcf55)

    director: Add director_ping_idle/max_timeout setting.

    director_ping_idle_timeout is used when there's otherwise no input coming 
    from the connection. Changed its default from 10 secs to 30 secs.

    director_ping_max_timeout is used when the other director keeps sending 
    input, but among it is no PONG reply.

M	src/director/director-connection.c
M	src/director/director-settings.c
M	src/director/director-settings.h

2017-11-24 18:18:45 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8506e63)

    director: Log exactly how long PING was waited on before it timed out.


M	src/director/director-connection.c

2017-11-26 12:20:26 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (193a587)

    director: DIRECTOR-LIST - Add "ring " prefix to self's status

    This is to make it a bit easier to understand the difference between a 
    connection's "handshaking" state vs. "ring handshaking" state.

M	src/director/doveadm-connection.c

2017-11-26 12:19:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5cdaaf2)

    director: DIRECTOR-LIST - Show number of USERs sent/received in
    "handshaking" state


M	src/director/director-connection.c
M	src/director/director-connection.h
M	src/director/doveadm-connection.c

2017-11-26 12:13:35 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e5ef6fa)

    director: Include number of users sent in handshake in disconnection log
    lines


M	src/director/director-connection.c

2017-11-26 03:45:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (dd19de9)

    director: Show number of incoming USERs/sec in ps title


M	src/director/director-connection.c
M	src/director/director.h
M	src/director/main.c

2017-11-25 23:28:12 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (58a1025)

    director: Include number of USERs received in disconnection log lines

    Separate handshake and refresh USERs.

M	src/director/director-connection.c

2017-11-25 10:01:31 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (14660f6)

    director: Don't send USERs in handshake that were already sent between
    handshake

    If the user was refreshed since the handshake was started, it means that the
    same user was already sent to the other side (added to the stream 
    immediately after it was received/handled). There's no need to send it 
    again.

    This fixes a potentally infinite handshake when users are rapidly changing 
    and the handshake iterator never sees the end of the list. (Each refreshed 
    user is moved to the end of the list, so handshaking can keep sending the 
    same user over and over again.)

M	src/director/director-connection.c
M	src/director/director.c
M	src/director/director.h
M	src/director/doveadm-connection.c
M	src/director/test-user-directory.c
M	src/director/user-directory.c
M	src/director/user-directory.h

2017-11-25 10:05:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (efd72f0)

    director: Delay sorting users until there are no more user iterators

    This shouldn't have normally happened. Only when an outgoing handshake was 
    going on at the same time as a) another outgoing handshake was going on, or 
    b) doveadm was doing HOST-RESET-USERS

M	src/director/user-directory.c

2017-11-26 01:31:08 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (edaa9f5)

    director: Avoid USER loops with >1s ring latency also with old directors

    Do this by ignoring USER refreshes that were already updated recently. The
    "recently" is calculated by director_user_expire/4 seconds ago, but with an
    upper limit of 15 secs. This means that the USER loops can now only exist if
    the director ring latency is above 15 seconds. (Once all directors in the
    ring are running the new version, there's no looping at any latency.)

M	src/director/director-connection.c

2017-11-26 01:19:35 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b3e3679)

    director: Avoid USER loops when ring latency is over 1 second

    Do this by adding a timestamp parameter to USER events. This way if it takes
    over 1 second for the USER event to traverse the ring, it won't get into an
    infinite loop getting the user updated over and over again.

M	src/director/director-connection.c
M	src/director/director.c
M	src/director/director.h
M	src/director/user-directory.h

2017-11-26 01:14:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (05b7b8f)

    director: Replace USER command during handshake with "U"

    This clearly differentiates the two commands and allows extending the USER 
    command with new parameters without mixing it up with the handshake-USER.

M	src/director/director-connection.c
M	src/director/director.h

2017-11-26 01:06:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (154f917)

    director: Ignore refresh requests for already expired user timestamps


M	src/director/director-connection.c

2017-11-17 13:24:59 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (94fb15f)

    director: Keep users unsorted during handshake and sort them at the end

    This is simpler and sometimes more efficient than the current way of 
    immediately inserting the users to the correct place in the linked list. 
    This is especially useful if handshaking is mixed with regular USER updates, 
    because each switch between them required walking the linked list backwards 
    to find the proper insert position.

    It's not a big problem if the users list is temporarily unordered. It mainly 
    means that some of the users won't be expired as early as they should have.

M	src/director/director-connection.c
M	src/director/user-directory.c

2017-11-17 18:53:18 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (0e94f6c)

    director: Make sure users are sorted after unfinished handshake

    The users were sorted after the handshake was finished, but if the 
    connection was closed before that hapepned, the users were left unsorted.
    This could have caused the users to not expire early enough.

M	src/director/director-connection.c

2017-11-17 14:56:20 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (04c8a95)

    director: Make sure user's timestamp isn't set to future

    The sending director could have the system clock slightly in the future.

M	src/director/director-connection.c

2017-11-21 23:07:56 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (c147bff)

    global: Use t_buffer_create

    sed -i -e 's/buffer_create_dynamic(pool_datastack_create(),
    */t_buffer_create(/g'

M	src/auth/auth-policy.c
M	src/auth/auth-request-handler.c
M	src/auth/auth-request-stats.c
M	src/auth/db-checkpassword.c
M	src/auth/password-scheme-scram.c
M	src/auth/password-scheme.c
M	src/config/old-set-parser.c
M	src/doveadm/client-connection-tcp.c
M	src/doveadm/doveadm-fs.c
M	src/doveadm/dsync/dsync-mailbox-state.c
M	src/imap-login/client-authenticate.c
M	src/lib-compression/test-compression.c
M	src/lib-dcrypt/dcrypt-openssl.c
M	src/lib-dcrypt/istream-decrypt.c
M	src/lib-dcrypt/ostream-encrypt.c
M	src/lib-dcrypt/test-crypto.c
M	src/lib-dict-backend/dict-sql.c
M	src/lib-imap-client/imapc-connection.c
M	src/lib-imap/imap-url.c
M	src/lib-index/mail-cache-fields.c
M	src/lib-index/mail-cache-lookup.c
M	src/lib-index/mail-cache-transaction.c
M	src/lib-index/mail-index-sync-keywords.c
M	src/lib-index/mail-index-transaction-export.c
M	src/lib-index/mail-index-view-sync.c
M	src/lib-index/mail-transaction-log-file.c
M	src/lib-mail/test-istream-binary-converter.c
M	src/lib-mail/test-ostream-dot.c
M	src/lib-mail/test-quoted-printable.c
M	src/lib-master/master-auth.c
M	src/lib-sql/driver-test.c
M	src/lib-storage/index/index-mail-binary.c
M	src/lib-storage/index/index-mail-headers.c
M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-storage.c
M	src/lib-storage/index/maildir/maildir-uidlist.c
M	src/lib-storage/index/mbox/mbox-save.c
M	src/lib-storage/list/mailbox-list-index-sync.c
M	src/lib-storage/mail-search.c
M	src/lib/base32.c
M	src/lib/base64.c
M	src/lib/hash-method.c
M	src/lib/hmac.c
M	src/lib/pkcs5.h
M	src/lib/test-buffer.c
M	src/lib/test-hex-binary.c
M	src/lib/test-iostream-pump.c
M	src/lib/test-numpack.c
M	src/lib/test-ostream-failure-at.c
M	src/login-common/client-common.c
M	src/login-common/sasl-server.c
M	src/plugins/acl/acl-cache.c
M	src/plugins/fts-lucene/Snowball.cc
M	src/plugins/imap-stats/imap-stats-plugin.c
M	src/plugins/mail-crypt/mail-crypt-global-key.c
M	src/plugins/mail-crypt/test-mail-global-key.c
M	src/plugins/mail-crypt/test-mail-key.c
M	src/plugins/pop3-migration/pop3-migration-plugin.c
M	src/plugins/stats/mail-stats-connection.c
M	src/plugins/virtual/virtual-sync.c
M	src/pop3-login/client-authenticate.c
M	src/stats/mail-command.c
M	src/stats/mail-session.c
M	src/stats/mail-user.c
M	src/util/script.c

2017-11-21 22:57:30 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (4d0200e)

    lib: buffer - Add t_buffer_create

    Helper for making a datastack buffer

M	src/lib/buffer.h

2017-11-24 12:31:22 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (06ff86f)

    lib-storage: Fix sorting mails with the same primary sort key

    The sorting order may have been wrong when there was a combination of:
    * Messages were sorted by a string (e.g. Subject)
    * Some messages had the same sort key (e.g. same base subject)
    * Within the messages with the same sort key, some of the messages already
      had the "sort-*" index number in Dovecot indexes, but some of them
      didn't.

    The result was that Dovecot found that the two messages had exactly the same 
    sort key. It should have continued with the secondary sort key (e.g. message
    sequence number), but it didn't.

M	src/lib-storage/index/index-sort-string.c

2017-11-08 15:42:32 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (9698cd2)

    auth: Add lua passdb/userdb support


M	src/auth/Makefile.am
M	src/auth/auth-request-var-expand.h
A	src/auth/db-lua.c
A	src/auth/db-lua.h
A	src/auth/passdb-lua.c
M	src/auth/passdb.c
M	src/auth/test-auth.h
A	src/auth/test-lua.c
M	src/auth/test-main.c
M	src/auth/test-mock.c
A	src/auth/userdb-lua.c
M	src/auth/userdb.c
M	src/lib-lua/dlua-script-private.h

2017-11-11 11:55:21 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (e88e76e)

    lib-lua: Add lua helper library

    Provides a base lua library for lua extensibility

M	configure.ac
M	src/Makefile.am
A	src/lib-lua/Makefile.am
A	src/lib-lua/dlua-compat.c
A	src/lib-lua/dlua-dovecot.c
A	src/lib-lua/dlua-script-private.h
A	src/lib-lua/dlua-script.c
A	src/lib-lua/dlua-script.h
A	src/lib-lua/test-lua.c

2017-11-08 14:09:26 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (feaa7d3)

    configure: Detect lua


M	configure.ac
A	m4/want_lua.m4

2017-11-15 19:13:39 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (38f53f9)

    auth: Add accessor for userdb-template fields

    It's needed in lua

M	src/auth/userdb-template.c
M	src/auth/userdb-template.h

2017-11-08 13:30:24 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (8734467)

    mempool-allocfree: Add linked-list malloc allocation

    This is useful when you want to actually free memory from pool too

M	src/lib/Makefile.am
A	src/lib/mempool-allocfree.c
M	src/lib/mempool.h
M	src/lib/test-lib.inc
A	src/lib/test-mempool-allocfree.c

2017-11-24 09:52:24 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (2945c7c)

    stats: Do not log errors if /proc/self/io is not accessible

    Some security options, used notably in docker, can prevent access to this
    file even from root, so do not log errors if the error is EACCES.

M	src/plugins/stats/mail-stats-fill.c

2017-11-20 09:46:48 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (4ee65ee)

    lib: test-path-util - whitespace & coding style cleanup in create_links()


M	src/lib/test-path-util.c

2017-11-22 10:49:49 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (2bd58dc)

    auth: Check that key is not empty in passdb or userdb template

    Prevents nasty crash later on if template has 'key = value'

    dovecot: auth: Panic: file auth-request.c: line 1746
    (auth_request_set_field): assertion failed: (*name != '\0')

M	src/auth/passdb-template.c
M	src/auth/userdb-template.c

2017-11-22 12:16:46 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4e3b79a)

    lib-storage: Add mailbox_set_critical() and mail_set_critical()

    These add the mailbox vname and mail UID to the log prefix and then call 
    mail_storage_set_critical().

M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage.c

2017-11-22 12:02:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9f10387)

    login-proxy: Fix hang in outgoing SSL connections

    The handshaking needs to be started explicitly.

M	src/login-common/login-proxy.c

2017-11-21 16:52:24 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5783df9)

    login-proxy: Log connection errors using IP, not hostname

    The hostname can point to multiple IPs or there can be some other mismatch. 
    Logging the IP instead shows exactly what is happening.

M	src/login-common/login-proxy.c

2017-11-20 21:17:24 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (89155c6)

    lib: path-util: Improved conditional expressions in path_normalize() to
    match the earlier adjusted assertions.

    Added some more assertions in the process to make sure subtractions are
    always valid.

M	src/lib/path-util.c

2017-11-20 15:53:55 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (71acd1d)

    lib: Improve test-path-util unit test to catch off-by-one memory allocation
    errors


M	src/lib/test-path-util.c

2017-11-20 16:01:25 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (569b502)

    lib: path-util - Allocate more space earlier

    Fixes assert crash in path_normalize when termination needs to happen at
    asize boundary.

    Panic: file path-util.c: line 93 (path_normalize): assertion failed:
    ((size_t)((npath_pos - npath) + 1) < asize)

M	src/lib/path-util.c

2017-11-20 17:56:52 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (82e7761)

    lib-storage: Add a fall through comment to fix gcc-7 warning


M	src/lib-storage/mailbox-list.c

2017-11-20 17:03:47 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7f42dc9)

    mdbox: Fix rebuilding when dovecot.map.index is missing map/ref extension

    The rebuild kept just repeatedly failing with: Error: mdbox map
    .../dovecot.map.index corrupted: missing map extension

M	src/lib-storage/index/dbox-multi/mdbox-storage-rebuild.c

2017-11-18 23:14:25 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (eaebd98)

    lib-storage: Fix mailbox_create_missing_dir() with storages that have no
    mail root dir

    The mailbox still exists even if the mail root directory doesn't, so there's 
    no point in even trying to stat() it.

M	src/lib-storage/mail-storage.c

2017-11-18 23:10:47 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3fdbff3)

    lib-storage: Make sure mailbox autocreation doesn't get into infinite loop

    If mailbox_create() -> mailbox_open() fails with MAIL_ERROR_NOTFOUND, it 
    would have looped back to mailbox_create() and continued this until running
    out of stack.

M	src/lib-storage/mail-storage.c

2017-11-18 18:57:51 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6386005)

    lib-storage: Add INDEXCACHE=<path> to mail_location

    This allows configuring a different directory for dovecot.index.cache files 
    than the rest of the index files.

M	src/lib-storage/index/index-storage.c
M	src/lib-storage/index/mbox/mbox-storage.c
M	src/lib-storage/list/mailbox-list-delete.c
M	src/lib-storage/list/mailbox-list-fs.c
M	src/lib-storage/list/mailbox-list-maildir.c
M	src/lib-storage/mail-storage.c
M	src/lib-storage/mailbox-list.c
M	src/lib-storage/mailbox-list.h

2017-11-20 14:28:40 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (da61301)

    lib-storage: mailbox_rename() - Improve debug logging when namespaces are
    incompatible


M	src/lib-storage/mail-storage.c

2017-11-18 18:12:10 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (72af688)

    lib-index: Add mail_index_set_cache_dir() to change .cache's directory


M	src/lib-index/mail-index-private.h
M	src/lib-index/mail-index.c
M	src/lib-index/mail-index.h

2017-11-18 18:03:55 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2608ab4)

    lib-index: Add mail_cache_open_or_create_path()

    This allows moving cache file to another directory.

M	src/lib-index/mail-cache.c
M	src/lib-index/mail-cache.h

2017-11-18 00:44:12 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ca0cfbc)

    virtual: Fix crash when saving to virtual mailbox whose physical box doesn't
    exist

    For example if using "!foo" in dovecot-virtual and "foo" doesn't exist, it
    crashed. Now it gives a nice error message instead.

M	src/plugins/virtual/virtual-storage.c

2017-11-18 19:06:55 +0100 Stephan Bosch <stephan.bosch@dovecot.fi> (1c8b68c)

    lib: path-util: Made assertions in path_normalize() more reliable and less
    confusing to static analyzer.


M	src/lib/path-util.c

2017-11-17 22:37:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d7a2f56)

    lib: path-util - Add more code paths to test in path_normalize()


M	src/lib/test-path-util.c

2017-11-17 21:44:50 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (489af46)

    virtual: Wrap mail.get_binary_stream() to fix it

    Fixes using FETCH BINARY[..] with virtual mailboxes crashing with:

    Panic: file index-mail-binary.c: line 585 (index_mail_get_binary_stream):
    assertion failed: (mail->data.stream != NULL)

M	src/plugins/virtual/virtual-mail.c

2017-11-17 20:56:28 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (948dccd)

    quota: Fix error handling if maildirsize rewrite fails after recalculation

    error could have been left uninitialized, potentially causing a crash.

M	src/plugins/quota/quota-maildir.c

2017-11-17 20:55:55 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1f8e934)

    fts-lucene: Fix potential memory leak


M	src/plugins/fts-lucene/lucene-wrapper.cc

2017-11-17 20:53:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (bcf23ee)

    lib-dcrypt: test-stream - Make static analyzer happier

    Without this clang thinks it's possible that siz>sizeof(payload).

M	src/lib-dcrypt/test-stream.c

2017-11-15 14:29:59 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (c560fa0)

    doveadm-auth-server: Further fix json problems

    Remove excess comma from start, forgotten in
    3e06a782584ea2c4ae2a8cb0451e9952f05f9dc8

M	src/doveadm/doveadm-auth-server.c

2017-11-09 15:33:52 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6d54804)

    lib-charset: Compile charset-utf8-only code always

    Mainly so that this code always gets compiled, so any bugs are found.

M	src/lib-charset/charset-utf8-only.c

2017-11-09 15:18:29 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9c675d5)

    lib-charset: Allow plugins to replace charset_* functions

    They just need to point charset_utf8_vfuncs to their own implementation.

M	src/lib-charset/Makefile.am
M	src/lib-charset/charset-iconv.c
M	src/lib-charset/charset-utf8-only.c
A	src/lib-charset/charset-utf8-private.h
M	src/lib-charset/charset-utf8.c

2017-11-09 15:12:05 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5b9bacd)

    lib-charset: Move non-iconv UTF-8 only translation code to its own file


M	src/lib-charset/Makefile.am
A	src/lib-charset/charset-utf8-only.c
M	src/lib-charset/charset-utf8.c

2017-11-16 13:27:23 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (abd2ac9)

    mail-crypt: Do not free global keys if no error has occured


M	src/plugins/mail-crypt/mail-crypt-pluginenv.c

2017-11-16 00:53:34 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d596739)

    director: Make sure a missing right-side connection is always reconnected

    This code shouldn't be needed, but add it just to be sure.

M	src/director/director.c

2017-11-16 00:44:17 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3a7a8b3)

    director: Reconnect after detecting a write failure to director

    If disconnection is detected during write failure, or "Output buffer full" 
    occurs, the connection is disconnected. However, if this was the right side 
    connection, it wasn't automatically reconnected to. This left the ring 
    nonworking.

M	src/director/director-connection.c

2017-11-15 12:57:34 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (0a222de)

    global: Replace o_stream_ignore_last_errors() with o_stream_abort() wherever
    possible


M	src/lib-fs/fs-api.c
M	src/lib-mail/test-istream-attachment.c
M	src/lib-storage/index/dbox-common/dbox-file-fix.c
M	src/lib-storage/index/dbox-common/dbox-file.c
M	src/lib-storage/list/subscription-file.c
M	src/plugins/fts-squat/squat-uidlist.c

2017-11-15 12:49:48 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7660a51)

    lib: Add o_stream_abort()


M	src/lib/ostream.c
M	src/lib/ostream.h

2017-11-15 12:51:12 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7112c5a)

    lib-smtp: Remove unnecessary o_stream_ignore_last_errors() call

    The stream is already marked with o_stream_set_no_error_handling(TRUE).

M	src/lib-smtp/smtp-submit.c

2017-11-02 10:07:39 -0400 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (8528048)

    lib-storage: Fix MAILBOX_LIST_INDEX_HIERARHCY_SEP spelling

    Original work by @jsoref

M	src/lib-storage/list/mailbox-list-index-backend.c
M	src/lib-storage/list/mailbox-list-index.h

2017-11-08 14:40:14 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b8f02c9)

    doveadm: client - Cleanup: Simplify the input loop


M	src/doveadm/server-connection.c

2017-11-08 14:39:06 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4a913ff)

    doveadm: client - Cleanup: Remove unnecessary stream_errno check


M	src/doveadm/server-connection.c

2017-11-09 16:17:26 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (73d5397)

    doveadm: client - Cleanup: Remove unnecessary code indentation


M	src/doveadm/server-connection.c

2017-11-08 14:35:31 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9f869f9)

    doveadm: client - Cleanup: Handle input NULL first


M	src/doveadm/server-connection.c

2017-11-09 16:18:13 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2063815)

    doveadm: client - Cleanup: Set authenticate_sent in a more proper location


M	src/doveadm/server-connection.c

2017-11-08 14:32:25 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (fd91d0e)

    doveadm: client - Cleanup: Don't check authenticate_sent twice


M	src/doveadm/server-connection.c

2017-11-08 14:20:49 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b52b16e)

    doveadm: client - Read any pipelined replies after authentication reply

    This practically shouldn't happen.

M	src/doveadm/server-connection.c

2017-11-08 14:17:04 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1a492d1)

    doveadm: client - Cleanup: Read server input only once in the input handler


M	src/doveadm/server-connection.c

2017-11-08 14:11:51 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8a6710d)

    doveadm: client - Fail if server sends more than one VERSION reply in
    handshake


M	src/doveadm/server-connection.c

2017-11-15 16:12:15 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (04d4432)

    *-login: Close SSL connections cleanly

    Don't close the socket before SSL "close notify" is sent.

M	src/login-common/client-common.c

2017-11-15 15:53:03 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4c5c19b)

    lib-imap: imap_envelope_parse() - remove unnecessary data stack frame

    imap_envelope_parse_args() isn't using data stack at all, so this 
    unnecessarily complicates the code. It also prevents using datastack-pool as
    the pool parameter.

M	src/lib-imap/imap-envelope.c

2017-11-15 09:22:34 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (dc8dc2e)

    lib-storage: mailbox-list-index - disable if MAILBOX_LIST_PROP_NO_LIST_INDEX
    set


M	src/lib-storage/list/mailbox-list-index.c

2017-11-13 15:28:08 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (18b3f47)

    lib-storage: imapc - use MAILBOX_LIST_PROP_NO_LIST_INDEX

    mailbox list index does not work with imapc, so disable it.

    Panic: file mail-storage.c: line 1858 (mailbox_get_metadata): assertion
    failed: ((items & MAILBOX_METADATA_GUID) == 0 ||
    !guid_128_is_empty(metadata_r->guid))

M	src/lib-storage/index/imapc/imapc-list.c

2017-11-15 09:16:12 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (9d41eb0)

    lib-storage: mailbox-list-none - use MAILBOX_LIST_PROP_NO_LIST_INDEX flag


M	src/lib-storage/list/mailbox-list-none.c

2017-11-13 15:27:07 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (ba0b86c)

    lib-storage: Add MAILBOX_LIST_PROP_NO_LIST_INDEX

    If set, disables mailbox list index for the given list.

M	src/lib-storage/mailbox-list.h

2017-11-15 10:28:37 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (3e06a78)

    doveadm-auth-server: Send comma only if we are sending field too

    Fixes json output

M	src/doveadm/doveadm-auth-server.c

2017-11-14 13:49:22 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (8b47843)

    lib-master: Drop support for SSL_TXT_SSLV2 in master-service-ssl-settings.c

    OpenSSL headers are not included in master-service-ssl-settings.c, so the
    check for SSL_TXT_SSLV2 is broken at the moment, and the feature is not
    worth supporting since SSLv2 is obsolete.

M	src/lib-master/master-service-ssl-settings.c

2017-11-15 06:13:30 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (6f4c61d)

    m4: Refuse to build with OpenSSL version < 1.0.1


M	m4/ssl.m4

2017-11-14 20:14:09 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a0876e2)

    lib: Add unit test for dec2str_buf()


M	src/lib/test-strfuncs.c

2017-11-14 16:51:37 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e1abe6d)

    auth: Remove userdb nss

    Its original purpose was because getpwnam() couldn't differentiate between
    "user doesn't exist" and "temporary error", but this was solved by using 
    getpwnam_r() instead.

    So all userdb nss users should be able to safely switch to userdb passwd.

M	src/auth/Makefile.am
D	src/auth/userdb-nss.c
M	src/auth/userdb.c

2017-11-14 00:09:10 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d436926)

    imap: SELECT/EXAMINE - Send * OK [CLOSED] before tagged BAD parameters reply


M	src/imap/cmd-select.c

2017-11-09 16:30:34 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (488bdf7)

    man: doveadm proxy -a parameter doesn't support TCP sockets


M	doc/man/doveadm-proxy.1.in

2017-11-09 07:08:24 +0100 Simon Frankenberger <simon@fraho.eu> (f987ef0)

    fts-solr: Explicitly ask for XML responses

    With recent solr versions (7.0+) the default response writer changed from
    XML to JSON. This commit sets the
    "wt" query parameter for all requests, so that the right response type is
    written.

M	src/plugins/fts-solr/fts-backend-solr.c

2017-11-09 10:52:12 -0500 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (2b55fff)

    lib: fix illumos build issue

    The recent performance improvements to the net_addr2ip() code broke build on
    illumos which has a 's_addr' #define in netinit/in.h.

M	src/lib/net.c

2017-11-10 10:34:09 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (f4bc02a)

    quota: Exit with EX_TEMPFAIL when doveadm quota get encounters an error


M	src/plugins/quota/doveadm-quota.c

2017-11-03 08:38:39 -0400 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (f416907)

    lib: use temp var in i_stream_unref for clarity


M	src/lib/istream.c

2017-11-09 12:24:16 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b97e952)

    director: Fix director_max_parallel_moves/kicks type

    Should be uint, not time.

M	src/director/director-settings.c

2017-11-08 16:03:17 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f729247)

    doveadm: client - Fix connecting to UNIX sockets that don't need
    authentication

    Trying to access doveadm UNIX socket that didn't require authentication 
    failed with:

    Error: doveadm server sent invalid handshake: ...

M	src/doveadm/server-connection.c

2017-11-08 16:01:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d85b096)

    doveadm: client - Cleanup: Rename handshaked to authenticate_sent

    This better describes what it does.

M	src/doveadm/server-connection.c

2017-11-03 17:29:37 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (93b8808)

    quota: Include mailbox name in quota_transaction_set_limits() error_r


M	src/plugins/quota/quota.c

2017-11-03 16:17:44 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (12d7f66)

    quota: Prefix quota errors with backend name in quota_get_resource()

    Remove quota backend name error_r prefixing from get_resource() vfuncs.

M	src/plugins/quota/quota-count.c
M	src/plugins/quota/quota-dict.c
M	src/plugins/quota/quota-dirsize.c
M	src/plugins/quota/quota-fs.c
M	src/plugins/quota/quota-imapc.c
M	src/plugins/quota/quota-maildir.c
M	src/plugins/quota/quota.c

2017-11-02 14:02:15 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (4f52de7)

    quota: Add error_result_r parameter to quota_count()


M	src/plugins/quota/quota-count.c
M	src/plugins/quota/quota-dict.c
M	src/plugins/quota/quota-private.h

2017-11-02 12:11:20 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (7ee626f)

    quota: Add QUOTA_GET_RESULT_BACKGROUND_CALC enum value


M	src/plugins/quota-clone/quota-clone-plugin.c
M	src/plugins/quota/quota-storage.c
M	src/plugins/quota/quota.h

2017-11-02 12:04:46 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (b14f93e)

    quota: Add QUOTA_ALLOC_RESULT_BACKGROUND_CALC enum value


M	src/plugins/quota/quota-status.c
M	src/plugins/quota/quota-storage.c
M	src/plugins/quota/quota.c
M	src/plugins/quota/quota.h

2017-11-02 11:37:08 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (1379bb7)

    quota: Return quota_get_result from quota_backend_vfuncs.get_resource()

    Add a QUOTA_UNKNOWN_RESOURCE_ERROR_STRING for returning error_r with 
    QUOTA_GET_RESULT_UNKNOWN_RESOURCE.

    Forbid backends from returning QUOTA_GET_RESULT_UNLIMITED in 
    quota_get_resource() with an i_panic().

M	src/plugins/quota/quota-count.c
M	src/plugins/quota/quota-dict.c
M	src/plugins/quota/quota-dirsize.c
M	src/plugins/quota/quota-fs.c
M	src/plugins/quota/quota-imapc.c
M	src/plugins/quota/quota-maildir.c
M	src/plugins/quota/quota-private.h
M	src/plugins/quota/quota.c

2017-11-02 10:39:18 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (c975f4c)

    quota: Add error_result_r parameter to quota_transaction_set_limits()


M	src/plugins/quota/quota-private.h
M	src/plugins/quota/quota-storage.c
M	src/plugins/quota/quota.c

2017-11-02 16:20:39 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (e78fe25)

    quota: Make quota_get_result errors <= QUOTA_GET_RESULT_INTERNAL_ERROR

    Reorder the enum to make a shortcut for distinguishing errors.

M	src/plugins/quota/quota.h

2017-11-02 16:30:31 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (995c0a8)

    quota-dict: Cleanup dict_quota_get_resource() whitespace


M	src/plugins/quota/quota-dict.c

2017-09-20 12:32:40 +0300 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (bb11a19)

    quota-clone: Rename ret_bytes and ret_count to bytes_res and count_res

    This is because the variables do not contain the actual quota resource 
    values but whether the lookup was successful.

M	src/plugins/quota-clone/quota-clone-plugin.c

2017-11-06 21:00:57 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (07ca0c7)

    lib: test-istream-jsonstr - Improve unit test


M	src/lib/test-istream-jsonstr.c

2017-11-08 14:06:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (40b50a2)

    doveadm-server: Fix protocol handshake order

    With version 1.1 protocol, server sent the authentication "+" or "-" line 
    before the VERSION. doveadm client accepts the VERSION reply either before 
    or after, so this change doesn't break it. It makes the protocol cleaner 
    though.

    Based on patch by Manuel Mausz

M	src/doveadm/client-connection-tcp.c

2017-11-08 14:04:12 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4addf3f)

    doveadm-server: Add client_connection_tcp.preauthenticated


M	src/doveadm/client-connection-tcp.c

2017-11-08 02:31:03 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b722fa7)

    lib-ssl-iostream: Simplify ssl_iostream_settings_equals()


M	src/lib-ssl-iostream/iostream-ssl.c

2017-11-07 17:36:05 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (74c369c)

    director: Add director_max_parallel_moves/kicks settings

    The director_max_parallel_moves setting controls the default limit, which 
    can still be increased by explicitly using the doveadm director flush
    --max-parallel" parameter.

M	src/director/director-settings.c
M	src/director/director-settings.h
M	src/director/doveadm-connection.c

2017-11-03 13:26:52 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (c339300)

    lib: istream-jsonstr - Properly handle unicode input

    Treat surrogates correctly, do not accept invalid codepoints

M	src/lib/istream-jsonstr.c
M	src/lib/json-parser.c
M	src/lib/test-istream-jsonstr.c

2017-11-03 13:23:15 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (d9d2885)

    lib: istream-jsonstr - Move length check to unescape


M	src/lib/istream-jsonstr.c

2017-11-06 14:40:08 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (c980536)

    lib: json-parser - check for valid hex in unicode escape


M	src/lib/json-parser.c
M	src/lib/test-json-parser.c

2017-11-03 09:50:40 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (32bd32d)

    lib: json-parser - Insert properly escaped unicode


M	src/lib/json-parser.c
M	src/lib/json-parser.h
M	src/lib/test-json-parser.c

2017-11-07 18:28:37 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2ede3b4)

    configure: Fix writing LIBDOVECOT[_DEPS] in dovecot-config

    It needs to be in a single line or DC_DOVECOT's greping doesn't work 
    correctly.

M	configure.ac

2017-11-06 10:36:07 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (16a5712)

    director: Limit max kicking count


M	src/director/doveadm-connection.c
M	src/director/doveadm-connection.h
M	src/director/main.c

2017-11-07 14:34:32 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (3e0c0a2)

    director: Add kick_callback to director

    This callback gets called whenever director has performed a kick.

M	src/director/director.c
M	src/director/director.h
M	src/director/main.c

2017-10-27 16:45:16 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (296acba)

    *-login: Add login_proxy_notify_path setting to configure proxy-notify path

    A single FIFO can be a bottleneck, so this could be set to e.g.:

    login_proxy_notify_path = proxy-notify%1R{pid}

    or:

    login_proxy_notify_path = proxy-notify%10N{pid}

M	src/login-common/login-settings.c
M	src/login-common/login-settings.h
M	src/login-common/main.c

2017-10-27 16:24:54 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (9dd8a75)

    director: Allow proxy-notify to optionally be a socket

    Dovecot isn't using this currently, but it can be useful if external 
    services want to send notifications.

M	src/director/main.c
M	src/director/notify-connection.c
M	src/director/notify-connection.h

2017-10-27 16:20:15 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (57d65ae)

    director: Support multiple proxy-notify connections


M	src/director/main.c
M	src/director/notify-connection.c
M	src/director/notify-connection.h

2017-11-07 03:57:49 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (d32f4c4)

    quota-fs: Make it possible to set the mount= parameter

    Also free root->storage_mount_path before copying the given parameter in 
    order not to leak memory when there are duplicate mount= parameters.

M	src/plugins/quota/quota-fs.c

2017-11-07 01:33:57 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (84703c2)

    log: Fix log reopening on SIGUSR1


M	src/log/main.c

2017-11-07 01:11:33 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9c04998)

    lib-ssl-iostream: Remove obsolete ssl_iostream_context_deinit()


M	src/lib-ssl-iostream/iostream-ssl.h

2017-11-05 18:35:57 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ebcf7d6)

    global: Replace ssl_iostream_context_init_client() with
    ssl_iostream_client_context_cache_get()


M	src/doveadm/doveadm-dsync.c
M	src/lib-http/http-client.c
M	src/lib-imap-client/imapc-client.c
M	src/lib-storage/index/pop3c/pop3c-client.c

2017-11-05 18:34:48 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b583cc2)

    lib-ssl-iostream: Call ssl_iostream_context_cache_free() automatically at
    exit


M	src/lib-ssl-iostream/iostream-ssl.c

2017-11-02 23:36:57 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8d9f11a)

    lib: Remove net_transmit()

    Its API was confusing, and it's no longer used anywhere.

M	src/lib/net.c
M	src/lib/net.h

2017-11-01 01:51:14 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (71bd935)

    login-common: Remove ssl-proxy code


M	src/login-common/Makefile.am
D	src/login-common/ssl-proxy-gnutls.c
D	src/login-common/ssl-proxy-openssl.c
D	src/login-common/ssl-proxy.c
D	src/login-common/ssl-proxy.h

2017-11-01 01:49:57 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3e06f83)

    login-common: Stop using ssl-proxy entirely


M	src/login-common/client-common.c
M	src/login-common/main.c

2017-11-01 01:49:04 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (06704ac)

    *-login: Remove unnecessary ssl-proxy.h include


M	src/imap-login/imap-login-client.c
M	src/pop3-login/client-authenticate.c
M	src/pop3-login/client.c

2017-11-01 01:47:54 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4635b36)

    login-common: Call io_stream_ssl_global_init() early


M	src/login-common/login-common.h
M	src/login-common/main.c

2017-11-01 01:27:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (feb8f7b)

    login-common: Use lib-ssl-iostream for incoming SSL/TLS connections


M	src/login-common/client-common.c
M	src/login-common/client-common.h
M	src/login-common/sasl-server.c

2017-11-01 01:40:23 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (15aa67e)

    lib-ssl-iostream: Add io_stream_ssl_global_init()


M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-11-01 01:38:19 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (74b7b25)

    lib-ssl-iostream: io_stream_create_ssl_client() - Move code to set
    verify_remote_cert=TRUE

    Enable it in the generic SSL code instead of OpenSSL-specific code.

M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-ssl.c

2017-11-01 01:21:38 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d920a34)

    *-login: Use io_add_istream() instead of io_add()


M	src/imap-login/imap-login-client.c
M	src/imap-urlauth/imap-urlauth-login.c
M	src/pop3-login/client.c

2017-11-01 22:48:55 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (0256180)

    login-common: Change process title to show different connection types

    Separate pre-login connections, proxy connections and post-login TLS 
    proxies.

M	src/login-common/client-common.c
M	src/login-common/client-common.h
M	src/login-common/login-proxy.c
M	src/login-common/login-proxy.h
M	src/login-common/main.c

2017-11-01 22:40:58 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a7efba6)

    login-common: Destroy all fd proxies at deinit.


M	src/login-common/client-common.c
M	src/login-common/client-common.h
M	src/login-common/main.c

2017-11-01 02:19:51 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (87dbf3e)

    login-common: Implement post-login proxying and use it with SSL connections

    Note: This temporarily breaks the SSL connections a bit. If post-login 
    process disconnects the client, it's not noticed by the login process. 
    Client connections are noticed by the post-login though.

M	src/login-common/client-common.c
M	src/login-common/client-common.h
M	src/login-common/sasl-server.c

2017-11-01 01:06:05 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (be6e55f)

    login-common: client_alloc() - remove unnecessary ssl parameter


M	src/login-common/client-common.c
M	src/login-common/client-common.h
M	src/login-common/main.c

2017-11-01 01:03:31 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9b450c9)

    login-common: Use client_init_ssl() to initialize all SSL connections


M	src/login-common/main.c

2017-11-01 00:59:54 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b1485f2)

    login-common: Extract SSL/TLS initialization into client_init_ssl()


M	src/login-common/client-common.c
M	src/login-common/client-common.h

2017-11-01 00:49:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (66ea9ea)

    login-common: Split client_create() to client_alloc() and client_init()

    client_unref() can be used to free an allocated client that hasn't been 
    fully created.

M	src/login-common/client-common.c
M	src/login-common/client-common.h
M	src/login-common/main.c

2017-11-02 01:05:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (14a07d2)

    lib-ssl-iostream: Add TLS SNI callback and a way to change SSL context


M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-11-01 00:18:23 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6315f87)

    lib-ssl-iostream: ssl_iostream_cert_match_name() - add reason_r parameter

    The callers were also changed to add the reason to error messages.

M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-11-01 00:12:24 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (bbafd34)

    lib-ssl-iostream: openssl_cert_match_name() - add reason_r parameter

    The returned string explains what exactly matched or why nothing matched.

M	src/lib-ssl-iostream/iostream-openssl-common.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/login-common/ssl-proxy-openssl.c

2017-11-01 00:08:26 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (18344a6)

    lib-ssl-iostream: ssl_iostream_cert_match_name() - Change to return bool

    The return value makes much more sense as a boolean TRUE/FALSE than 0/-1.

M	src/lib-ssl-iostream/iostream-openssl-common.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h
M	src/login-common/ssl-proxy-openssl.c

2017-10-31 19:34:05 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (58c2ffe)

    login-proxy: Use lib-ssl-iostream for outgoing SSL/TLS connections


M	src/login-common/login-proxy.c
M	src/login-common/main.c

2017-11-01 00:35:33 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b5af146)

    lib-master: master_service_ssl_settings_to_iostream_set() - add
    client/server parameter


M	src/lib-master/master-service-ssl-settings.c
M	src/lib-master/master-service-ssl-settings.h

2017-10-31 23:24:17 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8ca7d30)

    lib-master: master_service_ssl_settings_to_iostream_set() - reorder
    assignments

    Keep them in the same order as the fields in struct ssl_iostream_settings, 
    so it's easier to verify whether all fields are listed.

M	src/lib-master/master-service-ssl-settings.c

2017-10-31 23:23:10 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (30c5c1f)

    lib-master: master_service_ssl_settings_to_iostream_set() - add
    ssl_require_crl


M	src/lib-master/master-service-ssl-settings.c

2017-10-31 18:57:29 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (75eb713)

    lib-master: master_service_ssl_settings_to_iostream_set() - don't go through
    master_service

    It's more useful to convert any master_service_ssl_settings struct.

M	src/lib-master/master-service-ssl-settings.c
M	src/lib-master/master-service-ssl-settings.h

2017-11-01 00:26:02 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6d4fb02)

    lib-master: Add ssl_client_ca_file & _dir to master_service_ssl_settings


M	src/lib-master/master-service-ssl-settings.c
M	src/lib-master/master-service-ssl-settings.h

2017-11-02 01:04:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (86cc860)

    lib-ssl-iostream: Add ssl_iostream_context cache

    This can be used to easily get a shared ssl_iostream_context for either 
    server or client. There's no upper size limit for the cache.

M	src/lib-ssl-iostream/Makefile.am
A	src/lib-ssl-iostream/iostream-ssl-context-cache.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-11-05 18:30:42 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (85a594c)

    lib-ssl-iostream: Add ssl_iostream_settings_drop_stream_only()


M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c

2017-11-05 18:29:13 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1c18965)

    lib-ssl-iostream: Add ssl_iostream_settings_equals()


M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c

2017-10-31 18:43:22 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3c376d8)

    lib-ssl-iostream: Keep ssl_iostream_context referenced while it has streams


M	src/lib-ssl-iostream/iostream-openssl.c

2017-10-31 18:41:47 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (9635959)

    lib-ssl-iostream: Add refcounting to ssl_iostream_context


M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-31 18:39:39 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (15d19d6)

    global: Rename ssl_iostream_context_deinit() to ssl_iostream_context_unref()


M	src/doveadm/doveadm-dsync.c
M	src/lib-http/http-client.c
M	src/lib-http/http-server.c
M	src/lib-imap-client/imapc-client.c
M	src/lib-master/master-service-ssl.c
M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h
M	src/lib-storage/index/pop3c/pop3c-client.c

2017-10-30 16:55:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (319bc5f)

    lib-ssl-iostream: Change ssl_iostream_context.set to not be a pointer

    It's just unnecessary memory usage.

M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h

2017-10-31 18:19:33 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (25aa88d)

    lib-ssl-iostream: ssl_iostream_settings_dup() - rewrite using string offsets
    array

    This array will be useful for other purposes as well.

M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-30 16:54:34 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (cfa1edd)

    lib-ssl-iostream: Add ssl_iostream_settings_init_from()

    This allows duplicating settings to an already existing struct without 
    having to allocate it.

M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-30 12:57:40 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e88f4d3)

    lib-ssl-iostream: ssl_iostream_settings_dup() - duplicate also dh


M	src/lib-ssl-iostream/iostream-ssl.c

2017-10-30 12:06:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4c21d44)

    lib-ssl-iostream: Add stream/context comments to all ssl_iostream_settings


M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-30 00:44:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5f24bf9)

    login-proxy: Use iostream-proxy API to perform proxying


M	src/login-common/login-proxy.c

2017-10-30 00:59:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f8b6c3d)

    lib: Add o_stream_get_last_write_time()


M	src/lib/ostream-private.h
M	src/lib/ostream.c
M	src/lib/ostream.h

2017-10-30 00:49:15 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a215aba)

    lib: Add i_stream_get_last_read_time()


M	src/lib/istream-private.h
M	src/lib/istream.c
M	src/lib/istream.h

2017-11-01 23:53:42 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1312cf6)

    login-proxy: Move client fd closing to client_unref()


M	src/login-common/client-common.c
M	src/login-common/login-proxy.c

2017-11-01 21:15:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (86bca14)

    login-common: Move code in client_destroy_internal_failure() to its only
    caller

    No need to have a function that has only a single caller.

M	src/login-common/client-common-auth.c
M	src/login-common/client-common.c
M	src/login-common/client-common.h

2017-11-01 21:09:56 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1a1159e)

    login-common: Avoid using client_destroy_success() when
    mail_max_userip_connections is reached

    This was currently the only way how data != NULL here.

    This change destroys ssl_proxy on client_destroy() instead of 
    client_unref(), but that doesn't make much of a practical difference. This 
    new behavior is a bit more correct though.

M	src/login-common/client-common-auth.c
M	src/login-common/client-common.c
M	src/login-common/client-common.h

2016-10-04 15:36:06 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (8bcf6fd)

    iostream-openssl: Refactor stream sync code

    When doing input or stream sync, specify the type of operation that we are
    doing to make sure we do IO correctly.

M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/istream-openssl.c
M	src/lib-ssl-iostream/ostream-openssl.c

2017-11-05 18:07:28 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b4c64e7)

    lib-ssl-iostream: Set error on clean connection closing during handshake.

    Set the error to "SSL connection closed during handshake".

M	src/lib-ssl-iostream/iostream-openssl.c

2017-11-05 18:06:10 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (497cdac)

    lib-ssl-iostream: Cleanup disconnection handling

    Avoid code duplication. Set error to "Connection closed" if there's no other
    error.

M	src/lib-ssl-iostream/iostream-openssl.c

2017-11-05 17:47:15 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6c30d94)

    doveadm: Remove dead code

    ret can never be >0 at this point. If there are any unexpected JSON 
    elements, doveadm_http_server_json_parse_v1() returns -1.

M	src/doveadm/client-connection-http.c

2017-11-05 23:51:56 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (88734aa)

    director: Make sure HOST-RESET-USERS isn't used with max_moving_users=0

    The reset command would just hang in that case. doveadm would never have 
    sent this, so this is just an extra sanity check.

M	src/director/doveadm-connection.c

2017-11-05 23:27:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5754fa8)

    director: Show in process title how many users are being kicked.


M	src/director/director.c
M	src/director/director.h
M	src/director/main.c

2017-11-05 23:01:56 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4dc8d68)

    director: Show in process title how many requests are being delayed.


M	src/director/director-request.c
M	src/director/director.h
M	src/director/main.c

2017-11-06 10:57:03 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6f20cb5)

    director: Log an error if login process sends unexpected reply to KICK*
    commands


M	src/director/director.c

2017-11-05 22:53:23 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2dfc39a)

    director: Log whenever HOST-RESET-USERS is used


M	src/director/doveadm-connection.c

2017-11-05 22:38:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f534eb9)

    director: Include used CPU secs in director connection log messages

    It's counting the process's full CPU seconds used since the handshake 
    started, so it's not specific to the connection itself. Still, this is 
    likely to be very useful in debugging whether a slow handshake was due to
    CPU usage or something else.

M	src/director/director-connection.c

2017-11-05 22:37:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c83e45c)

    director: Deduplicate code into director_connection_set_connected()


M	src/director/director-connection.c

2017-11-05 22:27:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ef996cb)

    director: Include peak output buffer size in director connection log
    messages


M	src/director/director-connection.c

2017-11-04 14:33:52 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (18da63b)

    cassandra: Include the used timestamp in logged queries


M	src/lib-sql/driver-cassandra.c

2017-11-06 11:00:06 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (125081b)

    cassandra: Rename cassandra_sql_statement.pending_timestamp to just
    timestamp


M	src/lib-sql/driver-cassandra.c

2017-11-06 18:59:34 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (35e47c2)

    lib-storage: When copying mails, copy also empty cache fields

    This mainly means that it copies cache fields for nonexistent message 
    headers. Those are still important, because otherwise Dovecot doesn't know 
    whether they exist or not.

M	src/lib-storage/index/index-storage.c

2017-11-06 01:30:13 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ad394c5)

    director: Don't block too long when sending users during director handshake

    All the other work is blocked while the users are being sent.

M	src/director/director-connection.c

2017-07-26 18:34:59 +0900 Taizo Ito <taizo.ito@hde.co.jp> (ea1d2fc)

    auth: Disabling SMTP authentication in vpopmail users with NO_SMTP flag


M	src/auth/passdb-vpopmail.c

2017-11-05 21:36:55 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4039fdc)

    lib: str_parse/to_*int*() - minor optimization


M	src/lib/strnum.c

2017-11-04 15:29:29 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6b740bf)

    director: Avoid str_printfa() in director_connection_send_users()

    Optimizes the CPU usage.

M	src/director/director-connection.c

2017-11-04 02:17:55 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7b3acba)

    director: Avoid str_printfa() in login_host_callback()

    Optimizes the CPU usage.

M	src/director/login-connection.c

2017-11-04 02:05:26 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1b41830)

    director: Change request callback to take mail_host parameter

    This allows accessing the IP address both as struct and as string without 
    any conversions.

M	src/director/director-request.c
M	src/director/director-request.h
M	src/director/login-connection.c

2017-11-04 01:59:27 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (bd4bbe6)

    director: Use *_host.ip_str to avoid net_ip2addr() calls


M	src/director/director-connection.c
M	src/director/director-host.c
M	src/director/director.c
M	src/director/doveadm-connection.c
M	src/director/mail-host.c

2017-11-04 01:51:25 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b7650f0)

    director: Add director_host.ip_str

    This avoids having to use net_ip2addr() all the time to convert it into a 
    string.

M	src/director/director-host.c
M	src/director/director-host.h

2017-11-04 01:49:29 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (cfc891d)

    director: Add mail_host.ip_str

    This avoids having to use net_ip2addr() all the time to convert it into a 
    string.

M	src/director/mail-host.c
M	src/director/mail-host.h

2017-11-04 01:48:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e8d44b6)

    director: Use t_strsplit_tabescaped_inplace() for director connection input


M	src/director/director-connection.c

2017-11-04 01:43:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1c0491b)

    lib: net_addr2ip() - Optimize for parsing IPv4 addresses


M	src/lib/net.c
M	src/lib/test-net.c

2017-11-04 01:42:37 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8e9616d)

    lib: net_ip2addr() - Optimize by allocating destination memory immediately

    It doesn't really matter if we allocate a few extra bytes.

M	src/lib/net.c

2017-11-04 01:40:24 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b7b2029)

    lib: *_strsplit() - implement more efficient version for a single separator
    char


M	src/lib/strfuncs.c
M	src/lib/test-strfuncs.c

2017-11-05 21:30:30 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8587f42)

    lib: test-strfuncs - Improve *_strsplit*() unit tests


M	src/lib/test-strfuncs.c

2017-11-04 01:39:38 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7de17a5)

    lib: Implement t_strsplit_tabescaped_inplace()

    This is a more efficient version of t_strsplit_tabescaped(), which modifies 
    the input string instead of duplicating it.

M	src/lib/strescape.c
M	src/lib/strescape.h
M	src/lib/test-strescape.c

2017-11-05 21:14:41 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5d8ee65)

    lib: test-strescape - Refactor the unit test to use an array of tests


M	src/lib/test-strescape.c

2017-11-04 01:37:19 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4ec5591)

    lib: t_strsplit_tabescaped() - don't create unnecessary data stack mempool

    unsafe_data_stack_pool is more efficient to use

M	src/lib/strescape.c

2017-11-04 01:35:44 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (60212a5)

    lib: str_tabunescape() - optimize initial escape char lookup

    strchr() is faster than looping ourself.

M	src/lib/strescape.c

2017-11-04 01:34:02 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (27006b3)

    director: Don't recreate timeout on every user lookup

    Recreate it only when the timeout should change.

M	src/director/user-directory.c

2017-11-05 23:11:25 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7d8c1ba)

    director: Fix off-by-one when checking if user weakness is stuck

    When the weakness was exactly at the second, the weakness wasn't detected 
    and the next expiration timeout was removed entirely. This shouldn't have 
    caused any bigger problems, because another user lookup on the following 
    second would have then detected the weakness, removed the user and restored 
    the next expiration timeout.

M	src/director/user-directory.c

2017-11-05 17:49:52 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (872c2b1)

    mbox: Add assert to make static analyzer happier


M	src/lib-storage/index/mbox/mbox-save.c

2017-11-05 17:46:03 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (58336fc)

    lib-http: Remove dead code

    This code branch became dead after 22ee6e1e6193299034ab99f77a650290de2fd6ca

M	src/lib-http/http-transfer-chunked.c

2017-11-03 17:28:57 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (a6366f3)

    lib-ssl-iostream: Fix alt cert support

    It was only partially implemented in
    0577701d04beea222fc49a7318851ddcea3b99d3

M	src/lib-ssl-iostream/iostream-openssl-context.c

2017-11-02 00:00:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (ba55ec8)

    lib: istream - Avoid panic in snapshot() with nonpersistent buffers


M	src/lib/istream.c

2017-11-02 22:57:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (30517c7)

    lib: istream - Don't leak snapshot memory if close() triggers a read

    Also move the line_str freeing just before stream is freed. That didn't 
    cause any known memory leaks though.

M	src/lib/istream.c

2017-11-02 23:24:38 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (81a99ee)

    lib: istream-jsonstr - Fix potential infinite loop if parent stream's
    max_buffer_size is tiny


M	src/lib/istream-jsonstr.c

2017-11-02 23:22:14 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (22ee6e1)

    global: i_stream_read_memarea() - Remove impossible ret==-2 checks

    If the stream's buffer is empty, i_stream_read_memarea() would have already 
    assert-crashed at this point.

M	src/lib-http/http-transfer-chunked.c
M	src/lib-mail/istream-dot.c
M	src/lib/istream-crlf.c

2017-11-02 23:01:20 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7f4bcbb)

    imap, pop3: Don't access login_set.*_socket_path after they're freed from
    data stack

    Call master_login_init() before master_service_init_finish(), which frees 
    all the data stack done in initialization.

    This didn't normally cause any visible problems, because data stack wasn't 
    currently being used in a way that the strings were invalidated. However, it
    was causing failures if --enable-devel-checks was used.

M	src/imap/main.c
M	src/pop3/main.c

2017-11-02 15:45:09 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (63e9db4)

    config: Properly fix ssl-parameters.dat handling

    It was done only partially right in a70d867d1fe3584149811c65eb6213deb72be824

M	src/config/config-request.c
M	src/config/config-request.h
M	src/config/doveconf.c

2017-11-01 21:44:54 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b833824)

    login-common: client_unref() - always set client pointer to NULL

    This is the common coding practise elsewhere as well.

M	src/login-common/client-common.c

2017-11-01 21:44:23 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5885eec)

    pop3-login: Cleanup - uncork output unconditionally before client_unref()


M	src/pop3-login/client.c

2017-11-01 21:41:18 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a44e36b)

    login-common: Remove unnecessary client_ref/unref from STARTTLS handling

    There used to be code between them that could have destroyed the connection, 
    but that was removed long time ago.

M	src/login-common/client-common.c

2017-10-31 23:51:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1b7459f)

    doveadm: Send hostname without ":port" as TLS SNI name for outgoing SSL
    connections.


M	src/doveadm/doveadm-dsync.c
M	src/doveadm/doveadm-mail-server.c
M	src/doveadm/doveadm-server.h
M	src/doveadm/server-connection.c

2017-11-02 12:00:42 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (a70d867)

    config: Do not run ssl_dh check always

    Do it only when CONFIG_DUMP_FLAG_CHECK_SETTINGS is set. Fixes

    "Warning: You can generate it with: dd if=ssl-parameters.dat bs=1
    skip=88..."

M	src/config/config-request.c

2017-07-03 11:17:16 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (2644ab2)

    dict-redis: Include last_reply in communications failure error

    This way it's possible to determine what went wrong.

M	src/lib-dict/dict-redis.c

2016-06-24 12:09:31 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (c755552)

    dict-redis: Added support for authentication.

    Patch by David Zambonini

M	src/lib-dict/dict-redis.c

2017-11-02 01:34:11 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5aa1aa8)

    lib: i_stream_w_buffer_realloc() - avoid passing NULL to memcpy()

    It happened only with size=0, so it shouldn't have mattered much.

M	src/lib/istream.c

2017-11-02 00:03:57 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d69c66d)

    imap-proxy: Don't discard the first pipelined command after LOGIN


M	src/imap-login/imap-proxy.c

2017-11-01 19:10:19 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (b1390ca)

    lib-storage: imapc - Fix spelling mistakes

    Original work by @jsoref

M	src/lib-storage/index/imapc/imapc-list.c

2017-11-01 19:10:07 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (7603577)

    lib-fs: Fix spelling mistakes

    Original work by @jsoref

M	src/lib-fs/fs-api.c

2017-11-01 19:09:55 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (9cc05ea)

    test-quota: Fix spelling mistakes

    Original work by @jsoref

M	src/plugins/quota/test-quota-util.c

2017-11-01 19:09:43 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (a3e5780)

    lazy-expunge: Fix spelling mistakes

    Original work by @jsoref

M	src/plugins/lazy-expunge/lazy-expunge-plugin.c

2017-11-01 19:09:28 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (21bd357)

    plugin-fts: Fix spelling mistakes

    Original work by @jsoref

M	src/plugins/fts/fts-expunge-log.c

2017-11-01 19:09:15 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (ed4bd0e)

    fts-squat: Fix spelling mistakes

    Original work by @jsoref

M	src/plugins/fts-squat/squat-trie.c

2017-11-01 19:09:04 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (31281f7)

    imap: Fix spelling mistakes

    Original work by @jsoref

M	src/imap/cmd-urlfetch.c

2017-11-01 19:08:54 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (688653d)

    director: Fix spelling mistakes

    Original work by @jsoref

M	src/director/director-connection.c

2017-11-01 19:08:40 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (d47cf08)

    mech-apop: Fix spelling mistake

    Original work by @jsoref

M	src/auth/mech-apop.c

2017-11-01 19:08:30 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (b890922)

    man: Fix spelling mistakes

    Original work by @jsoref

M	doc/man/doveadm-replicator.1.in
M	doc/man/doveadm.1.in

2017-11-01 19:07:26 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (19557f1)

    global: Fix spelling mistakes in comments

    Original work by @andreasschulze and @jsoref

M	doc/example-config/conf.d/20-pop3.conf
M	doc/example-config/conf.d/90-quota.conf
M	m4/notify.m4
M	src/auth/auth-request-handler.c
M	src/auth/db-checkpassword.c
M	src/auth/db-passwd-file.c
M	src/auth/mech-gssapi.c
M	src/config/config-parser.c
M	src/director/director-connection.c
M	src/imap-urlauth/imap-urlauth.c
M	src/imap/cmd-sort.c
M	src/lib-dcrypt/ostream-encrypt.c
M	src/lib-fs/fs-metawrap.c
M	src/lib-fts/fts-filter.h
M	src/lib-http/test-http-client-errors.c
M	src/lib-imap-client/imapc-connection.c
M	src/lib-index/mail-cache-transaction.c
M	src/lib-index/mail-index-map-hdr.c
M	src/lib-index/mail-index-map.c
M	src/lib-index/mail-index-strmap.h
M	src/lib-index/mail-index-transaction-finish.c
M	src/lib-index/mail-index-view.c
M	src/lib-index/mail-index.h
M	src/lib-index/mail-transaction-log-private.h
M	src/lib-index/mail-transaction-log.h
M	src/lib-mail/message-part-data.h
M	src/lib-ntlm/ntlm-des.c
M	src/lib-ntlm/ntlm-types.h
M	src/lib-otp/otp-hash.c
M	src/lib-settings/settings.c
M	src/lib-smtp/lmtp-client.h
M	src/lib-ssl-iostream/ostream-openssl.c
M	src/lib-storage/index/dbox-common/dbox-file.c
M	src/lib-storage/index/dbox-single/sdbox-file.h
M	src/lib-storage/index/index-search-mime.c
M	src/lib-storage/index/index-storage.c
M	src/lib-storage/index/maildir/maildir-sync.c
M	src/lib-storage/index/mbox/mbox-sync-rewrite.c
M	src/lib-storage/index/mbox/mbox-sync.c
M	src/lib-storage/list/mailbox-list-index-backend.c
M	src/lib-storage/list/mailbox-list-index-status.c
M	src/lib-storage/mailbox-attribute.c
M	src/lib/array.h
M	src/lib/buffer.c
M	src/lib/failures.c
M	src/lib/ioloop-epoll.c
M	src/lib/ioloop-kqueue.c
M	src/lib/istream.h
M	src/lib/net.h
M	src/lib/path-util.c
M	src/lib/sendfile-util.c
M	src/lib/seq-range-array.h
M	src/lib/wildcard-match.c
M	src/master/sd-daemon.h
M	src/master/service.h
M	src/plugins/acl/acl-backend-vfile-acllist.c
M	src/plugins/fs-compress/fs-compress.c
M	src/plugins/mail-crypt/doveadm-mail-crypt.c
M	src/plugins/mail-crypt/fs-crypt-common.c
M	src/plugins/mail-filter/istream-ext-filter.c
M	src/plugins/mail-filter/ostream-ext-filter.c
M	src/pop3/pop3-client.c

2017-11-01 18:04:57 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (787bbd4)

    fts-lucene: Do not clobber return value

    Found by scanbuild

M	src/plugins/fts-lucene/fts-backend-lucene.c

2017-10-26 13:56:25 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (2a550de)

    director: Show each director connection in doveadm DIRECTOR-LIST

    Previously the host was shown only once, regardless of how many connections 
    it had. This especially helps when there are just two directors, but also 
    can be useful when showing incoming/outgoing connections that are still in
    handshaking phase.

M	src/director/doveadm-connection.c

2017-10-26 14:10:51 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (cb3f509)

    doveadm director ring status: Add more fields related to connection status


M	src/director/doveadm-connection.c
M	src/doveadm/doveadm-director.c

2017-10-26 14:18:50 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (3dc72a4)

    director: Track show long the last ring sync took.


M	src/director/director-connection.c
M	src/director/director.c
M	src/director/director.h

2017-10-26 14:07:56 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (f1551f4)

    director: Track connections' last ping time


M	src/director/director-connection.c
M	src/director/director-connection.h

2017-10-26 13:07:30 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (56139ff)

    director: Add director_connection_get_status()

    Can be used to access connection-specific status information.

M	src/director/director-connection.c
M	src/director/director-connection.h

2017-10-26 13:02:32 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (a1febfe)

    director: Fix updating director connection's last_output timestamp

    It was previously updated only in ostream's flush callback, which was called 
    only when there were a lot of output. This only caused the "last output" 
    timestamp in disconnection log lines to be wrong.

M	src/director/director-connection.c

2017-10-26 12:44:34 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (20b6e49)

    doveadm director: Parse timestamp parameters with str_to_time()


M	src/doveadm/doveadm-director.c

2017-10-25 17:22:42 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (1511fc5)

    director: Close director connection immediately when output buffer is full

    Only the ostream was closed, which didn't actually cause the disconnection 
    until the other side closed the connection.

M	src/director/director-connection.c

2017-10-25 17:18:03 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (311cf36)

    director: Add director_output_buffer_size setting

    This allows configuring the max buffer size for outgoing connections. 
    Previously it was hardcoded to 10 MB, which wasn't necessarily enough for 
    very busy directors.

M	src/director/director-connection.c
M	src/director/director-settings.c
M	src/director/director-settings.h

2017-10-31 23:37:44 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4584a00)

    lib-ssl-iostream: Verify SSL server's hostname against cert if it's non-NULL

    The hostname verification was skipped when handshake-callback wasn't used. 
    All of the existing code used the callback though, so this doesn't fix any
    bugs.

M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-31 19:49:56 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (4cc6874)

    lib-ssl-iostream: Fix checking cert validity when handshake callback isn't
    used


M	src/lib-ssl-iostream/iostream-openssl.c

2017-11-01 12:58:46 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d185226)

    lib-ssl-iostream: Split host to connected_host and sni_host

    Using the same variable for both was causing confusion.

M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h

2017-09-22 11:38:10 +0300 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (9a84b90)

    global: start relying on [io]_stream_close(NULL) being a no-op

    Cleanup performed with the following semantic patch (and a bit of 
    hand-editing):

    	@@
    expression E;
    @@

    	- if (E != NULL) {
    - 	i_stream_close(E);
    - }
    + i_stream_close(E);

    	@@
    expression E;
    @@

    	- if (E != NULL) {
    - 	o_stream_close(E);
    - }
    + o_stream_close(E);

M	src/auth/auth-master-connection.c
M	src/auth/auth-postfix-connection.c
M	src/lib-smtp/lmtp-client.c
M	src/lib/connection.c
M	src/lib/istream-seekable.c
M	src/lib/istream.c
M	src/lib/ostream.c
M	src/login-common/client-common.c
M	src/replication/aggregator/notify-connection.c

2017-09-22 11:29:35 +0300 Josef 'Jeff' Sipek <jeff.sipek@dovecot.fi> (660ecba)

    lib: [io]_stream_close(NULL) should be no-ops


M	src/lib/istream.c
M	src/lib/ostream.c

2017-11-01 14:40:51 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (322400f)

    lib-index: Fix -Wstrict-bool warnings with --enable-devel-checks


M	src/lib-index/mail-index-sync-update.c

2017-10-27 21:20:36 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (bcd2866)

    global: Use i_stream_read_memarea() wherever possible


M	src/lib-dcrypt/istream-decrypt.c
M	src/lib-fs/istream-metawrap.c
M	src/lib-http/http-transfer-chunked.c
M	src/lib-mail/istream-dot.c
M	src/lib-mail/istream-header-filter.c
M	src/lib-mail/istream-nonuls.c
M	src/lib-mail/istream-qp-decoder.c
M	src/lib-mail/istream-qp-encoder.c
M	src/lib-program-client/program-client-remote.c
M	src/lib-storage/index/mbox/istream-raw-mbox.c
M	src/lib/istream-base64-decoder.c
M	src/lib/istream-base64-encoder.c
M	src/lib/istream-chain.c
M	src/lib/istream-concat.c
M	src/lib/istream-crlf.c
M	src/lib/istream-jsonstr.c
M	src/lib/istream-limit.c
M	src/lib/istream-multiplex.c
M	src/lib/istream-rawlog.c
M	src/lib/istream-seekable.c
M	src/lib/istream-sized.c
M	src/lib/istream.c
M	src/plugins/mail-filter/istream-ext-filter.c

2017-10-27 21:32:10 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (fa39c42)

    lib: i_stream_compress() - assert-crash if trying to compress shared memarea

    The caller is always expected to check the refcount before calling this.

M	src/lib/istream.c

2017-10-27 21:22:04 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (66967e1)

    lib: i_stream_read() - Add buffer validity checks if DEBUG is enabled


M	src/lib/istream.c

2017-10-27 21:17:23 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (e0fab14)

    lib: i_stream_read() - Use snapshots

    This guarantees that data returned by i_stream_get_data() won't be freed 
    until the next i_stream_read() returns >0. This is mainly important, because
    often the error handling for <=0 doesn't update the buffer pointers
    correctly and it leads to complicated bugs where already freed memory is
    attempted to be read (but never written).

M	src/lib/istream-private.h
M	src/lib/istream.c
M	src/lib/istream.h

2017-10-27 21:13:40 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (25c833d)

    lib: Use ISTREAM_CREATE_FLAG_NOOP_SNAPSHOT where useful


M	src/lib/istream-chain.c
M	src/lib/istream-concat.c
M	src/lib/istream-data.c
M	src/lib/istream-tee.c

2017-10-27 21:13:20 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (89a8973)

    lib: Add ISTREAM_CREATE_FLAG_NOOP_SNAPSHOT flag


M	src/lib/istream-private.h
M	src/lib/istream.c

2017-10-27 21:08:26 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (2974dca)

    global: Add flags parameter to i_stream_create() and set it to 0

    This just changes the API - the following changes add the new flag.

M	src/lib-compression/istream-bzlib.c
M	src/lib-compression/istream-lz4.c
M	src/lib-compression/istream-lzma.c
M	src/lib-compression/istream-zlib.c
M	src/lib-dcrypt/istream-decrypt.c
M	src/lib-fs/istream-fs-file.c
M	src/lib-fs/istream-fs-stats.c
M	src/lib-fs/istream-metawrap.c
M	src/lib-http/http-server-request.c
M	src/lib-http/http-transfer-chunked.c
M	src/lib-mail/istream-attachment-extractor.c
M	src/lib-mail/istream-binary-converter.c
M	src/lib-mail/istream-dot.c
M	src/lib-mail/istream-header-filter.c
M	src/lib-mail/istream-nonuls.c
M	src/lib-mail/istream-qp-decoder.c
M	src/lib-mail/istream-qp-encoder.c
M	src/lib-program-client/program-client-remote.c
M	src/lib-ssl-iostream/istream-openssl.c
M	src/lib-storage/index/istream-mail.c
M	src/lib-storage/index/mbox/istream-raw-mbox.c
M	src/lib-test/test-istream.c
M	src/lib/istream-base64-decoder.c
M	src/lib/istream-base64-encoder.c
M	src/lib/istream-callback.c
M	src/lib/istream-chain.c
M	src/lib/istream-concat.c
M	src/lib/istream-crlf.c
M	src/lib/istream-data.c
M	src/lib/istream-failure-at.c
M	src/lib/istream-file.c
M	src/lib/istream-hash.c
M	src/lib/istream-jsonstr.c
M	src/lib/istream-limit.c
M	src/lib/istream-mmap.c
M	src/lib/istream-multiplex.c
M	src/lib/istream-private.h
M	src/lib/istream-rawlog.c
M	src/lib/istream-seekable.c
M	src/lib/istream-sized.c
M	src/lib/istream-tee.c
M	src/lib/istream-timeout.c
M	src/lib/istream-try.c
M	src/lib/istream.c
M	src/plugins/mail-filter/istream-ext-filter.c

2017-10-27 21:28:51 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (58e397e)

    lib-ssl-iostream: Simplify istream-openssl

    Partially reverts 739125f23e3312045e620014812fe2249a309cc4. This is no 
    longer needed because of the io_set_pending() changes.

M	src/lib-ssl-iostream/istream-openssl.c

2017-10-27 20:49:07 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (ef4661a)

    lib-compression: Use i_stream_try_alloc*()


M	src/lib-compression/istream-bzlib.c
M	src/lib-compression/istream-lzma.c
M	src/lib-compression/istream-zlib.c

2017-10-27 20:45:41 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (51d379c)

    lib: Add i_stream_try_alloc_avoid_compress()


M	src/lib/istream-private.h
M	src/lib/istream.c

2017-10-27 20:38:49 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (e050398)

    lib-compression: istream-lz4 - Use i_stream_alloc()


M	src/lib-compression/istream-lz4.c

2017-10-26 18:36:09 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (f5d8e05)

    lib-mail: istream-attachment-extractor - Don't modify buffer during failure

    If i_stream_read() returns -1 because the attachment file couldn't be 
    created, don't add the trailing data to the main istream. It's not useful, 
    and the following extra checks will cause it to assert-crash.

M	src/lib-mail/istream-attachment-extractor.c

2017-09-08 14:59:37 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (d74c9f4)

    lib: istream-mmap - Use memarea API


M	src/lib/istream-mmap.c

2017-10-26 17:12:04 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (448ab35)

    lib: istream-seekable - Implement snapshot()


M	src/lib/istream-seekable.c

2017-10-26 16:37:49 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (3e55775)

    lib: istream-seekable - Change to use i_stream_*alloc()

    This simplifies implementing the snapshotting.

M	src/lib/istream-seekable.c

2017-10-26 17:10:57 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (3fe5eae)

    lib: istream-seekable - Fix fd leak if initial temp file couldn't be read
    back

    That should normally never happen.

M	src/lib/istream-seekable.c

2017-10-26 15:17:04 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (82ea464)

    lib: Add istream.snapshot() method for referencing the current memarea

    It will be used by following commits.

M	src/lib/istream-private.h
M	src/lib/istream.c

2017-10-26 15:22:26 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (5181e19)

    lib-test: istream-test - use memarea API


M	src/lib-test/test-istream.c

2017-09-08 14:25:41 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (5ca745a)

    lib: Use memarea for default istream memory allocations.


M	src/lib/istream-private.h
M	src/lib/istream.c

2017-10-26 16:25:51 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (54bd0fe)

    global: Use i_stream_free_buffer() instead of freeing w_buffer directly


M	src/lib-http/http-transfer-chunked.c
M	src/lib-ssl-iostream/istream-openssl.c
M	src/lib/istream-chain.c
M	src/lib/istream-concat.c
M	src/lib/istream-multiplex.c
M	src/lib/istream.c

2017-10-26 16:24:50 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (785ee8b)

    lib: Add i_stream_free_buffer() to free i_stream_*alloc()ed memory


M	src/lib/istream-private.h
M	src/lib/istream.c

2017-09-08 13:33:27 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (4c7d704)

    lib: Add memarea API

    This can be used to create reference counted memory areas where a callback 
    is called once the refcount drops to zero.

M	src/lib/Makefile.am
A	src/lib/memarea.c
A	src/lib/memarea.h
M	src/lib/test-lib.inc
A	src/lib/test-memarea.c

2017-10-26 14:56:26 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (59a6379)

    lib: istream-chain/concat cleanup - return early if no new data is read

    There's no need to change the buffer or other variables. This simplifies the
    following changes.

    This cleanup is identical for istream-concat and istream-chain.

M	src/lib/istream-chain.c
M	src/lib/istream-concat.c

2017-01-20 17:34:50 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (fdf15b2)

    lib-mail: istream-header-filter - Fix header read() when max_buffer_size=0

    If the buffer was too small to read anything into it, read_header() returned
    -2, but then it continued reading the header as if it was the body already. 
    This should instead be an error situation - max buffer size just shouldn't
    be 0 at this point.

    This was originally changed in a72355fef49c512c13b7d8c3e07f4f76ebd57a10 as 
    some kind of a workaround, but since then we implemented support for reading 
    a mixed header/body in c2afdbf963d0564a542d71ca784deb0c2f7776d0.

M	src/lib-mail/istream-header-filter.c

2017-10-30 13:58:54 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a6657bc)

    imap: Set max buffer size for CATENATE istream-chain

    This fixes a crash with mbox when nonexistent CATENATE URL is attempted to 
    be used. The istream doesn't get any size, and istream-header-filter panics 
    due to having reached the maximum buffer size (0), even though the stream is 
    empty and there's nothing to read.

M	src/imap/cmd-append.c

2017-01-20 16:28:53 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d506fc3)

    lib: Add assert to io_stream_ref()

    This makes an assert-crash likely to happen if iostream was already freed.

M	src/lib/iostream.c

2017-11-01 13:01:03 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (97b6a92)

    doveadm: Ignore errors also on outgoing SSL connection ostreams

    Setting the errors as ignored on the plain ostream was done too late, so ssl 
    ostream didn't inherit the error handling flag.

M	src/doveadm/server-connection.c

2017-10-30 00:30:13 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (987c15a)

    lib: iostream-proxy - Specify what failed in completion callback parameter


M	src/lib/iostream-proxy.c
M	src/lib/iostream-proxy.h
M	src/lib/test-iostream-proxy.c

2017-10-30 00:16:35 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (39435f0)

    lib: iostream-pump - Specify what failed in completion callback parameter

    This makes it easier for the caller to find out whether the failure was due 
    to istream or ostream.

M	src/lib-http/http-server-request.c
M	src/lib/iostream-proxy.c
M	src/lib/iostream-pump.c
M	src/lib/iostream-pump.h
M	src/lib/test-iostream-pump.c

2017-10-29 23:53:16 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6ce52ed)

    lib: iostream-proxy - Add iostream_proxy_is_waiting_output()


M	src/lib/iostream-proxy.c
M	src/lib/iostream-proxy.h

2017-10-29 23:53:00 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (fe4a546)

    lib: iostream-pump - Add iostream_pump_is_waiting_output()


M	src/lib/iostream-pump.c
M	src/lib/iostream-pump.h

2017-10-30 01:07:36 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (3bc5b80)

    lib: iostream-pump - Fix crash in iostream_pump_switch_ioloop() if io is
    NULL

    This would happen when the pump's ostream is full and it has stopped 
    listening for input.

M	src/lib/iostream-pump.c

2017-10-29 23:28:38 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (84b746f)

    lib: iostream-pump - Cork the ostream when writing

    This reduces latency for TCP connections by disabling Nagle algorithm.

M	src/lib/iostream-pump.c
M	src/lib/test-iostream-pump.c

2017-10-31 20:05:19 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (103e63c)

    doveadm-server: Deinitialize log proxying before closing SSL iostream

    Otherwise the SSL iostream destroying may trigger debug/error logging, which
    attempts to proxy logs when the stream is already closed. This caused a
    panic.

M	src/doveadm/client-connection-tcp.c

2017-10-31 19:24:21 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a36cac1)

    dbox: Don't finish dbox's ostream when mail is saved

    Fixes assert-crash when saving mail when using zlib plugin.

M	src/lib-storage/index/dbox-common/dbox-file.c

2017-10-31 17:27:05 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8e8b9d0)

    lib-compression: Fix unit test to not crash


M	src/lib-compression/test-compression.c

2017-10-31 17:24:06 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6519bf9)

    lib-mail: ostream-dot - Set o_stream_set_finish_also_parent(FALSE) by
    default

    ostream-dot is always used inside another ostream to implement some kind of 
    data escaping. The ostream-dot always has to be finished to write the "." 
    line, but the caller never wants it to finish the parent stream.

M	src/lib-mail/ostream-dot.c

2017-10-31 17:20:22 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (03e102d)

    lib-fs: fs-metawrap - Don't try to write to an already finished ostream

    Fixes a crash after recent changes when trying to write an empty file via 
    fs-metawrap.

M	src/lib-fs/fs-metawrap.c

2017-10-31 17:09:47 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8a4a0ef)

    lib: connection - Use o_stream_set_finish_via_child(FALSE)

    This allows o_stream_finish() calls on child streams without closing this 
    parent stream. Since the stream has no error checking by default anyway, 
    this allows the connection stream to be used more easily.

M	src/lib/connection.c

2017-10-31 17:07:44 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (d6193a8)

    lib: Add o_stream_set_finish_also_parent() and _finish_via_child()

    These allow controlling on both directions whether o_stream_finish() should 
    be finishing the parent stream. If either one is set to FALSE, the parent 
    stream isn't finished. Which one of these to use depends on the situation.

M	src/lib/ostream-private.h
M	src/lib/ostream.c
M	src/lib/ostream.h

2017-10-31 15:05:01 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (8109f31)

    global: Use o_stream_flush_parent()


M	src/lib-compression/ostream-bzlib.c
M	src/lib-compression/ostream-lz4.c
M	src/lib-compression/ostream-lzma.c
M	src/lib-compression/ostream-zlib.c
M	src/lib-dcrypt/ostream-encrypt.c
M	src/lib-mail/ostream-dot.c
M	src/lib/ostream-escaped.c
M	src/lib/ostream-failure-at.c
M	src/lib/ostream.c
M	src/plugins/mail-filter/ostream-ext-filter.c

2017-10-31 15:00:51 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (5df4dbc)

    lib: Add o_stream_flush_parent()


M	src/lib/ostream-private.h
M	src/lib/ostream.c

2017-10-31 17:42:15 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (b9b86a2)

    lib: istream-base64-encoder - Fix getting size for empty stream


M	src/lib/istream-base64-encoder.c
M	src/lib/test-istream-base64-encoder.c

2017-10-31 12:16:41 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (f134770)

    lib-master: Use skip_crl_check for ssl context


M	src/lib-master/master-service-ssl.c

2017-10-16 10:56:17 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (7548965)

    lib-master: Load SSL module if wanted by service


M	src/lib-master/master-service.c
M	src/lib-master/master-service.h

2017-10-16 10:47:36 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (30dca95)

    lib-master: Add master_service_ssl_settings_to_iostream_set


M	src/lib-master/master-service-ssl-settings.c
M	src/lib-master/master-service-ssl-settings.h

2017-10-31 10:10:39 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (1570746)

    lib-master: Support alternative cert in master_service_ssl_ctx_init


M	src/lib-master/master-service-ssl.c

2017-10-24 14:43:51 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (98c2cac)

    lib-ssl-iostream: Seed OpenSSL RNG earlier

    Make sure we give the RNG a chance to seed before we chroot.

M	src/lib-ssl-iostream/dovecot-openssl-common.c
M	src/lib-ssl-iostream/iostream-openssl.c

2017-09-07 10:19:36 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (997b30e)

    lib-ssl-iostream: Expose ssl_module_load

    We need to load SSL module before we chroot in login-common.

M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2016-10-03 12:04:26 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (c141f36)

    lib-ssl-iostream: Use named initializers


M	src/lib-ssl-iostream/iostream-openssl.c

2016-09-26 13:55:17 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (ca55f7e)

    lib-ssl-iostream: Remove input_handler flag

    It is no longer needed after 87da941c

M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/istream-openssl.c

2016-09-26 13:52:33 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (48e2439)

    lib-ssl-iostream: Add get_compression accessor

    This is needed by login-common

M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-ssl-private.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2016-10-03 13:39:35 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (1fea3af)

    lib-ssl-iostream: Close ostream before istream

    If i_stream is autoclose, then o_stream close will fail if done after
    i_stream close.

M	src/lib-ssl-iostream/iostream-openssl.c

2016-10-03 12:38:35 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (978edad)

    lib-ssl-iostream: Allow skipping CRL check


M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-30 14:08:23 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (0577701)

    lib-ssl-iostream: Add alternate certificate support


M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-30 14:06:36 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (9f7ba38)

    global: Splice cert into separate struct from iostream_ssl_settings


M	src/auth/db-oauth2.c
M	src/lib-ldap/ldap-connection.c
M	src/lib-master/master-service-ssl.c
M	src/lib-ssl-iostream/iostream-openssl-context.c
M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/iostream-ssl.c
M	src/lib-ssl-iostream/iostream-ssl.h

2017-10-31 17:01:26 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (c75fd96)

    lib-fs: test-fs-posix - Fix checking whether unlink_directory() failed


M	src/lib-fs/test-fs-posix.c

2017-10-30 20:30:03 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (65ef833)

    man: Update manpage for mailbox delete command


M	doc/man/doveadm-mailbox.1.in

2017-10-30 19:29:02 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (32c7865)

    lib: Don't use NEEDS_LOCAL_CREDS undefined


M	src/lib/net.c

2017-10-30 16:06:39 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (1bc075e)

    global: Rename i_stream_is_eof() to i_stream_read_eof()

    This describes its behavior a bit better.

M	src/lib-compression/istream-zlib.c
M	src/lib-fs/fs-sis.c
M	src/lib-http/http-server-request.c
M	src/lib-oauth2/oauth2.c
M	src/lib-program-client/program-client.c
M	src/lib-storage/index/dbox-common/dbox-file.c
M	src/lib-storage/index/dbox-multi/mdbox-purge.c
M	src/lib-storage/index/index-mail-binary.c
M	src/lib/istream.c
M	src/lib/istream.h

2017-10-30 16:11:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (a05250b)

    global: Avoid i_stream_is_eof() where it's not necessary


M	src/lib-http/test-http-server-errors.c
M	src/lib-smtp/test-smtp-submit.c
M	src/lib/test-istream-chain.c
M	src/lib/test-istream-concat.c
M	src/lib/test-istream-seekable.c

2017-10-30 16:06:21 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (6a170d6)

    lib: Improve i_stream_is_eof() comment


M	src/lib/istream.h

2017-10-30 16:01:31 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (7b29ccd)

    lib: Update struct istream comments


M	src/lib/istream.h

2017-10-30 16:00:13 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (2a8454f)

    lib-http: If istream read fails, preserve the istream's full error message


M	src/lib-http/http-header-parser.c
M	src/lib-http/http-message-parser.c
M	src/lib-http/http-response-parser.c

2017-10-30 15:59:46 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (f48fad9)

    lib-http: test-http-client-errors - fix typo in error message


M	src/lib-http/test-http-client-errors.c

2017-10-30 15:58:43 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (53393ea)

    lib-http: Detect istream errors correctly.

    i_stream_is_eof() returns TRUE also when streams have an error, so all 
    errors were logged the same as a regular disconnection.

M	src/lib-http/http-header-parser.c
M	src/lib-http/test-http-client-errors.c

2017-10-30 16:39:21 +0200 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (d61f316)

    lib,lib-index: Use #ifdef with WORDS_BIGENDIAN

    Some were missing from the last change.

M	src/lib-index/mail-transaction-log-file.c
M	src/lib/byteorder.h
M	src/lib/sha1.c

2017-10-28 02:57:37 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (5bc7508)

    global: Remove explicit o_stream_flush() calls from ostream.close() methods

    It's now being done automatically.

M	src/lib-compression/ostream-bzlib.c
M	src/lib-compression/ostream-lz4.c
M	src/lib-compression/ostream-lzma.c
M	src/lib-fs/ostream-cmp.c
M	src/lib/ostream-file.c
M	src/lib/ostream-multiplex.c
M	src/lib/ostream-rawlog.c

2017-10-28 02:55:22 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (5ec4fc4)

    lib: Automatically flush ostream when it's closed

    Also verify that it unexpectedly didn't get fully flushed.

M	src/lib/ostream.c
M	src/lib/ostream.h

2017-10-28 02:45:58 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (ec2c310)

    mail-filter: ostream-ext-filter - Require o_stream_finish() to be called

    Similar to ostream-zlib.

M	src/plugins/mail-filter/ostream-ext-filter.c

2017-10-28 02:43:16 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (a258339)

    lib-mail: ostream-dot - Require o_stream_finish() to write the trailer

    Similar to ostream-zlib.

M	src/doveadm/server-connection.c
M	src/lib-mail/ostream-dot.c
M	src/lib-mail/test-ostream-dot.c
M	src/lib-program-client/program-client.c
M	src/lib-program-client/test-program-client-net.c

2017-10-28 02:35:58 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (de535bb)

    lib: ostream-multiplex - Don't close parent streams at destroy

    The close() method is already called as needed.

M	src/lib/ostream-multiplex.c

2017-10-28 02:21:48 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (6630a57)

    lib-dcrypt: ostream-dcrypt - Require o_stream_finish() to write the trailer

    Similar to ostream-zlib.

M	src/lib-dcrypt/ostream-encrypt.c

2017-10-28 02:09:58 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (6fb8641)

    lib-compression: ostream-zlib - Require o_stream_finish() to write the
    trailer

    It's now possible to call o_stream_flush() without the trailer getting 
    written.

    It's also now required to call o_stream_finish() to write the trailer before 
    closing the ostream. This guarantees that the caller checks that the trailer
    was successfully written. This isn't needed if the ostream already failed
    before writing the trailer.

M	src/lib-compression/ostream-zlib.c
M	src/lib-compression/test-compression.c

2017-10-28 02:07:32 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (4805c8a)

    lib: Remove o_stream_nfinish()


M	src/lib/ostream.h

2017-10-28 02:06:56 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (d1ba8ec)

    global: Replace o_stream_nfinish() with o_stream_flush()


M	src/auth/auth-worker-client.c
M	src/lib-auth/auth-master.c
M	src/lib-fs/fs-api.h
M	src/lib-storage/index/dbox-common/dbox-file-fix.c
M	src/lib-storage/index/dbox-common/dbox-file.c
M	src/lib-storage/index/dbox-common/dbox-save.c
M	src/lib-storage/index/dbox-multi/mdbox-purge.c
M	src/lib-storage/index/mbox/mbox-save.c
M	src/lib/iostream-rawlog.c
M	src/lmtp/commands.c

2017-10-28 01:55:12 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (ad9afb6)

    global: Replace o_stream_nfinish() with o_stream_finish() whenever possible


M	src/doveadm/client-connection-http.c
M	src/doveadm/dsync/dsync-ibc-stream.c
M	src/lib-compression/test-compression.c
M	src/lib-dcrypt/test-stream.c
M	src/lib-dict/dict-file.c
M	src/lib-fs/fs-api.c
M	src/lib-index/mail-cache-compress.c
M	src/lib-index/mail-index-strmap.c
M	src/lib-index/mail-index-write.c
M	src/lib-mail/istream-attachment-extractor.c
M	src/lib-mail/test-istream-attachment.c
M	src/lib-master/master-instance.c
M	src/lib-program-client/test-program-client-net.c
M	src/lib-program-client/test-program-client-unix.c
M	src/lib-storage/index/cydir/cydir-save.c
M	src/lib-storage/index/dbox-common/dbox-save.c
M	src/lib-storage/index/dbox-single/sdbox-file.c
M	src/lib-storage/index/imapc/imapc-save.c
M	src/lib-storage/index/maildir/maildir-save.c
M	src/lib-storage/index/maildir/maildir-uidlist.c
M	src/lib-storage/list/subscription-file.c
M	src/lib-storage/mail-duplicate.c
M	src/lib/test-istream-multiplex.c
M	src/lib/test-multiplex.c
M	src/lib/test-ostream-buffer.c
M	src/lib/test-ostream-file.c
M	src/lib/test-ostream-multiplex.c
M	src/plugins/acl/acl-backend-vfile-acllist.c
M	src/plugins/acl/acl-backend-vfile-update.c
M	src/plugins/fts-squat/squat-trie.c
M	src/plugins/fts-squat/squat-uidlist.c
M	src/replication/replicator/replicator-queue.c
M	src/util/rawlog.c

2017-10-28 01:15:14 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (84717f0)

    lib: Add o_stream_finish()

    This marks the ostream as fully finished, with no further writes coming to 
    it. Otherwise it behaves like o_stream_flush().

    The ostream.flush() methods are supposed to write their trailer (if the 
    ostream has one) when they see that ostream.finished is set. These will be 
    implemented by the following commits.

M	src/lib/ostream-private.h
M	src/lib/ostream.c
M	src/lib/ostream.h

2017-10-28 02:02:13 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (34d5077)

    lib: o_stream_flush() - check for send overflows and reset error handling

    This begins the removal of o_stream_nfinish().

M	src/lib/ostream.c
M	src/lib/ostream.h

2017-10-28 00:59:57 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (b688884)

    lib: Remove o_stream_nflush()

    None of its previous callers were calling it correctly, so it's better to 
    remove it entirely to avoid more of such wrong calls.

M	src/lib/ostream.c
M	src/lib/ostream.h

2017-10-28 00:54:37 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (401b336)

    imap: Make sure long COPY commands send "* OK Hang in there" packets

    o_stream_nflush() already flushed the writes to kernel, and Linux should 
    have sent them after 200ms delay, so this probably doesn't fix anything. 
    Using uncork+cork is a bit clearer way to indicate that the data really is
    wanted to be sent now.

M	src/imap/cmd-copy.c

2017-10-28 00:48:01 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (414bbc6)

    lib-imap: When sending "+ OK" to client, uncork ostream immediately

    This makes sure that it's sent to the client as soon as possible.

    Also removed o_stream_nflush(), since uncorking does that already. If there
    is no corking, the "+ OK" was already attempted to be sent by the
    o_stream_nsend() call and a flush is unlikely to help.

M	src/lib-imap/imap-parser.c

2017-10-27 23:31:32 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (f81141f)

    global: Remove unnecessary o_stream_nflush() calls

    The following o_stream_nfinish() or o_stream_uncork() calls it anyway.

M	src/imap/cmd-append.c
M	src/imap/cmd-setmetadata.c
M	src/imap/imap-client.c
M	src/lib-http/http-server-connection.c
M	src/lib-index/mail-index-write.c

2017-10-27 23:31:56 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (23c8c51)

    lib: o_stream_uncork() - call o_stream_nflush() instead of o_stream_flush()

    Otherwise flush errors may be unintentionally ignored. This change requires 
    that all the o_stream_uncork() callers must call o_stream_nfinish() 
    afterwards, unless the ostream is set to ignore errors.

M	src/lib/ostream-file.c
M	src/lib/ostream.c
M	src/lib/ostream.h

2017-10-28 00:13:28 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (7e41ef2)

    lib: test-ostream-* - Call o_stream_nfinish() after uncorking


M	src/lib/test-ostream-buffer.c
M	src/lib/test-ostream-file.c

2017-10-30 11:56:32 +0200 Aki Tuomi <aki.tuomi@dovecot.fi> (2fc1835)

    configure: Add support for EXTRA_LDFLAGS


M	configure.ac

2017-10-30 11:19:17 +0200 Timo Sirainen <timo.sirainen@dovecot.fi> (e01ebd5)

    imapc: Add imapc_features=fetch-empty-is-expunged

    When FETCH returns an empty mail, the mail is assumed to be expunged.

M	src/lib-storage/index/imapc/imapc-mail-fetch.c
M	src/lib-storage/index/imapc/imapc-settings.c
M	src/lib-storage/index/imapc/imapc-settings.h

2017-10-27 11:03:07 +0300 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (debc93e)

    global: Use #ifdef instead of #if with WORDS_BIGENDIAN

    This is to not rely on undefined WORDS_BIGENDIAN being evaluated as 0.

M	src/lib-index/mail-index-map-hdr.c
M	src/lib-index/mail-index-map.c
M	src/lib-index/mail-transaction-log-file.c
M	src/lib/byteorder.h
M	src/lib/sha1.c
M	src/lib/test-byteorder.c

2017-10-27 11:08:36 +0300 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (d534a96)

    lib/compat.h: Undefine WORDS_BIGENDIAN when it's defined as 0


M	src/lib/compat.h

2017-10-27 11:02:25 +0300 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (e350413)

    m4: Use AC_C_BIGENDIAN instead of custom m4


M	configure.ac
D	m4/endian.m4

2017-10-24 10:27:23 +0300 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (111673e)

    lib-storage: Replace DBOX_GUID_BIN_LEN with GUID_128_SIZE

    DBOX_GUID_BIN_LEN define was removed in 0c909e, replace the use with 
    GUID_128_SIZE.

M	src/lib-storage/mail.c

2017-10-24 10:24:23 +0300 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (0c347e9)

    director: Don't use undefined DIRECTOR_CONNECTION_PING_TIMEOUT_MSECS


M	src/director/director-connection.c

2017-10-24 10:23:20 +0300 Martti Rannanjärvi <martti.rannanjarvi@dovecot.fi> (0a8db75)

    auth: Don't use undefined SASL_VERSION_MAJOR


M	src/auth/db-ldap.c

2017-10-28 15:21:29 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (6fc4067)

    global: Rename client_connection_type to doveadm_connection_type


M	src/doveadm/client-connection-http.c
M	src/doveadm/client-connection-private.h
M	src/doveadm/client-connection-tcp.c
M	src/doveadm/client-connection.c
M	src/doveadm/client-connection.h
M	src/doveadm/doveadm-cmd.h
M	src/doveadm/doveadm-dsync.c
M	src/doveadm/doveadm-kick.c
M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm.c
M	src/doveadm/doveadm.h
M	src/plugins/mail-crypt/doveadm-mail-crypt.c

2017-10-27 21:57:31 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (2ba5e7d)

    doveadm: Rename client_connection_type to doveadm_client_connection_type

    Move it to doveadm.h to allow plugins use doveadm-cmd.h

M	src/doveadm/client-connection-private.h
M	src/doveadm/client-connection.c
M	src/doveadm/client-connection.h
M	src/doveadm/doveadm-cmd.h
M	src/doveadm/doveadm-kick.c
M	src/doveadm/doveadm.h

2017-10-27 22:06:28 +0300 Aki Tuomi <aki.tuomi@dovecot.fi> (d29c679)

    doveadm: Reorder includes

    This makes next commit possible

M	src/doveadm/doveadm-cmd.c
M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm-print-formatted.c
M	src/doveadm/doveadm-print-json.c
M	src/doveadm/doveadm-print-server.c
M	src/doveadm/main.c

2017-10-23 12:01:27 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (d81702d)

    quota: Improve error messages


M	src/plugins/quota/quota-storage.c
M	src/plugins/quota/quota.c

2017-10-18 16:21:52 +0300 Timo Sirainen <timo.sirainen@dovecot.fi> (39eefc5)

    quota-fs: Default to quota API v2 if _LINUX_QUOTA_VERSION is undefined.

    glibc v2.25 drops v1 support in sys/quota.h and doesn't define
    _LINUX_QUOTA_VERSION.

M	src/plugins/quota/quota-fs.c

2017-10-17 15:44:38 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (cf6131b)

    doveadm-server: http: Properly implemented error handling for requests.


M	src/doveadm/client-connection-http.c

2017-10-17 18:03:59 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (456e3b9)

    doveadm-server: http: Mark the HTTP request for connection closure right
    away.

    This means that the connection is closed once the request finishes. Before,
    each response did that individually. Once connection reuse is
    implemented/needed this can now be turned off at one place.

M	src/doveadm/client-connection-http.c

2017-10-11 00:57:08 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (556a202)

    doveadm-server: http: Restructured JSON parsing to improve code clarity.

    Made state machine more explicit and easier to understand. Also added more
    comments.

M	src/doveadm/client-connection-http.c

2017-10-16 23:27:45 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (2511999)

    doveadm-server: http: Wrapped long code lines.


M	src/doveadm/client-connection-http.c

2017-10-11 00:10:38 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (2341eb7)

    doveadm-server: http: Joined JSON parsing and handling in one function.


M	src/doveadm/client-connection-http.c

2017-10-10 23:51:57 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (39e0111)

    doveadm-server: http: Split JSON handling into several sub-functions.


M	src/doveadm/client-connection-http.c

2017-10-08 13:27:26 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e97a359)

    doveadm-server: http: Split JSON parsing into several sub-functions.


M	src/doveadm/client-connection-http.c

2017-10-27 09:36:39 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (2ccd63d)

    doveadm-server: http: Changed request parse error into an assertion.

    The condition can never occur when json-parser and the request parsing state
    machine are behaving correctly. At that point only an object key can be
    returned; the client cannot cause it to return anything else.

M	src/doveadm/client-connection-http.c

2017-10-10 20:28:00 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (664503c)

    doveadm-server: http: Moved doveadm_http_server_command_execute().


M	src/doveadm/client-connection-http.c

2017-10-08 01:19:34 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (ce916cf)

    doveadm-server: http: Renamed parse state enum.


M	src/doveadm/client-connection-http.c

2017-10-07 22:33:26 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (4578694)

    doveadm-server: http: Split off request handling in separate struct, so that
    the connection can be reused.


M	src/doveadm/client-connection-http.c

2017-10-08 11:52:53 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (14e38f2)

    doveadm-server: http: Added structural comments.


M	src/doveadm/client-connection-http.c

2017-10-08 11:44:40 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (5927e94)

    doveadm-server: http: Moved doveadm_http_server_request_destroy().


M	src/doveadm/client-connection-http.c

2017-10-07 19:11:04 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (8bbeec7)

    doveadm-server: http: Moved doveadm_http_server_send_response().


M	src/doveadm/client-connection-http.c

2017-10-07 19:08:03 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (437eb0a)

    doveadm-server: http: Moved connection-related code to the bottom of the
    file.


M	src/doveadm/client-connection-http.c

2017-10-07 18:52:57 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (3dee112)

    doveadm-server: http: Make http_server_set a local variable of
    doveadm_http_server_init().


M	src/doveadm/client-connection-http.c

2017-10-07 18:47:53 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (bcb83bf)

    doveadm-server: http: Create the http_response once needed, not
    preemptively.


M	src/doveadm/client-connection-http.c

2017-10-07 18:31:44 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (8b24f7b)

    doveadm-server: http: Split authentication into multiple functions.


M	src/doveadm/client-connection-http.c

2017-10-07 17:37:41 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (f607f62)

    doveadm-server: http: Renamed conn->http_server_request to
    conn->http_request.


M	src/doveadm/client-connection-http.c

2017-10-07 17:28:04 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (1a7d36f)

    doveadm-server: http: Removed http_request field from struct
    client_connection_http.

    Not useful to put it there.

M	src/doveadm/client-connection-http.c

2017-10-07 17:16:22 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (2045a5d)

    doveadm-server: http: Renamed conn->http_client to conn->http_conn.


M	src/doveadm/client-connection-http.c

2017-10-07 13:39:44 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (80a225c)

    doveadm-server: Restructured client-connection code so that TCP and HTTP
    connection types are properly separated.


M	src/doveadm/client-connection-http.c
M	src/doveadm/client-connection-private.h
M	src/doveadm/client-connection-tcp.c
M	src/doveadm/client-connection.c
M	src/doveadm/client-connection.h
M	src/doveadm/main.c

2017-10-07 17:07:58 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (ee063d6)

    doveadm-server: http: Moved client_connection_destroy_http().


M	src/doveadm/client-connection-http.c

2017-10-07 17:07:10 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e60c3e1)

    doveadm-server: tcp: Renamed client_connection_create() to
    client_connection_tcp_create().


M	src/doveadm/client-connection-tcp.c
M	src/doveadm/client-connection.h
M	src/doveadm/main.c

2017-10-07 17:06:09 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (f300f92)

    doveadm-server: http: Renamed client_connection_create_http() to
    client_connection_http_create().


M	src/doveadm/client-connection-http.c
M	src/doveadm/client-connection.h
M	src/doveadm/main.c

2017-10-07 16:30:31 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (4284e49)

    doveadm-server: http: Renamed conn->client to conn->conn.


M	src/doveadm/client-connection-http.c

2017-10-07 16:57:45 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (cd13c18)

    doveadm-server: tcp: Moved client_connection_destroy().


M	src/doveadm/client-connection-tcp.c

2017-10-07 16:55:01 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (57e356f)

    doveadm-server: tcp: Cleaned up doveadm_server_log_handler().


M	src/doveadm/client-connection-tcp.c

2017-10-07 16:48:14 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (4e08875)

    doveadm-server: Moved common client code back from client-connection-tcp.c
    to client-connection.c.


M	src/doveadm/Makefile.am
M	src/doveadm/client-connection-private.h
M	src/doveadm/client-connection-tcp.c
A	src/doveadm/client-connection.c

2017-10-07 15:40:45 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (c4292f9)

    doveadm-server: Renamed client-connection.c to client-connection-tcp.c.

    Preparation for subsequent commits.

M	src/doveadm/Makefile.am
A	src/doveadm/client-connection-tcp.c
D	src/doveadm/client-connection.c

2017-10-08 12:19:09 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e79e121)

    doveadm-server: http: Changed index variables from size_t to unsigned int
    where size_t makes no sense.


M	src/doveadm/client-connection-http.c

2017-10-18 19:01:10 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (9cc49c8)

    doveadm-server: http: Changed initialization of parameters in
    doveadm_http_handle_json_v1().

    Use normal assignment, rather than memcpy(). This way, type checking is not
    skipped unnecessarily.

M	src/doveadm/client-connection-http.c

2017-10-08 12:04:11 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (5381c92)

    doveadm-server: http: Use `ret' rather than `rc' as name for the local
    variable used for return values.


M	src/doveadm/client-connection-http.c

2017-10-07 12:36:34 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (df45032)

    doveadm-server: http: Cleaned up code formatting.


M	src/doveadm/client-connection-http.c

2017-10-09 14:38:52 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (a602aa8)

    doveadm-server: http: Created local variable for
    conn->cmd_param->value.v_istream as an abbreviation.

    This is a preparation for subsequent commits.

M	src/doveadm/client-connection-http.c

2017-10-09 13:57:27 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (4b2c686)

    doveadm-server: http: Created local variable for conn->client.output as an
    abbreviation.

    This is a preparation for subsequent commits.

M	src/doveadm/client-connection-http.c

2017-10-09 14:35:30 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (f17ff90)

    doveadm-server: http: Created local variable for conn->http_request as an
    abbreviation.

    This is a preparation for subsequent commits.

M	src/doveadm/client-connection-http.c

2017-10-09 14:13:37 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (28d5207)

    doveadm-server: http: Created local variable for conn->http_response as an
    abbreviation.

    This also makes sure it is named consistently everywhere. This is a
    preparation for subsequent commits.

M	src/doveadm/client-connection-http.c

2017-10-09 13:43:42 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (bf5c099)

    doveadm-server: http: Created local variable for conn->http_server_request
    as an abbreviation.

    This also makes sure it is named consistently everywhere. This is a
    preparation for subsequent commits.

M	src/doveadm/client-connection-http.c

2017-10-07 12:48:38 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (db4c6cc)

    doveadm-server: http: Moved loop body in
    doveadm_http_server_read_request_v1() to separate function.


M	src/doveadm/client-connection-http.c

2017-10-10 15:58:33 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (e16f28d)

    doveadm: mail: Removed redundant cur_username field from struct
    doveadm_mail_cmd_context.


M	src/doveadm/client-connection.c
M	src/doveadm/doveadm-dsync.c
M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm-mail.h

2017-10-10 19:12:52 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (2ff59d5)

    doveadm: mail: Removed redundant cur_client_ip field from struct
    doveadm_mail_cmd_context.


M	src/doveadm/doveadm-dsync.c
M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm-mail.h

2017-10-10 19:04:20 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (a435fb2)

    doveadm: mail: Removed struct doveadm_cmd_context function parameters that
    are now useless.

    It can be accessed from struct doveadm_mail_cmd_context.

M	src/doveadm/client-connection.c
M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm-mail.h

2017-10-07 21:30:27 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (1b58508)

    doveadm: Changed command contexts to contain the input, output, and
    connection type values directly.

    Before, it used a direct pointer to the connection. It used also flags to
    indicate the connection type, which is now consolidated in the connection
    type enum.

M	src/doveadm/client-connection-http.c
M	src/doveadm/client-connection-private.h
M	src/doveadm/client-connection.c
M	src/doveadm/client-connection.h
M	src/doveadm/doveadm-cmd.h
M	src/doveadm/doveadm-dsync.c
M	src/doveadm/doveadm-kick.c
M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm-mail.h
M	src/doveadm/doveadm.c
M	src/plugins/mail-crypt/doveadm-mail-crypt.c

2017-10-17 16:16:22 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (001b7ca)

    lib-http: server: Implemented http_server_request_fail_text(), which allows
    creating failure responses with verbose payload.


M	src/lib-http/http-server-request.c
M	src/lib-http/http-server.h

2017-10-17 16:04:38 +0200 Stephan Bosch <stephan.bosch@dovecot.fi> (a5886ae)

    lib-http: server: Allow determining at any time whether the connection will
    be closed after handling a request.

    Previously, this was only possible during response submission, which
